#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include <time.h>

#include <string.h>
#include <stdlib.h>


#include <netinet/tcp.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <netinet/tcp.h>

#include <sys/socket.h>
#include <sys/types.h>

#include <sys/time.h>
#include <netinet/in.h>
#include <errno.h>

#include <jni.h>

const unsigned short servicetPort = 702;
#define profileDir "/usr/novell/sys/mySQUID"
#define  logfname profileDir"/myauth.log"
time_t allowTime = 31;

void print_to_file (FILE *fp, const char *format, va_list args);
void saveLog(bool ntime, const char *format,...);
int acceptUser(char *getSRC, char *userStr);


int main ()
{
  int ch;
  char *cp, *address;
  char userName[256], error[256];
  
  char line[4096];
  saveLog (true, "start external acl programm\n");
  //while (1)
  //{
  while (fgets (line, sizeof (line), stdin)) 
  {
    if ((cp = strchr (line, '\n')) != NULL) 
	{
      *cp = '\0';
    }
    if ((cp = strtok (line, " \t")) != NULL) 
	{
      address = cp;

	  saveLog(true, "userIP - %s\n", address);
	  if (acceptUser(address, userName) > 0)
	  {
		  printf ("OK user=%s\n", userName);
		  saveLog(true, "allow - %s\n", userName);
	  }
	  else 
		{
			printf ("ERR error=access_denied\n");
			saveLog(true, "no access - %s\n", userName);
		}
    } 
		else 
			{
				//fprintf (stderr, "helper: unable to read tokens\n");
				printf ("ERR error=tokens_error\n");
				//continue;
			}
	
     fflush(stdout);
  }
  //}
  saveLog(true, "exit external acl programm\n");

  return 0;
}



void print_to_file (FILE *fp, const char *format, va_list args)
{
	vfprintf(fp, format, args);
}

//void setLog(unsigned char ntime, const char *format,...)
void saveLog(bool ntime, const char *format,...)
{
	va_list marker;
    va_start(marker, format);

	FILE *fp;
	fp = fopen(logfname,"a+");
	if (fp != NULL)
	{
		//if (needtime)
		if (ntime)
		{
			time_t workTime;
			time (&workTime);
			struct tm *today;
			today =  localtime( &workTime );
			fprintf (fp, "%d.%d.%d-%d:%d:%d >", 
					today->tm_mday, today->tm_mon+1, today->tm_year-100 , today->tm_hour, today->tm_min, today->tm_sec);
		}
			
		static char f[4096];   
		snprintf (f, 4095, "%s", format);

		if (strlen(f) > 0)
			print_to_file (fp, f, marker);
		fclose(fp);
	}
	va_end( marker );
}

//int acceptUser(char *getSRC, char *regProc, char *userStr)
int acceptUser(char *getSRC, char *userStr)
{

	int permit;

	char iobuf [1024];
	char seps [] = " ;	\0\n";
	int s, rc;
	struct sockaddr_in clientsockaddr;

	char *firsHeader = "User description ";
	char *firstStr, *fullUserName, *strUserLimit, *strUserTraffic, *strUnlimited, *strTime;
	
	permit = -1;
	fullUserName = "?";
	s = socket(AF_INET, SOCK_STREAM, 0);
	if (s > 0)
	{
		clientsockaddr.sin_addr.s_addr =  inet_addr("127.0.0.1");
		//clientsockaddr.sin_addr.s_addr =  inet_addr(regProc);
		clientsockaddr.sin_family = AF_INET;
		clientsockaddr.sin_port   = htons(servicetPort);
			rc = connect(s, (struct sockaddr*)&clientsockaddr, sizeof(struct sockaddr_in));
		if (rc == 0)
		{
			//sprintf (iobuf, "Who is user %s %s %s<EOF>", client_ip, hostIP, myHostName);
			sprintf (iobuf, "Who is user %s;<EOF>", getSRC);
			rc = send(s, iobuf, strlen(iobuf)+1, 0);//send
			if (rc > 0)
			{
				if ( (rc = recv(s, iobuf, sizeof (iobuf), 0)) > 0)
				{
						firstStr = strstr(iobuf, firsHeader);
					if (firstStr != NULL)
					{
						firstStr += strlen (firsHeader);
						if ((fullUserName = strtok (firstStr, seps)) != NULL)
						{
							if ((strUserLimit = strtok (NULL, seps)) != NULL)
							{
								if ((strUserTraffic = strtok (NULL, seps)) != NULL)
								{
									if ((strUnlimited = strtok (NULL, seps)) != NULL)
									{
										if ((strTime = strtok (NULL, seps)) != NULL)
										{
											int myLimit = 0, myTraffic = 0, myUnlimited = 0;
											time_t myTime, ltime;
											time (&ltime);
												myLimit = atoi(strUserLimit);
											myTraffic = atoi(strUserTraffic);
											myUnlimited = atoi(strUnlimited);
											myTime = atol(strTime);
												snprintf (userStr, 256, fullUserName);
											if (myUnlimited == -1)
											{
												permit = 2;
											}
											else
											{
												if ((myLimit + myUnlimited - myTraffic) > 1024) 
												{
													if ((ltime - myTime) < allowTime) permit = 1;
														else permit = -1;
												}
													else permit = -2;
											}
										}
									}
								}
							}
						}
					}else 
						{
							//setLog(iobuf, 0); setLog("   <-type reciving string error", 1);
							saveLog (true, "%s  <-type reciving string error\n", iobuf);
						}
				}
			}
		}else 
			//setLog("connect error ->", 1);
			saveLog(true, "connect error\n");
		close(s);
	}else
		//setLog("create socket error", 1);
		saveLog(true, "create socket error\n");
	return permit;
}
