#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include <time.h>

#include <string.h>
#include <stdlib.h>


#include <netinet/tcp.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <netinet/tcp.h>

#include <sys/socket.h>
#include <sys/types.h>

#include <sys/time.h>
#include <netinet/in.h>
#include <errno.h>

#include <jni.h>

//const unsigned short servicetPort = 710;
//#define profileDir "/usr/novell/sys/mySQUID"
//#define  logfname profileDir"/myauth.log"
//char *daemon_addr = "192.168.1.38";

unsigned short servicetPort;
//char logDir [1024];
char logfname [1024];
char daemon_addr [18];

time_t allowTime = 31;

void print_to_file (FILE *fp, const char *format, va_list args);
void saveLog(bool ntime, const char *format,...);
int acceptUser(char *getSRC, char *userStr);


int main ()
{
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	char *infStr;
	char seps [] = " ;\0\n";	
	char infFileName[1024];
	//snprintf (infFileName, 1024, "/usr/novell/sys/mySQUID/myauth/myauth.inf");
	snprintf (infFileName, 1024, "/usr/novell/sys/mySQUID/full.inf");


	char *iFN;
	/*if (argc > 1)
	{
		if ((infStr = strstr(argv[1], "--inf=")) != NULL )
		{
			infStr += strlen("--inf=");
			if ((iFN = strtok(infStr, seps)) != NULL)
			{
				snprintf (infFileName, 1024, "%s", iFN);
			}
			
		}
	}*/

	FILE *infoFile;
	infoFile = fopen (infFileName, "r");
	char rBuf [4096];
	if (infoFile != NULL)
	{
		int countii = 0;
		int numberVariable = 3;
		//printf ("open inf file\n");
		while (fgets(rBuf, 4096, infoFile) != NULL)
		{
			int ii;
			/*char *configMass [] = {"daemonServer",
									"daemonPort",
									"logDir"
									};*/
			char *configMass [] = {"daemonServer",
									"authPort",
									"logDir"
									};

			char *confString, *configMean;//, *ldapServerIP;

			for (ii = 0; ii < numberVariable; ++ii)
			{
				if ((confString = strstr(rBuf, configMass[ii])) != NULL)
				{
					countii ++;
					confString += strlen (configMass[ii]);
					if ((configMean = strtok(confString, seps)) != NULL)
					{
						switch (ii)
						{
							case 0: snprintf (daemon_addr, 18, "%s", configMean);
								break;
							case 1: servicetPort = atoi (configMean);
								break;
							case 2: snprintf (logfname, 1024, "%s/myauth.log", configMean);
								break;
						}
					}
				}
			}

		}
		fclose (infoFile);
		if (countii < numberVariable)
		{
			saveLog (1, "Not full inf file\n");
			exit (0);
		}
	}
	/*else
		{
			printf ("Cannot open myauth inf file !!!\n");
			exit (0);
		}*/

	//snprintf(logfname, 1024, "%s/myauth.log", logDir);
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


  int ch;
  char *cp, *address;
  char userName[256], error[256];
  
  char line[4096];
  saveLog (true, "start external acl programm\n");
  //while (1)
  //{
  while (fgets (line, sizeof (line), stdin)) 
  {
    if ((cp = strchr (line, '\n')) != NULL) 
	{
      *cp = '\0';
    }
    if ((cp = strtok (line, " \t")) != NULL) 
	{
      address = cp;

	  strncpy(userName, "         ", 256);
	  saveLog(true, "userIP - %s\n", address);
	  if (acceptUser(address, userName) > 0)
	  {
		  printf ("OK user=%s\n", userName);
		  saveLog(true, "allow - %s\n", userName);
	  }
	  else 
		{
			printf ("ERR error=access_denied\n");
			saveLog(true, "no access - %s\n", userName);
		}
    } 
		else 
			{
				//fprintf (stderr, "helper: unable to read tokens\n");
				printf ("ERR error=tokens_error\n");
				//continue;
			}
	
     fflush(stdout);
  }
  //}
  saveLog(true, "exit external acl programm\n");

  return 0;
}



void print_to_file (FILE *fp, const char *format, va_list args)
{
	vfprintf(fp, format, args);
}

//void setLog(unsigned char ntime, const char *format,...)
void saveLog(bool ntime, const char *format,...)
{
	va_list marker;
    va_start(marker, format);

	FILE *fp;
	fp = fopen(logfname,"a+");
	if (fp != NULL)
	{
		//if (needtime)
		if (ntime)
		{
			time_t workTime;
			time (&workTime);
			struct tm *today;
			today =  localtime( &workTime );
			fprintf (fp, "%d.%d.%d-%d:%d:%d >", 
					today->tm_mday, today->tm_mon+1, today->tm_year-100 , today->tm_hour, today->tm_min, today->tm_sec);
		}
			
		static char f[4096];   
		snprintf (f, 4095, "%s", format);

		if (strlen(f) > 0)
			print_to_file (fp, f, marker);
		fclose(fp);
	}
	va_end( marker );
}

//int acceptUser(char *getSRC, char *regProc, char *userStr)
int acceptUser(char *getSRC, char *userStr)
{

	int permit;

	char iobuf [1024];
	char seps [] = " ;	\0\n";
	int s, rc;
	struct sockaddr_in clientsockaddr;

	char *firsHeader = "User description ";
	//char *firstStr, *fullUserName, *strUserLimit, *strUserTraffic, *strUnlimited, *strTime;
	char *firstStr, *fullUserName, *allowUser;
	
	permit = -1;
	fullUserName = "?";
	s = socket(AF_INET, SOCK_STREAM, 0);
	if (s > 0)
	{
			int on = 1;
			if (setsockopt(s, SOL_SOCKET, SO_REUSEADDR, (char *) &on, sizeof(on)) < 0)
			saveLog (true, "SetReuseAddr error\n");
			struct linger L;
			L.l_onoff = 0;		/* off */
			L.l_linger = 0;
			if (setsockopt(s, SOL_SOCKET, SO_LINGER, (char *) &L, sizeof(L)) < 0)
			saveLog (true, "SetNoLinger error\n");

		clientsockaddr.sin_addr.s_addr =  inet_addr(daemon_addr);
		//clientsockaddr.sin_addr.s_addr =  inet_addr(regProc);
		clientsockaddr.sin_family = AF_INET;
		clientsockaddr.sin_port   = htons(servicetPort);
			rc = connect(s, (struct sockaddr*)&clientsockaddr, sizeof(struct sockaddr_in));
		if (rc == 0)
		{
			//sprintf (iobuf, "Who is user %s %s %s<EOF>", client_ip, hostIP, myHostName);
			sprintf (iobuf, "Who is user %s;<EOF>", getSRC);
			rc = send(s, iobuf, strlen(iobuf)+1, 0);//send
			if (rc > 0)
			{
				if ( (rc = recv(s, iobuf, sizeof (iobuf), 0)) > 0)
				{
					//saveLog (true, "string - %s\n", iobuf);
						firstStr = strstr(iobuf, firsHeader);
					if (firstStr != NULL)
					{
						firstStr += strlen (firsHeader);
						if ((fullUserName = strtok (firstStr, seps)) != NULL)
						{
							if ((allowUser = strtok (NULL, seps)) != NULL)
							{
								permit = -1;
								if (strstr(allowUser, "allow") != NULL)
								{
									permit = 1;
								}
								if (strstr(allowUser, "safelimit") != NULL)
								{
									permit = 2;
								}
								snprintf (userStr, 256, fullUserName);
							}
							/*
							if ((strUserLimit = strtok (NULL, seps)) != NULL)
							{
								if ((strUserTraffic = strtok (NULL, seps)) != NULL)
								{
									if ((strUnlimited = strtok (NULL, seps)) != NULL)
									{
										if ((strTime = strtok (NULL, seps)) != NULL)
										{
											int myLimit = 0, myTraffic = 0, myUnlimited = 0;
											time_t myTime, ltime;
											time (&ltime);
												myLimit = atoi(strUserLimit);
											myTraffic = atoi(strUserTraffic);
											myUnlimited = atoi(strUnlimited);
											myTime = atol(strTime);
												snprintf (userStr, 256, fullUserName);
											if (myUnlimited == -1)
											{
												permit = 2;
											}
											else
											{
												if ((myLimit + myUnlimited - myTraffic) > 1024) 
												{
													if ((ltime - myTime) < allowTime) permit = 1;
														else permit = -1;
												}
													else permit = -2;
											}
										}
									}
								}
							}
							*/
						}
					}else 
						{
							//setLog(iobuf, 0); setLog("   <-type reciving string error", 1);
							saveLog (true, "%s  <-type reciving string error\n", iobuf);
						}
				}
			}
		}else 
			//setLog("connect error ->", 1);
			saveLog(true, "connect error\n");
		close(s);
	}else
		//setLog("create socket error", 1);
		saveLog(true, "create socket error\n");
	return permit;
}
