#ifndef _SQUID2SQL_H
#define _SQUID2SQL_H
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
//#include <vector>
//#include <string>
//#include <iostream>
//#include <fstream>

#include "ldap2sql.h"

#include <memory.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <linux/netfilter.h>
#include <linux/netlink.h>
#include <net/if.h>

#include <linux/types.h>
#include <linux/socket.h>
#include <pthread.h>
#include <signal.h>

#include <fcntl.h>
#include <errno.h>
#include <jni.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <pwd.h>
#include <grp.h>

void print_to_file (FILE *fp, const char *format, va_list args);
void saveLog(bool ntime, const char *format,...);
void logPipe();
void logPipeChild();
void stopLogPipre();
void stopLogPipreChild();

bool readUserInfo(MYSQL &loc_mysql, userInfo &myUserInfo);
bool saveUserInfo(MYSQL &loc_mysql, userInfo &myUserInfo);
void subGroups(limitArray &routUser, int &groupTraffic, int &groupCacheTraffic, int &fromUser, vector <attrName> &groupInfo);

void saveBackUpLog(char *Str);
void saveUnKnownLog(char *Str);
void saveLog(bool ntime, const char *format,...);

#endif /*_SQUID2SQL_H*/
