#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <syslog.h>
#include <signal.h>

#include <string.h>
#include <stdlib.h>
#include <iomanip>

#include <sys/un.h>
#include <netdb.h>
#include <unistd.h>
#include <stdlib.h>


#include <linux/netfilter.h>

#include <linux/netlink.h>
#include <net/if.h>
#include <unistd.h>


#include <netinet/tcp.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <arpa/inet.h>
#include <net/if_arp.h>
#include <netinet/in_systm.h>
#include <netinet/tcp.h>
//#include <netinet/in.h>
#include <sys/resource.h>

#include <jni.h>
//#include <ansidcl.h>
//#include <linux/sched.h>

#include "serv_daemon.h"
#include "mylibipq.h"
#include "myldap.h"

//using std::string;
//using std::vector;
//using std::iterator;


#define BUFFER_SIZE             (8*1024)
const int clLen = 1024;
//const int maxCL = 255;

#define profileDir "/usr/novell/sys/mySQUID/userbase"
#define infDir "/usr/novell/sys/mySQUID/daemon"
#define log_fname "/usr/novell/sys/mySQUID/mydaemonlog"

unsigned short registerPort = 712;
unsigned short servicePort = 702;
//char *serverIP = "192.168.1.37";
unsigned short serverPort = 8080;
time_t allowTime = 31;

//pthread_mutex_t request_mutex = PTHREAD_MUTEX_INITIALIZER;


bool myCrypt(char *strCript);
//void saveLog(char *mylog, bool ntime);
//void saveLog(bool ntime, const char *format, va_list args)
void 
print_to_file (FILE *fp, const char *format, va_list args)
{
	vfprintf(fp, format, args);
}

void
saveLog(bool ntime, const char *format,...)
{
	//const char *format = NULL;
	//LOCAL_ARRAY(char, f, BUFSIZ);

	//bool needtime;
	va_list marker;
    va_start(marker, format);
	//needtime = va_arg(marker, bool);
	//format = va_arg(marker, const char *);

	FILE *fp;
	fp = fopen(log_fname,"a+");
	if (fp != NULL)
	{
		//if (needtime)
		if (ntime)
		{
			time_t workTime;
			time (&workTime);
			struct tm *today;
			today =  localtime( &workTime );
			fprintf (fp, "%d.%d.%d-%d:%d:%d >", 
					today->tm_mday, today->tm_mon+1, today->tm_year-100 , today->tm_hour, today->tm_min, today->tm_sec);
		}
			
		//#define LOCAL_ARRAY(type,name,size) static type name[size]
		//LOCAL_ARRAY(char, f, 4096);
		static char f[4096];   
		snprintf (f, 4095, "%s", format);

		if (strlen(f) > 0)
			print_to_file (fp, f, marker);
			//fprintf (fp, format, marker);
				//va_end( marker2 );
		fclose(fp);
	}
	va_end( marker );
}



tcpdaemon *pointToDaemon;

TCmdLine::TCmdLine()
{ 
	pipe_fp = NULL; asCount = 0;
}

TCmdLine::~TCmdLine() 
{ 
	if (pipe_fp != NULL) 
		if (pclose(pipe_fp) == -1) 
		{
			//saveLog ("cmd pclose error in ~TCmdLine\n", true);
			saveLog (true, "cmd pclose error in ~TCmdLine\n");
			switch (errno)
			{
				case ECHILD: 
					//saveLog ("No specified process exists, procHandle is invalid (cmd pclose error in ~TCmdLine)\n", false); 
					saveLog (false, "No specified process exists, procHandle is invalid (cmd pclose error in ~TCmdLine)\n"); 
					break;
				case EINVAL: 
					//saveLog ("action is invalid (cmd pclose error in ~TCmdLine)\n", false); 
					saveLog (false, "action is invalid (cmd pclose error in ~TCmdLine)\n"); 
					break;
				default: 
					//saveLog ("(default) cmd pclose error in ~TCmdLine\n", false);
					saveLog (false, "(default) cmd pclose error in ~TCmdLine\n");
			}
		}
		//cmdFree();
}

bool TCmdLine::cmdFree()
{
	int retVal = 0;
	//char eLine[clLen] = " ";
	if (pipe_fp != NULL) 
	{
		//while (iptablesAnswer(eLine));
		retVal = pclose(pipe_fp); 
		//if (strstr (eLine, "Error pclose") != NULL) return false;
	}
	pipe_fp = NULL;
	if (retVal == -1) 
	{
		//saveLog ("cmd free error\n", false); 
		saveLog (false, "cmd free error\n"); 
		return false;
		switch (errno)
		{
			case ECHILD: 
				//saveLog ("No specified process exists, procHandle is invalid (cmd pclose error in cmdFree)\n", false); 
				saveLog (false, "No specified process exists, procHandle is invalid (cmd pclose error in cmdFree)\n"); 
				break;
			case EINVAL: 
				//saveLog ("action is invalid (cmd pclose error in cmdFree)\n", false);
				saveLog (false, "action is invalid (cmd pclose error in cmdFree)\n");
				break;
			default: 
				//saveLog ("(default) cmd pclose error in cmdFree\n", false);
				saveLog (false, "(default) cmd pclose error in cmdFree\n");
		}
	}
	else return true;
}
bool TCmdLine::iptablesCmd(char *cmdLine)
{
	asCount = 0;
	if (pipe_fp != NULL) 
	{
		if (pclose(pipe_fp) == -1) 
		{
			//saveLog ("cmd pclose error in iptablesCmd\n", true); 
			saveLog (true, "cmd pclose error in iptablesCmd\n"); 
			switch (errno)
			{
				case ECHILD: 
					//saveLog ("No specified process exists, procHandle is invalid (cmd pclose error in iptablesCmd)\n", false);
					saveLog (false, "No specified process exists, procHandle is invalid (cmd pclose error in iptablesCmd)\n");
					break;
				case EINVAL: 
					//saveLog ("action is invalid (cmd pclose error in iptablesCmd)\n", false);
					saveLog (false, "action is invalid (cmd pclose error in iptablesCmd)\n");
					break;
				default: 
					//saveLog ("(default) cmd pclose error in iptablesCmd\n", false);
					saveLog (false, "(default) cmd pclose error in iptablesCmd\n");
			}
			return false;
		}
	}
	if ( (pipe_fp = popen(cmdLine, "r")) == NULL )
	{
		//saveLog ("popen error\n", true);
		saveLog (true, "popen error\n");
		switch (errno)
		{
			case EMFILE: 
				//saveLog ("no more file descriptors available (cmd popen error in iptablesCmd)\n", false);
				saveLog (false, "no more file descriptors available (cmd popen error in iptablesCmd)\n");
				break;
			case ENFILE: 
				//saveLog ("system file table overflow (cmd popen error in iptablesCmd)\n", false);
				saveLog (false, "system file table overflow (cmd popen error in iptablesCmd)\n");
				break;
			default: 
				//saveLog ("(default) cmd popen error in iptablesCmd\n", false);
				saveLog (true, "(default) cmd popen error in iptablesCmd\n");
		}
		return false;
	}
	return true;
}
bool TCmdLine::iptablesAnswer( char* answerString)
{
	bool endStream = false;
	if ( !feof(pipe_fp))
	{
		if ( fgets( answerString, clLen, pipe_fp ) != NULL) asCount ++;
		else endStream = true;
	}
	else 
		{
			endStream = true;
			//saveLog ("find feof", true);
			saveLog (true, "find feof");
		}
	if (endStream)
	{
		pclose(pipe_fp);
		/*if (pclose(pipe_fp) == -1) 
		{
			switch (errno)
			{
				case ECHILD: saveLog ("No specified process exists, procHandle is invalid (cmd pclose error in iptablesAnswer)\n", false); break;
				case EINVAL: saveLog ("action is invalid (cmd pclose error in iptablesAnswer)\n", false); break;
				default: saveLog ("(default) cmd pclose error in iptablesAnswer\n", false);
			}
			saveLog ("cmd pclose error in iptablesAnswer\n", false);
			sprintf(answerString, "Error pclose");
		}*/
		pipe_fp = NULL;
		asCount = 0;
		return false;
	}
	return true;
}
bool TCmdLine::iptablesSaveAnswer(char *cmdLine)
{
	char aLine [clLen];
	if (!iptablesCmd(cmdLine)) return false;
	//saveLog(">", true);
	saveLog(true, "iptables>\n");
	snprintf (aLine, clLen, " ");
	while (iptablesAnswer(aLine)) 
	{
		//saveLog(aLine, false);
		if (strlen (aLine) > 0)
			saveLog(false, "iptables> %s \n", aLine);
		//snprintf (aLine, clLen, "");
	}
	return true;
}
//----------------------------------------------------------------------------------------------
void tcpdaemon::die(struct ipq_handle *h)
{
   saveLog(true, "ipq error");
   ipq_destroy_handle(h);
   exit(1);
}
void* tcpdaemon::packetTraffic(void* data)
{
	tcpdaemon *tcpD = (tcpdaemon *)(data);
	//const int BUFSIZE = 2048;
	const int BUFSIZE = MAX_PKT_SIZE;

	int status;
    unsigned char buf[BUFSIZE];
    struct ipq_handle *h;
        
    h = ipq_create_handle(0, PF_INET);
    if (!h)
	{
        //saveLog ("ipq create handle error\n", true);  
        saveLog (true, "ipq create handle error\n");  
		die(h);
	}
               
//    status = ipq_set_mode(h, IPQ_COPY_PACKET, BUFSIZE);
//    status=ipq_set_mode(h, IPQ_COPY_PACKET, sizeof(struct ip) + sizeof(struct tcphdr));
    status=ipq_set_mode(h, IPQ_COPY_PACKET, MAX_PKT_SIZE);
    if (status < 0)
	{
        //saveLog ("ipq set mod error\n", true);  
        saveLog (true, "ipq set mod error\n");  
		die(h);
	}
                
    do
	{
       //status = ipq_read(h, buf, BUFSIZE, 0);
	   status=ipq_read(h, buf, MAX_PKT_SIZE, 1000);
	   //status=ipq_read(h, buf, MAX_PKT_SIZE, 0);
       if (status < 0)
	   {
		   //saveLog ("error ipq read\n", false);
		   saveLog (false, "error ipq read\n");
//		   die(h);
		   continue;
	   }
       if (status == 0)
		   continue;
                        
       switch (ipq_message_type(buf)) 
	   {
           case NLMSG_ERROR:
			   //char myErr[256];
			   //sprintf(myErr, "Received error message %d\n", ipq_get_msgerr(buf));
			   //saveLog (myErr, true);
			   saveLog (true, "Received error message %d\n", ipq_get_msgerr(buf) );

			   continue;
			   break;
                                
           case IPQM_PACKET:
			   break;
                       
           default:
//               saveLog ("Unknown message type!\n", true);
	   		   continue;
               break;

	   }

	   ipq_packet_msg_t *m;
	   m = ipq_get_packet(buf);
	   struct ip *p_ip = (struct ip *) m->payload;
	   //char myStr[1024];
	   struct in_addr NsrcIPaddr, NdstIPaddr, userPaketIP;
	   //int srcPort, dstPort;

	   NsrcIPaddr.s_addr = p_ip->ip_src.s_addr;
	   NdstIPaddr.s_addr = p_ip->ip_dst.s_addr;
	   	
	   bool serverSide, ip_protocol;
	   if (tcpD->daemonServIP.s_addr == NsrcIPaddr.s_addr)
	   {
		   userPaketIP.s_addr = NdstIPaddr.s_addr;
		   serverSide = true;
	   }
	   else
		{
		   userPaketIP.s_addr = NsrcIPaddr.s_addr;
		   serverSide = false;
		}
		if ( p_ip->ip_p == IPPROTO_TCP)
		{
			ip_protocol = true;
		}
			else
				{
					ip_protocol = false;
				}
	   /*if(p_ip->ip_p == IPPROTO_TCP || p_ip->ip_p == IPPROTO_UDP) 
	   {
			struct tcphdr *th = (struct tcphdr *)((u_char *)p_ip + p_ip->ip_hl*4);
			
			srcPort	= th->th_sport;
			dstPort	= th->th_dport;
	   } 
	   else {
				srcPort	= 0;
				dstPort	= 0;
			}*/

	   //snprintf (myStr, 255, "Get packet size %d from %s to %s length %d\n",  m->data_len, srcIP, dstIP, p_ip->ip_len);
	   //saveLog (myStr, false);

//-----------------------------------------------------------------------------------------
//save traffic
	   
	   int dataLen = m->data_len;
		time_t realTime, DROPtime, RTime;

		time (&realTime);
		DROPtime = 0;
		bool findUser = false;
	   if (dataLen > 0)
		{
			int baseTraffic = 0, baseLimit = 0, baseCache = 0, baseUnderLimit = 0;
			time_t registerTime;
			char unlimitedTraffic = 0;
			char localUserName[256];
			int i;//, j;

//mutex enable
//pthread_mutex_lock(&request_mutex);
			for(i = 1; i < tcpD->share.size(); ++i)
			{
				if ( tcpD->share[i].userIP.s_addr == userPaketIP.s_addr)
				{
					RTime = tcpD->share[i].rTime;
					//DROPtime = tcpD->share[i].dropTime;
				//if ((realTime - tcpD->share[i].rTime) < allowTime)
				if (((realTime - RTime) < allowTime) && (tcpD->share[i].userID > 0))
				{
					findUser = true;
						if (serverSide)
						{
					tcpD->collected[tcpD->share[i].userID].userTraffic += dataLen;
					baseTraffic = tcpD->collected[tcpD->share[i].userID].userTraffic -
							tcpD->collected[tcpD->share[i].userID].userCacheTraffic;
					baseLimit = tcpD->collected[tcpD->share[i].userID].userLimit;
					baseUnderLimit = tcpD->collected[tcpD->share[i].userID].underLimit;

					if ((tcpD->collected[tcpD->share[i].userID].userTraffic - 10240) > 
									tcpD->collected[tcpD->share[i].userID].oldUserTraffic)
					{
						tcpD->collected[tcpD->share[i].userID].oldUserTraffic = tcpD->collected[tcpD->share[i].userID].userTraffic;
						strcpy (localUserName, tcpD->collected[tcpD->share[i].userID].userName);
						unsigned int real_month, last_month, real_year, last_year;

						struct tm *today, *last;
						today =  localtime( &realTime );
						real_month = today->tm_mon;
						real_year = today->tm_year;
							registerTime = tcpD->collected[tcpD->share[i].userID].lastTime;
							last =  localtime( &registerTime );
						last_month = last->tm_mon;
						last_year = last->tm_year;
						if ((last_month != real_month)	|| (last_year != real_year))
						{
							tcpD->collected[tcpD->share[i].userID].userTraffic = 0;
							tcpD->collected[tcpD->share[i].userID].userCacheTraffic = 0;
							tcpD->collected[tcpD->share[i].userID].oldUserTraffic = 0;
						}
						tcpD->saveUserTrafficToDisk(tcpD->collected[tcpD->share[i].userID]);
					}

					if (baseUnderLimit != -1)
					{
						//kill user connection if limit is allowed
						if ((baseLimit - baseTraffic + baseUnderLimit) < 1024)
						{
							if (!tcpD->share[i].detachConnection)
							{
								char dstIPstr[18];
   								snprintf (dstIPstr, 17, "%s", inet_ntoa (userPaketIP) );
								/*saveLog (true, "kill user %s) connection in packetTraffic\n", dstIPstr);
								if (!tcpD->oldKillUserConection(userPaketIP, dstIPstr, 30) )  
									saveLog(true, "KillUserConection Error in packetTraffic\n");*/
								//saveLog (true, "drop user %s (%s) connection in packetTraffic\n", 
								//	dstIPstr, tcpD->collected[tcpD->share[i].userID].userName);
								tcpD->share[i].dropTime = realTime + 30;
								tcpD->share[i].detachConnection = true;
							}
						}	
						else 
						{
							if ((baseLimit - baseTraffic + baseUnderLimit) > 10240)
								tcpD->share[i].detachConnection = false;
						}
					}
						}
					break;
				}
					DROPtime = tcpD->share[i].dropTime;
				}
			}

//pthread_mutex_unlock(&request_mutex);		
//mutex disable



/*//kill unknown user connection
			if (!findUser)
				if (dstIPaddr.s_addr != inet_addr(tcpD->myDaemonServer))
			{
				char dstIPstr[18];
				snprintf (dstIPstr, 17, "%s", inet_ntoa (dstIPaddr) );
				//saveLog ( "kill unknown user connection in packetTraffic\n", true);
				saveLog (true, "kill unknown user connection (%s) in packetTraffic\n", dstIPstr);
				if (!tcpD->KillUserConection(dstIPaddr, dstIPstr, 10) )  
					//saveLog("kill unknown KillUserConection Error in packetTraffic\n", false);
					saveLog(true, "kill unknown KillUserConection Error in packetTraffic\n");
			}*/
		}

		
		//-----------------------------------------------------------------------------------------
//restore old discoonect!!!
	   status = ipq_set_verdict(h, m->packet_id, NF_ACCEPT, 0, NULL);
/*	   if (DROPtime < realTime)
	   //if ((DROPtime < realTime) && findUser)
		   status = ipq_set_verdict(h, m->packet_id, NF_ACCEPT, 0, NULL);
	   else
		   status = ipq_set_verdict(h, m->packet_id, NF_DROP, 0, NULL);*/

	   if (status < 0) 
	   {
		   //saveLog ("ipq set verdict error", true);
		   saveLog (true, "ipq set verdict error");
		   //die(h);
	   }

	} while (tcpD->workDaemon);
        
	if (!tcpD->workDaemon) 
		//saveLog ("workDaemon false\n", true);
		saveLog (true, "workDaemon false\n");
	//saveLog ("Destroy ipq handle\n", true);
	saveLog (true, "Destroy ipq handle\n");
	ipq_destroy_handle(h);
	//saveLog ("exit traffic thread\n", true);
	saveLog (true, "exit traffic thread\n");
		//pthread_exit(NULL);
}
//-----------------------------------------------------------------------------------------
void tcpdaemon::saveTraffic()
{

	int j;
	for(j = 0; j < collected.size(); ++j)
	{
		//saveUserTrafficToDisk(collected[j].userName, collected[j].userTraffic);
		saveUserTrafficToDisk(collected[j]);
	}

}

//void tcpdaemon::saveUserTrafficToDisk(char *userName, int baseTraffic)
void tcpdaemon::saveUserTrafficToDisk(SUserData &sud)
{

	char readBuff[clLen], writeBuff[clLen], userLimitFileName[clLen];

	time_t realTime;
	time (&realTime);

	struct tm *today;
	today =  localtime( &realTime );

	//snprintf (userLimitFileName, clLen, "%s/__%s.mdu", profileDir, sud.userName);
		snprintf (userLimitFileName, 255, "%s/%2.2d.%2.2d__%s.mdu", profileDir, today->tm_mon + 1, today->tm_year - 100, sud.userName);

	/*char seps [] = " ;	\0\n";
	char *sUserName, *strLimit, *strAllTraffic, *strCacheTraffic, *underLimitStr, *strUserRegTime;
	int AllTraffic = 0, CacheTraffic = 0, Limit = 0, underLimit = 0;
	bool openULF = false;

	FILE *uLF;
	uLF = fopen(userLimitFileName, "r");
	if (uLF != NULL)
	{
		if (fgets(writeBuff, 256, uLF) != NULL)
		{
			sUserName = strtok (writeBuff, seps);
			strLimit = strtok (NULL, seps);
			strAllTraffic = strtok (NULL, seps);
			strCacheTraffic = strtok (NULL, seps);
			Limit = atol(strLimit);
			AllTraffic = atol(strAllTraffic);
			CacheTraffic = atol(strSessionTraffic);
			if (strlen(sUserName) > 2)
			{
				openULF = true;
			}
		}
		fclose (uLF);
	}else saveLog ("Cannot open user limit file to read !!!\n", true);*/

	FILE *uLF;
	//if (openULF)
	//{
		uLF = fopen(userLimitFileName, "w");
		if (uLF != NULL)
		{
			//fprintf (uLF, "%s;%d;%d;%d;", sud.userName, sud.userLimit, sud.userTraffic, SessionTraffic);
			fprintf (uLF, "%s;%d;%d;%d;%d;%d;", 
				sud.userName, sud.userLimit, sud.userTraffic, sud.userCacheTraffic, sud.underLimit, sud.lastTime);
			fclose (uLF);
		}
		 else 
			//saveLog ("Cannot open user limit file to write !!!\n", true);
			saveLog (true, "Cannot open user limit file to write !!!\n");
	//}

}
//-----------------------------------------------------------------------------------------
void tcpdaemon::restorIPtablesRule()
{
	TCmdLine myCL;
	McStr myAnswerStrings;
	vector <McStr> myCmdStr;
	char answerLine[4096],myRejectline[1024], DropLine[1024];//myInRejectline[1024], myOutRejectline[1024];
	char *startLine;

	//int i;//, myFact;
	//do{
    int countResult = 0;
		//"-p tcp -m tcp --sport %d -j REJECT --reject-with tcp-reset", serverPort
		//"-p tcp -m tcp --dport %d -j REJECT --reject-with tcp-reset", serverPort
	snprintf (myRejectline, 1024, "port %d -j REJECT --reject-with", serverPort);
	snprintf (DropLine, 1024, "port %d -j DROP", serverPort);
		
		myCmdStr.clear();
		if (myCL.iptablesCmd("iptables-save\n")) 
		{
			//while (myCL.iptablesAnswer(myAnswerStrings.lineStr))
			while (myCL.iptablesAnswer(answerLine))
			{
				if (strstr(answerLine, "-j QUEUE") != NULL)
					if ((startLine = strstr(answerLine, "-A ")) != NULL)
				{
					startLine += strlen("-A ");
					//strncpy(myAnswerStrings.lineStr, answerLine, 4096);
					snprintf(myAnswerStrings.lineStr, 4096, "-D %s", startLine);
					myCmdStr.push_back(myAnswerStrings);
					countResult ++;
				}
				if (strstr(answerLine, myRejectline) != NULL)
					if ((startLine = strstr(answerLine, "-A ")) != NULL)
				{
					startLine += strlen("-A ");
					//strncpy(myAnswerStrings.lineStr, answerLine, 4096);
					snprintf(myAnswerStrings.lineStr, 4096, "-D %s", startLine);
					myCmdStr.push_back(myAnswerStrings);
					countResult ++;
				}
				if (strstr(answerLine, DropLine) != NULL)
					if ((startLine = strstr(answerLine, "-A ")) != NULL)
				{
					startLine += strlen("-A ");
					//strncpy(myAnswerStrings.lineStr, answerLine, 4096);
					snprintf(myAnswerStrings.lineStr, 4096, "-D %s", startLine);
					myCmdStr.push_back(myAnswerStrings);
					countResult ++;
				}
			}
		}
		else 
			//saveLog("error show iptables rules\n", false);
			saveLog(false, "error show iptables rules\n");
		//myFact = 0;
		//int i;
		/*for (i = 0; i < myCmdStr.size(); ++i)
		{
			if (strstr(myCmdStr[i].lineStr, "-j QUEUE") != NULL)
			{
				//myFact |= 4;
				countResult ++;
			}
		}*/

	
	if (countResult > 0)
	{
		char deleteLine [4096];

		vector<McStr>::iterator rIdent;
		for(rIdent = myCmdStr.begin(); rIdent != myCmdStr.end(); ++rIdent)
		{
			snprintf (deleteLine, 4096, "iptables %s\n", (*rIdent).lineStr);
			if (myCL.iptablesCmd(deleteLine))
			{
				//if (!myCL.iptablesSaveAnswer(aLine)) 
				//	saveLog (true, "cmdSaveAnswer (delete QUEUE) error\n");
				myCL.cmdFree();
			}else saveLog (true, " delete my rules error\n");
		}
	}
	myCmdStr.clear();

		/*for(i = 0; i < countResult; ++i)
		{
			//sprintf (aLine, "iptables -D OUTPUT -o eth0 -d 192.168.0.0/16 -p tcp -m tcp --sport %d -j QUEUE\n", serverPort);
			sprintf (aLine, "iptables -D OUTPUT -d 192.168.0.0/16 -p tcp -m tcp --sport %d -j QUEUE\n", serverPort);
			if (!myCL.iptablesSaveAnswer(aLine) ) 
				//saveLog ("cmdSaveAnswer (DELETE redirect to user program) error\n", false);
				saveLog (true, "cmdSaveAnswer (DELETE redirect to user program) error\n");
		}

	//delete tcp-resest rules in iptables
	vector<McStr>::iterator rIdent;
	for(rIdent = rejectOutputRules.begin(); rIdent != rejectOutputRules.end(); ++rIdent)
	{
		snprintf (aLine, clLen-1, "iptables -D OUTPUT %s", (*rIdent).lineStr);
		if (myCL.iptablesCmd(aLine))
		{
			if (!myCL.iptablesSaveAnswer(aLine)) 
				//saveLog ("cmdSaveAnswer (delete tcp-reset rules) error\n", false);
				saveLog (true, "cmdSaveAnswer (delete tcp-reset rules) error\n");
			//myCL.cmdFree());
		}
	}
	for(rIdent = rejectInputRules.begin(); rIdent != rejectInputRules.end(); ++rIdent)
	{
		snprintf (aLine, clLen-1, "iptables -D INPUT %s", (*rIdent).lineStr);
		if (myCL.iptablesCmd(aLine))
		{
			if (!myCL.iptablesSaveAnswer(aLine)) 
				//saveLog ("cmdSaveAnswer (delete tcp-reset rules) error\n", false);
				saveLog (true, "cmdSaveAnswer (delete tcp-reset rules) error\n");
			//myCL.cmdFree());
		}
	}*/
}
void tcpdaemon::prepareIpTables()
{
	TCmdLine myCL;
	char aLine [clLen];
	//saveLog ("prepare IPTables\n", true);
	saveLog (true, "prepare IPTables\n");

	const int numInpStr = 2;
	const int numOutStr = 2;
	char *iptOutString[] = {"-p tcp -m tcp -d 192.168.0.0/16 --sport 8080 -j QUEUE",
							"-p udp -m udp -d 192.168.0.0/16 --sport 8080 -j QUEUE"
							};			
	char *iptInpString[] = {"-p tcp -m tcp -s 192.168.0.0/16 --dport 8080 -j QUEUE",
							"-p udp -m udp -s 192.168.0.0/16 --dport 8080 -j QUEUE",
							};
	//char *findString;
	bool needAddInp[numInpStr];
	bool needAddOut[numOutStr];
	int i,j;
	for (i = 0; i < numInpStr; ++i)
	{
		needAddInp[i] = true;
	}
	for (i = 0; i < numOutStr; ++i)
	{
		needAddOut[i] = true;
	}

	/*//run iptables
	sprintf (aLine, "modprobe iptable_filter\n");
	if (!myCL.iptablesSaveAnswer(aLine)) saveLog ("iptablesSaveAnswer run iptables error\n", false);

	//run ip_queue
	sprintf (aLine, "modprobe ip_queue\n");
	if (!myCL.iptablesSaveAnswer(aLine)) saveLog ("iptablesSaveAnswer run ip_queue error\n", false);*/

	/*if (myCL.iptablesCmd(aLine)) {	if (!myCL.cmdFree()) saveLog ("cmdFree clear counts error\n", false);}
	else saveLog("error clear counts\n", false);*/

	//char 
	
	
	McStr myAnswerStrings;
	vector <McStr> myCmdStr;
	if (myCL.iptablesCmd("iptables-save\n")) 
	{
		while (myCL.iptablesAnswer(myAnswerStrings.lineStr))
		{
			myCmdStr.push_back(myAnswerStrings);
		}
	}
	else 
		//saveLog("error show iptables rules\n", false);
		saveLog(true, "error show iptables rules\n");

/*
	//load rules
	sprintf (aLine, "iptables-restore %s/myIpRule.save\n", profileDir);
	if (myCL.iptablesCmd(aLine)) {if (!myCL.cmdFree()) saveLog ("cmdFree load rules error\n", false);}
	else 
		saveLog("error load rules\n", false);
*/
	
/*	//save rules
	sprintf (aLine, "iptables-save>%s/myIpRule.save\n", profileDir);
	if (!myCL.iptablesSaveAnswer(aLine)) saveLog ("iptablesSaveAnswer error in iptables-save\n", false);
*/
	/*if (myCL.iptablesCmd(aLine)) { if (!myCL.cmdFree()) saveLog ("cmdFree load rules error\n", false);}
	else saveLog("error load rules\n", false);*/

	//sprintf (aLine, "iptables -N my_count\n");
	//if (myCL.iptablesCmd(aLine)) {if (!myCL.cmdFree()) saveLog ("cmdFree add count chains error\n", false);}
	//if (myCL.iptablesCmd("iptables -N my_count\n")) {if (!myCL.cmdFree()) saveLog ("cmdFree add count chains error\n", false);}
	//else saveLog("error add my_count chains\n", false);
	//int i;
	//bool myFactOut, myFactInp;
	//myFactOut = true;
	//myFactInp = true;
	//int i;
	for (i = 0; i < myCmdStr.size(); ++i)
	{
		for (j = 0; j < numInpStr; ++j)
		{
			if (strstr(myCmdStr[i].lineStr, iptInpString[j]) != NULL)
				needAddInp[j] = false;
		}
		for (j = 0; j < numOutStr; ++j)
		{
			if (strstr(myCmdStr[i].lineStr, iptOutString[j]) != NULL)
				needAddOut[j] = false;
		}
			/*if (strstr(myCmdStr[i].lineStr, "-j QUEUE") != NULL)
			{
				if (strstr(myCmdStr[i].lineStr,"-s 192.168.0.0/16") != NULL)
				{
					myFactInp = false;
					//saveLog("find QUEUE string!!!", true);
					saveLog(true, "find QUEUE string in IPTables OUTPUT rules - dot need add\n");
				}
				if (strstr(myCmdStr[i].lineStr,"-d 192.168.0.0/16") != NULL)
				{
					myFactOut = false;
					//saveLog("find QUEUE string!!!", true);
					saveLog(true, "find QUEUE string in IPTables INPUT rules - dot need add\n");
				}
			}*/
	}
	/*if (myFactOut)
	{
		snprintf (aLine, clLen, "iptables -I OUTPUT 1 -p tcp -d 192.168.0.0/16 --sport %d -j QUEUE\n", serverPort);
		if (!myCL.iptablesSaveAnswer(aLine)) 
			//saveLog ("cmdSaveAnswer (INSERT redirect count chains) error\n", false);
			saveLog (true, "cmdSaveAnswer (INSERT OUTPUT redirect count chains) error\n");
	}
	if (myFactInp)
	{
		snprintf (aLine, clLen, "iptables -I INPUT 1 -p tcp -s 192.168.0.0/16 --dport %d -j QUEUE\n", serverPort);
		if (!myCL.iptablesSaveAnswer(aLine)) 
			//saveLog ("cmdSaveAnswer (INSERT redirect count chains) error\n", false);
			saveLog (true, "cmdSaveAnswer (INSERT INPUT redirect count chains) error\n");
	}*/
	for (j = 0; j < numInpStr; ++j)
	{
		if (needAddInp[j])
		{
			snprintf (aLine, clLen, "iptables -I INPUT 1 %s\n", iptInpString[j]);
			if (!myCL.iptablesSaveAnswer(aLine)) 
				saveLog (true, "cmdSaveAnswer (INSERT INPUT redirect count chains) error\n");
		}
	}
	for (j = 0; j < numOutStr; ++j)
	{
		if (needAddOut[j])
		{
			snprintf (aLine, clLen, "iptables -I OUTPUT 1 %s\n", iptOutString[j]);
		if (!myCL.iptablesSaveAnswer(aLine)) 
			saveLog (true, "cmdSaveAnswer (INSERT OUTPUT redirect count chains) error\n");
		}
	}


	//saveLog("end preparing\n", false);
	saveLog(true, "end preparing\n");
}

void tcpdaemon::sighandler(int signum) 
{
    waitpid(0, 0, WNOHANG);
}
void tcpdaemon::stopDaemon(int signum) 
{
	//workDaemon = false;
	pointToDaemon->workDaemon = false;


	//saveLog ("wait Daemon stop\n", true);
	saveLog (true, "wait Daemon stop\n");
    waitpid(0, 0, WNOHANG);
	//saveLog ("wait done\n", true);
	saveLog (true, "wait done\n");

	sleep (1);

	//saveLog ("restor iptable setting\n", true);
	saveLog (true, "restor iptable setting\n");

	pointToDaemon->restorIPtablesRule();
	//saveLog ("save traffic in stopDaemon finction\n", true);
	saveLog (true, "save traffic in stopDaemon finction\n");
	pointToDaemon->saveTraffic();
	
	sleep (1);
	//saveLog ("closing socket in stop function\n", true);
	saveLog (true, "closing socket in stop function\n");
		/*struct linger L;
		L.l_onoff = 1;
		L.l_linger = 0;
		if (setsockopt(pointToDaemon->sockfd, SOL_SOCKET, SO_LINGER, (char *) &L, sizeof(L)) < 0)
		saveLog ("ResetTCPClose error", true);*/
	close(pointToDaemon->sockfd);
		/*if (setsockopt(pointToDaemon->sockRL, SOL_SOCKET, SO_LINGER, (char *) &L, sizeof(L)) < 0)
		saveLog ("ResetTCPClose error", true);*/
	close(pointToDaemon->sockRL);
	//saveLog ("socket close in stop function\n", true);
	saveLog (true, "socket close in stop function\n");

	/*saveLog ("cancel threads\n", true);

	pthread_cancel(pointToDaemon->traffic_thread);
	int i;
	for (i = 0; i < numLocalService; ++i)
	{
	  pthread_cancel(pointToDaemon->service_thread[i]);
	  //close (pointToDaemon->fdService[i]);
	}
	for (i = 0; i < numListenThread; ++i)
	{
	  pthread_cancel(pointToDaemon->listen_thread[i]);
	  //close (pointToDaemon->fdListen[i]);
	}*/
	
//pthread_mutex_destroy(&request_mutex);

	saveLog (true, "call exit\n");
	//saveLog ("call exit\n", true);
	fflush (stdin);
	fflush (stdout);
	fflush (stderr);
	exit(0);
}

bool tcpdaemon::alreadyRun() 
{
	int pid = 0;
	char rBuf[256];
	FILE *dF;
	char fileName[256];

	snprintf (fileName, 255, "%s/daemon_pid", infDir);
	dF = fopen(fileName, "r");
			//saveLog ("search pid file !!!\n", true);
	if (dF != NULL)
	{
			//saveLog ("open pid file !!!\n", true);
		if (fgets(rBuf, 255, dF) != NULL)
		{
			pid = atoi(rBuf);
			//char logStr[256];
			//sprintf (logStr, " read pid=%d\n", pid);
			//saveLog (logStr, true);
			saveLog (true, " read pid=%d\n", pid);
		}else 
			//saveLog ("cannot read pid file\n", true);
			saveLog (true, "cannot read pid file\n");
		fclose (dF);
	}else 
		//saveLog ("Cannot read pid file !!!\n", true);
		saveLog (true, "Cannot read pid file !!!\n");
	
	if (pid > 0)
	{
		//saveLog ("probe pid\n", true);
		//saveLog (true, "probe pid\n");
	    if (kill(pid, 0) >= 0)
		{

			saveLog (true, "already run!!!\n");
			//exit(0);
			return true;
		}
			/*snprintf (fileName, 255, "/proc/%d/exe", pid);
		dF = fopen(fileName, "rt");
		if (dF != NULL)
		{
			char rBuf[256];
			if (fgets(rBuf, 255, dF) != NULL)
			{
				if (strstr(rBuf, "serv_daemon"))
				{
					printf ("serv daemon allreade run! pid = %d", pid);
					exit(0);
				}
			}else saveLog ("cannot read link file\n", true);
			fclose (dF);
		}else saveLog ("Cannot open link file!!!\n", true);*/
	}
	return false;
}
void tcpdaemon::daemonize() 
{
    int pid;
    struct sigaction sa, act;
	char logText [255];

	FILE *dF;
	char fileName[256];
	
	/*if (find_task_by_name("serv_daemon"))
	{
		printf ("serv daemon allreade run! pid = %d", pid);
		exit(0);
	}*/
	if (alreadyRun())
	{
		prepareIpTables();
		printf ("serv daemon allreade run! pid = %d\n", pid);
		exit(0);
	}
	
	//restorIPtablesRule();
	prepareIpTables();
	//saveLog ("Daemonizing ourselves.. \n", true);
	saveLog (true, "Daemonizing ourselves.. \n");
    pid = fork();

    switch(pid) 
    {
	case 0:
	    setsid();
	    chdir("/");
	    //chdir(profileDir);

	    close(0);
	    close(1);
	    close(2);

	    memset(&sa, 0, sizeof(sa));
	    sa.sa_handler = &sighandler;
	    sigaction(SIGCHLD, &sa, 0);

	    memset(&act, 0, sizeof(act));
	    act.sa_handler = stopDaemon;
	    sigaction(SIGTERM, &act, NULL);//sigaction(SIGINT, &sa, NULL) SIGUSR1

	    //openlog("newMyDaemonlog", 0, LOG_USER);
	    startDaemon();
	    //saveLog("Exit daemon", true);
	    saveLog(true, "Exit daemon");
		//closelog();
	    exit(0);

	case -1:
	    //saveLog ( "fork() error\n", true);
	    saveLog (true, "fork() error\n");
	    break;

	default:
		snprintf (fileName, 255, "%s/daemon_pid", infDir);

		dF = fopen(fileName, "w");
		if (dF != NULL)
		{
			//fprintf (uLF, "%s;%d;%d;%d;", sud.userName, sud.userLimit, sud.userTraffic, SessionTraffic);
			fprintf (dF, "%d\n", pid);
			fclose (dF);
		}else 
			//saveLog ("Cannot save pid file !!!\n", true);
			saveLog (true, "Cannot save pid file !!!\n");

		//sprintf (logText, );
	    //saveLog ( logText, false);
	    saveLog (false, "ok. PID=%d\n", pid);
	    break;
    }
}

void tcpdaemon::startDaemon() 
{
//syslog(LOG_NOTICE, "clear all in ip_filter");

	pointToDaemon = this;
	share.clear();
	collected.clear();
	//rejectOutputRules.clear();
	//McStr mcs;
	//sprintf (mcs.lineStr, "???");
	//mcs.killTime = 0;
	//mcs.beginTime = 0;
	//rejectOutputRules.push_back(mcs);


		SUserData myUserData;
		strcpy (myUserData.userName, "Public");
		myUserData.userLimit = 0;
		myUserData.underLimit = 0;
		myUserData.userTraffic = 0;

		myUserData.userCacheTraffic = 0;
		myUserData.underLimit = 0;

		myUserData.oldUserTraffic = myUserData.userTraffic;
		myUserData.userID = 0;
		myUserData.lastTime = 0;

		collected.push_back(myUserData);


		SIdentUser myIdentUser;
		strcpy (myIdentUser.userName, "Public");
		strcpy (myIdentUser.strUserIP, "0.0.0.0");
		myIdentUser.userIP.s_addr = inet_addr("0.0.0.0");
		myIdentUser.rTime = 0;

		myIdentUser.userID = 0;
		myIdentUser.detachConnection = false;
		myIdentUser.dropTime = 0;

		share.push_back(myIdentUser);

	
	//prepareIpTables();

	FILE *infoFile;
	char infoFileName[256], rBuf[4096];
	snprintf (infoFileName, 255, "%s/serv_daemon.inf", infDir);
	//snprintf (infoFileName, 255, "serv_daemon.inf");
	infoFile = fopen(infoFileName, "r");
	//char *ldapServer;
	//ldapServer = "192.168.1.4"
	strncpy(myLdapServer, ldapServer, 255);
	strncpy(myDaemonServer, daemonServer, 255);
	
	if (infoFile != NULL)
	{
		//if (fgets(rBuf, 4095, infoFile) != NULL)
		while (fgets(rBuf, 4095, infoFile) != NULL)
		{
			int i;
			//char *ldapServStr = "ldapServer=", *daemonServStr = "daemonServer=";
			char *ldapServStr = "ldapServer", *daemonServStr = "daemonServer";
			char *ldapStr, *daemonStr;
			ldapStr = strstr(rBuf, ldapServStr);
			daemonStr = strstr(rBuf, daemonServStr);
			if (ldapStr != NULL)
			{
				strtok (ldapStr, "=;");
				ldapServer = strtok (NULL, "=;");
				strncpy(myLdapServer, ldapServer, 255);
				//saveLog (ldapServer, false); saveLog(" LDAP Server\n", true);
				saveLog (true, "LDAP Server: %s\n", ldapServer);
			}
			if (daemonStr != NULL)
			{
				strtok (daemonStr, "=;");
				daemonServer = strtok (NULL, "=;");
				strncpy(myDaemonServer, daemonServer, 255);
				//saveLog (daemonServer, false); saveLog(" Daemon Server\n", true);
				saveLog (true, " Daemon Server: %s\n", daemonServer, false);
			}
		}
		fclose (infoFile);
	}else 
		//saveLog ("Cannot open servDaemon inf file !!!\n", true);
		saveLog (true, "Cannot open servDaemon inf file !!!\n");
	
	daemonServIP.s_addr = inet_addr(myDaemonServer);
	//strncpy(myLdapServer, ldapServer, 255);
	//strncpy(myDaemonServer, daemonServer, 255);
	
	
	//pthread_t traffic_thread, listen_thread[numListenThread], service_thread[numLocalService];
	//int sockfd, fd;
 
	hostent* remoteHost;
	unsigned int addr;
	int my_error = gethostname(myHostName, 16);

	if (my_error == 0)
	{
		remoteHost = gethostbyname(myHostName);
		sprintf (myIPstr, "%s", inet_ntoa(*((struct in_addr *)remoteHost->h_addr_list[0])));
		//char hostInfo[1024];
		//sprintf (hostInfo, "Host - %s IP - %s\n", myHostName, myIPstr);
		//saveLog (hostInfo, false);
		saveLog (false, "Host - %s IP - %s\n", myHostName, myIPstr);
//syslog(LOG_INFO, "Host - %s IP - %s\n", myHostName, myIPstr);

	}
	else 
		//saveLog ("cannot get host name\n", false);
		saveLog (false, "cannot get host name\n");
	size_t stacksize;
	pthread_attr_t attr;
	pthread_attr_init(&attr);
	stacksize = 50000;
	pthread_attr_setstacksize (&attr, stacksize);
	pthread_attr_getstacksize (&attr, &stacksize);

	//pthread_create(&traffic_thread,&attr,serv_request,(void*));
		//ThreadData myTD;
 int threadError;
 int tc;
 //bool killdaemon = true;
 for (tc = 0; tc < 100; ++tc)
 {
	workDaemon = true;
	sockfd = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);//SO_REUSEADDR
	
	if(sockfd != -1) 
	{

		    int on = 1;
			if (setsockopt(sockfd, SOL_SOCKET, SO_REUSEADDR, (char *) &on, sizeof(on)) < 0)
			//saveLog ("SetReuseAddr error\n", true);
			saveLog (true, "SetReuseAddr error\n");
			//debug(50, 1) ("commSetReuseAddr: FD %d: %s\n", fd, xstrerror());
			struct linger L;
			L.l_onoff = 0;		/* off */
			L.l_linger = 0;
			if (setsockopt(sockfd, SOL_SOCKET, SO_LINGER, (char *) &L, sizeof(L)) < 0)
			//debug(50, 0) ("commSetNoLinger: FD %d: %s\n", fd, xstrerror());
			//saveLog ("SetNoLinger error\n", true);
			saveLog (true, "SetNoLinger error\n");

		//memset(&sa, 0, sizeof(conn_sa));
	    struct sockaddr_in sa;
		sa.sin_addr.s_addr = htonl(INADDR_ANY);
		//sa.sin_addr.s_addr = inet_addr(myDaemonServer);
		sa.sin_family = AF_INET;
		sa.sin_port = htons(registerPort);

		if(bind(sockfd, (struct sockaddr *) &sa, sizeof(sa)) != -1) 
		{

			if(listen(sockfd, 5) == 0) 
			{
				for (int i = 0; i < numListenThread; ++i)
				{
					threadError = pthread_create(&listen_thread[i], &attr, listenerThread, (void*)this);
					//threadError = pthread_create(&listen_thread[i], NULL, listenerThread, (void*)this);
					if (threadError != 0)
					{
						//saveLog("Error create getOutLine thread\n", true);
						saveLog(true, "Error create listenerThread\n");
						workDaemon = false;
						//exit(1);
					}else
						{
							//saveLog("Create listenerThread thread\n", false);
							saveLog(false, "Create listenerThread thread \n");
						}
				}
				break;
			}else 
				{
					//saveLog("listen error in create listenerThread\n", true); 
					saveLog(true, "listen error in create listenerThread\n");
					close (sockfd); 
					workDaemon = false;
				}
		}else 
			{
				//saveLog("bind error in create listenerThread\n", true);
				saveLog(true, "bind error in create listenerThread\n");
				close (sockfd);
				workDaemon = false;
			}
	}else 
		{
			//saveLog("create socket for clientTrust error\n", true);
			saveLog(true, "create socket for clientTrust error\n");
			workDaemon = false;
		}
 	sleep (1);
 }
	
 if (workDaemon)
 {
 for (tc = 0; tc < 100; ++tc)
 {
	workDaemon = true;
	sockRL = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);//
	if(sockRL != -1) 
	{
		    int on = 1;
			if (setsockopt(sockRL, SOL_SOCKET, SO_REUSEADDR, (char *) &on, sizeof(on)) < 0)
				//saveLog ("SetReuseAddr error\n", true);
				saveLog (true, "SetReuseAddr error\n");
			//debug(50, 1) ("commSetReuseAddr: FD %d: %s\n", fd, xstrerror());
			struct linger L;
			L.l_onoff = 0;		/* off */
			L.l_linger = 0;
			if (setsockopt(sockRL, SOL_SOCKET, SO_LINGER, (char *) &L, sizeof(L)) < 0)
				//debug(50, 0) ("commSetNoLinger: FD %d: %s\n", fd, xstrerror());
				//saveLog ("SetNoLinger error\n", true);
				saveLog (true, "SetNoLinger error\n");
		
		
		
		//memset(&sa, 0, sizeof(conn_sa));
		struct sockaddr_in sa_rl;
		//sa_rl.sin_addr.s_addr = htonl(INADDR_ANY);
		sa_rl.sin_addr.s_addr = inet_addr("127.0.0.1");
		sa_rl.sin_family = AF_INET;//AF_UNIX;
		sa_rl.sin_port = htons(servicePort);

		if(bind(sockRL, (struct sockaddr *) &sa_rl, sizeof(sa_rl)) != -1) 
		{

			if(listen(sockRL, 5) == 0) 
			{
				for (int i = 0; i < numLocalService; ++i)
				{
					threadError = pthread_create(&service_thread[i], &attr, serviceThread, (void*)this);
					//threadError = pthread_create(&service_thread[i], NULL, serviceThread, (void*)this);
						/*myTD.tcpD = this;
						myTD.number_fd = i;
						threadError = pthread_create(&service_thread[i], &attr, serviceThread, (void*)&myTD);*/
					if (threadError != 0)
					{
						//saveLog("Error create servise thread\n", true);
						saveLog(true, "Error create servise thread\n");
						workDaemon = false;
						//exit(1);
					}else
						{
							saveLog(true, "Create servise thread\n");
						}
				}
				break;
			}else 
				{
					//saveLog("listen error in create service_thread\n", true);
					saveLog(true, "listen error in create service_thread\n");
					close(sockRL);
					workDaemon = false;
				}
		}else 
			{
				//saveLog("bind error in create service_thread\n", true);
				saveLog(true, "bind error in create service_thread\n");
				close(sockRL);
				workDaemon = false;
			}
	}else 
		{
			//saveLog("create socket for rlimit error\n", true);
			saveLog(true, "create socket for rlimit error\n");
			workDaemon = false;
		}
  sleep(1); 

 }


 
	threadError = pthread_create(&traffic_thread, &attr, packetTraffic, (void*)this);
	if (threadError != 0)
	{
		//saveLog("Error create traffic thread\n", true);
		saveLog(true, "Error create traffic thread\n");
		exit(1);
	}else
		{
			//saveLog("Create traffic thread\n", false);
			saveLog(false, "Create traffic thread\n");
		}
	//packetTraffic(this);
	pthread_attr_destroy(&attr);
	//workDaemon = false;
	saveLog (true, "ready !!!\n");	//saveLog ("wait thread daemom to join\n", true);
	readyToWork = true;
	pthread_join(traffic_thread, NULL);
	//pthread_detach(traffic_thread);
	//saveLog ("join daemom threads done\n", true);
	saveLog (true, "join daemom threads done\n");	//saveLog ("wait thread daemom to join\n", true);
	
	//saveLog (true, "wait thread daemom to join\n");


	int i;
	//char strLog[256];
	for (i = 0; i < numListenThread; ++i)
	{
		pthread_detach(listen_thread[i]);
		//pthread_join(listen_thread[i], NULL);
		saveLog (true, "wait listen_thread %d done\n", i+1);
	}
	for (i = 0; i < numLocalService; ++i)
	{
		pthread_detach(service_thread[i]);
		//pthread_join(service_thread[i], NULL);
		saveLog (true, "wait service_thread %d done\n", i+1);
	}
 }

	//saveLog ("closing socket in exit\n", true);
	saveLog (true, "closing socket in exit\n");
	if (!workDaemon)
	{
		//saveLog ("closing socket in exit\n", true);
		saveLog (true, "closing socket in exit\n");
		close(sockRL);
		close(sockfd);
		//saveLog ("socket close in exit\n", true);
		saveLog (true, "socket close in exit\n");
	}

  //saveLog ("restore IPTables Rule befor exit\n", true);
  saveLog (true, "restore IPTables Rule befor exit\n");
  restorIPtablesRule();

  //saveLog ("save traffic\n", true);
  saveLog (true, "save traffic in Exit\n");
  saveTraffic();

  //saveLog ("Exit TCP daemom\n", true);
  saveLog (true, "Exit TCP daemom\n");
  //printf ("Exit traffic daemon\n");
}

void* tcpdaemon::serviceThread(void *data)
{
	
	tcpdaemon *tcpD = (tcpdaemon *)(data);

 while (!tcpD->readyToWork); 
 /*�����������
  int retour;               
  struct sockaddr_in server;
  fd_set readf;             
  fd_set writef;            
  struct timeval to;*/        

	struct sockaddr_in conn_sa;
    socklen_t n;
	n = sizeof(conn_sa);
	int fd;

	//if(fcntl(tcpD->sockRL, F_SETFL, O_NONBLOCK) < 0) saveLog("fcntl() error\n", true);

	while (tcpD->workDaemon)
	{
                        /*
						FD_ZERO(&readf);        
                        FD_ZERO(&writef);       
                        FD_SET(tcpD->sockfd, &readf);   
                        FD_SET(tcpD->sockfd, &writef);  
                        to.tv_sec = 1; 
                        //to.tv_usec = 200; 
						retour = select(tcpD->sockfd+1, &readf, &writef, 0, &to);         
		                if (retour == 0)  
						{     
                            continue;    
                        }  
                       if ( (FD_ISSET(tcpD->sockfd, &readf)) || (FD_ISSET(tcpD->sockfd, &writef))) 
					   {*/       

		if((fd = accept(tcpD->sockRL, (struct sockaddr *) &conn_sa, &n)) != -1) 
		{
			//if (!tcpD->workDaemon) {close (fd); break;}
			if (tcpD->firstRegistration)
				tcpD->sendToRLimit(fd, conn_sa.sin_addr, inet_ntoa(conn_sa.sin_addr));
			//else close fd;
		}else 
			{	
				if (fd < 0)
					if(errno == EAGAIN || errno == EWOULDBLOCK)
					{
						//saveLog ("error accept connection from rlimit\n", false);
						saveLog (false, "error accept connection from rlimit\n", false);
						//break;
					}
			}
					   /*
					     }  
							else     
                                {       
									saveLog ("this is not a service socket\n", false);
                                }*/
		close (fd);
	}
	//saveLog ("exit service thread\n", false);
	saveLog (false, "exit service thread\n");
	//pthread_exit(NULL);
}
//void tcpdaemon::sendToRLimit(int fd, char* connIP)
void tcpdaemon::sendToRLimit(int fd, struct in_addr rlIPaddr, char *rlIPstr)
{
	const int szCMD = 1024;
	char cmd[szCMD] = "";
	char answer[szCMD] = "";

	char logStr[255];

	//snprintf (logStr, 255, "rlimit connection from %s\n", rlIPstr);
	//saveLog(logStr, true);

	int myLimit, myTraffic, myCacheAdd, myCacheTraffic, myUnderLimit;
	char seps [] = " ;\0\n";
	char *redirectStr = "Who is user ", *squidStr = "User Cache ", *writeComplete = "Write complete ";
	char *myStr, *userIP, *user, *cacheAdd;//, *hostIP, *hostName
	
		int i;
		struct in_addr userIPaddr;
	myLimit = 0;
	myTraffic = 0;
	myCacheTraffic = 0;
	myCacheAdd = 0;
	myUnderLimit = 0;

	if (recv(fd, cmd, szCMD, 0) > 0)
	{
		sprintf (answer, "error format\n");
		if ((myStr = strstr(cmd, redirectStr)) != NULL)
		{
		    //int cpid = fork();
			//switch(cpid) 
			//{
			//case 0:
				myStr += strlen(redirectStr);
				if ((userIP = strtok(myStr, seps)) != NULL)
				{
					//if ((hostIP = strtok(NULL, seps)) != NULL)
					//{
						//if ((hostName = strtok(NULL, seps)) != NULL)
						//{

							userIPaddr.s_addr = inet_addr(userIP);
	//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
							if (firstRegistration)
							{
								for(i = 0; i < share.size(); ++i)
								{
									if ( share[i].userIP.s_addr == userIPaddr.s_addr)
									{
										myLimit = collected[share[i].userID].userLimit;
										myTraffic = collected[share[i].userID].userTraffic;
										myCacheTraffic = collected[share[i].userID].userCacheTraffic;
										myUnderLimit = collected[share[i].userID].underLimit;
										snprintf (answer, 1023, "User description %s %d %d %d %d", 
												collected[share[i].userID].userName, 
												myLimit, 
												myTraffic - myCacheTraffic,
												myUnderLimit,
												share[i].rTime);
										break;
									}
								}
							}
							//else snprintf (answer, 1023, "Empty base");
	//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
						//}
					//}
				}
				send(fd, answer, strlen(answer)+1, 0);
			//	exit(0);

			//case -1:
			//	saveLog ( "fork() error in user limit transfer data\n", true);
			//	break;
			//}


		}
		else 
		{
			if ((myStr = strstr(cmd, squidStr)) != NULL)
			{
								//saveLog (cmd, false);
								//saveLog ("<SQUID answer", true);
				myStr += strlen(squidStr);
				if ((userIP = strtok(myStr, seps)) != NULL)
				{
					if ((cacheAdd = strtok(NULL, seps)) != NULL)
					{
						if (firstRegistration)
						{
							myCacheAdd = atoi(cacheAdd);
							userIPaddr.s_addr = inet_addr(userIP);
							for(i = 0; i < share.size(); ++i)
							{
								if ( share[i].userIP.s_addr == userIPaddr.s_addr)
								{
									//saveLog("get from cache for ", false);saveLog(collected[share[i].userID].userName, true);
									time_t realTime;
									time (&realTime);

									if ((realTime - share[i].rTime) < allowTime)
									{
										if (myCacheAdd > 0)
											collected[share[i].userID].userCacheTraffic += myCacheAdd;
									}

									break;
								}
							}			
							snprintf (answer, 1023, "User Name %s", collected[share[i].userID].userName);
						}
						else snprintf (answer, 1023, "Empty base");

					}
				}else 
					//saveLog ("error get user IP from SQUID", true);
					saveLog (true, "error get user IP from SQUID");
			send(fd, answer, strlen(answer)+1, 0);
			}
			else
			{
				if ((myStr = strstr(cmd, writeComplete)) != NULL)
				{
										//saveLog (true, cmd);
					snprintf (answer, 1023, "User Permision ALLOW\n");
					myStr += strlen(writeComplete);
					if ((userIP = strtok(myStr, seps)) != NULL)
					{
										//saveLog(true, "user IP %s\n", userIP);
						if ((cacheAdd = strtok(NULL, seps)) != NULL)
						{
										//saveLog(true, "user limit %s\n", cacheAdd);
							if (firstRegistration)
							{
								userIPaddr.s_addr = inet_addr(userIP);
								for(i = 0; i < share.size(); ++i)
								{
									if ( share[i].userIP.s_addr == userIPaddr.s_addr)
									{
										time_t realTime;
										time (&realTime);

										//saveLog(true, "find user (%s)\n", userIP);
										if (share[i].dropTime > realTime)
										{
											snprintf (answer, 1023, "User Permision CLOSE\n");
											saveLog(true, "close user (%s) socket\n", userIP);
										}
										break;
									}
								}
							}
						}
					}

					/*if ((userIP = strtok(myStr, seps)) != NULL)
					{
						if ((cacheAdd = strtok(NULL, seps)) != NULL)
						{
							if (firstRegistration)
							{
								myCacheAdd = atoi(cacheAdd);
								userIPaddr.s_addr = inet_addr(userIP);
								for(i = 0; i < share.size(); ++i)
								{
									if ( share[i].userIP.s_addr == userIPaddr.s_addr)
									{
										//saveLog("get from cache for ", false);saveLog(collected[share[i].userID].userName, true);
										time_t realTime;
										time (&realTime);

										if ((realTime - share[i].rTime) < allowTime)
										{
											if (myCacheAdd > 0)
												collected[share[i].userID].userCacheTraffic += myCacheAdd;
										}

										break;
									}
								}			
								snprintf (answer, 1023, "User Name %s", collected[share[i].userID].userName);
							}
							else snprintf (answer, 1023, "Empty base");

						}
					}
					 else 
						saveLog (true, "error get user IP from SQUID");*/
					send(fd, answer, strlen(answer)+1, 0);
				}

				else 
					saveLog (false, "error rlimit recive format string from rlimit or squid");
			}
		}
	}
		
	//close (fd);	
	//saveLog("close rlimit connection", false);
				
}

void* tcpdaemon::listenerThread(void *data)
{
	
	//int listenSocket = (int)data;
	tcpdaemon *tcpD = (tcpdaemon *)(data);
	while (!tcpD->readyToWork); 
	
  /*//*
  int retour;               
  struct sockaddr_in server;
  fd_set readf;             
  fd_set writef;            
  struct timeval to;  //*/    


	struct sockaddr_in conn_sa;
    socklen_t n;
	n = sizeof(conn_sa);
	int fd;

	char logStr[256];
	struct in_addr userIPaddr;

	//if(fcntl(tcpD->sockfd, F_SETFL, O_NONBLOCK)<0) saveLog("fcntl() error\n", true);

	char userIPstr[18];
	while (tcpD->workDaemon)
	{
                        /*/*
						FD_ZERO(&readf);        
                        FD_ZERO(&writef);       
                        FD_SET(tcpD->sockfd, &readf);   
                        FD_SET(tcpD->sockfd, &writef);  
                        to.tv_sec = 1; 
						retour = select(tcpD->sockfd+1, &readf, &writef, NULL, &to);         
						retour = select(tcpD->sockfd+1, &readf, NULL, NULL, &to);         
		                if (retour == 0)  
						{     
                            continue;    
                        }  
                       if ( (FD_ISSET(tcpD->sockfd, &readf)) || (FD_ISSET(tcpD->sockfd, &writef))) 
                       //if (FD_ISSET(tcpD->sockfd, &readf))
					   {   //*/    

		if((fd = accept(tcpD->sockfd, (struct sockaddr *) &conn_sa, &n)) != -1) 
		{
			if (!tcpD->workDaemon) {close (fd); break;}
			strncpy (userIPstr, inet_ntoa(conn_sa.sin_addr), 18);

			userIPaddr.s_addr = conn_sa.sin_addr.s_addr;
			tcpD->operate(fd, userIPaddr, userIPstr);
			/*if ( tcpD->operate(fd, userIPaddr, userIPstr) )
			{
				tcpD->deregisterUserIP(userIPaddr, userIPstr);
			}*/
			close (fd);

		}
		  else 
			{	
				//saveLog ("error accept connection from clientTrust\n", false);
				saveLog (true, "error accept connection from clientTrust\n");
				//break;
				/*if (fd < 0)
    			if(errno == EAGAIN || errno == EWOULDBLOCK)
				{
					saveLog ("error accept connection from clientTrust\n", false);
				}*/
			}
					   /*/*�����������
					     }
                               else     
                                {       
									//saveLog ("this is not a listen socket\n", false);
									saveLog (false, "this is not a listen socket\n");
                                } //*/
	}
	//close (fd);
	//saveLog ("exit listen thread\n", false);
	saveLog (false, "exit listen thread\n");
	//pthread_exit(NULL);
}
//void* tcpdaemon::KillThread(void *data)
void tcpdaemon::oldKillProcess(char *userIPstr, int killTime)
{
	/*tcpdaemon *tcpD;
	tcpD = (tcpdaemon *)data;
	time_t killTime = tcpD->rejectOutputRules.back().killTime;

	char aLine [clLen], getOutLine [clLen], getInLine [clLen];
	strncpy(getOutLine, tcpD->rejectOutputRules.back().lineStr, clLen);

	if (strstr (getOutLine, "???") == NULL)
	{
	snprintf (aLine, clLen, "iptables -I OUTPUT 1 %s", getOutLine);
	TCmdLine myCL;
	if (myCL.iptablesCmd(aLine))
	{
		myCL.cmdFree();
	}
	snprintf (aLine, clLen-1, "iptables -I INPUT 1 %s", getInLine);
	if (myCL.iptablesCmd(aLine))
	{
		myCL.cmdFree();
	}

	sleep(killTime);

	snprintf (aLine, clLen-1, "iptables -D OUTPUT %s", getOutLine);
	saveLog (true, "restor user connectrion\n");
	if (myCL.iptablesCmd(aLine))
	{
		myCL.cmdFree();

			vector<McStr>::iterator rIdent;
			for(rIdent = tcpD->rejectOutputRules.begin(); rIdent != tcpD->rejectOutputRules.end(); ++rIdent)
			{
				if (strstr((*rIdent).lineStr, getOutLine) != NULL)
				{
					tcpD->rejectOutputRules.erase(rIdent);
					break;
				}
			}
	}

	snprintf (aLine, clLen, "iptables -D INPUT %s", getInLine);
	saveLog (true, "restor user connectrion\n");
	if (myCL.iptablesCmd(aLine))
	{
		myCL.cmdFree();
			vector<McStr>::iterator rIdent;
			for(rIdent = tcpD->rejectInputRules.begin(); rIdent != tcpD->rejectInputRules.end(); ++rIdent)
			{
				if (strstr((*rIdent).lineStr, getInLine) != NULL)
				{
					tcpD->rejectInputRules.erase(rIdent);
					break;
				}
			}
	}
	}*/
	char outLineTCP [clLen], outLineUDP [clLen], cmdLine[clLen];
	//snprintf (outLine, clLen, "-d %s -p tcp -m tcp --sport %d -j REJECT --reject-with tcp-reset", userIPstr, serverPort);
	//snprintf (inLine, clLen, "-s %s -p tcp -m tcp --dport %d -j REJECT --reject-with tcp-reset", userIPstr, serverPort);
	//snprintf (outLine, clLen, "-p tcp -d %s --sport %d -j REJECT --reject-with icmp-host-unreachable", userIPstr, serverPort);
	//snprintf (inLine, clLen, "-p tcp -s %s --dport %d -j REJECT --reject-with icmp-host-unreachable", userIPstr, serverPort);

	snprintf (outLineTCP, clLen, "-p tcp -d %s --sport %d -j REJECT --reject-with tcp-reset", userIPstr, serverPort);
	snprintf (outLineUDP, clLen, "-p udp -d %s --sport %d -j REJECT --reject-with icmp-port-unreachable", userIPstr, serverPort);
	//snprintf (inLine, clLen, "-p tcp -s %s --dport %d -j REJECT --reject-with tcp-reset", userIPstr, serverPort);
	//snprintf (outLine, clLen, "-p tcp -d %s --sport %d -j DROP", userIPstr, serverPort);
	//snprintf (inLine, clLen, "-p tcp -s %s --dport %d -j DROP", userIPstr, serverPort);

	TCmdLine myCL;
	snprintf (cmdLine, clLen, "iptables -I OUTPUT 2 %s\n", outLineTCP);
	if (myCL.iptablesCmd(cmdLine))
	{
		myCL.cmdFree();
	}
	//TCmdLine myCL;
	snprintf (cmdLine, clLen, "iptables -I OUTPUT 2 %s\n", outLineUDP);
	if (myCL.iptablesCmd(cmdLine))
	{
		myCL.cmdFree();
	}
        
    /*char inLineTCP [clLen], inLineUDP[clLen];
 	snprintf (inLineTCP, clLen, "-p tcp -s %s --dport %d -j REJECT --reject-with tcp-reset", userIPstr, serverPort);
	snprintf (inLineUDP, clLen, "-p udp -s %s --dport %d -j REJECT --reject-with icmp-port-unreachable", userIPstr, serverPort);
	snprintf (cmdLine, clLen, "iptables -I INPUT 2 %s", inLineTCP);
	if (myCL.iptablesCmd(cmdLine))
	{
		myCL.cmdFree();
	}
	snprintf (cmdLine, clLen, "iptables -I INPUT 2 %s", inLineUDP);
	if (myCL.iptablesCmd(cmdLine))
	{
		myCL.cmdFree();
	}*/
	saveLog(true, "killed user connection - %s\n", userIPstr);

	sleep(killTime);

	snprintf (cmdLine, clLen, "iptables -D OUTPUT %s\n", outLineTCP);
	if (myCL.iptablesCmd(cmdLine))
	{
		myCL.cmdFree();
	}
	snprintf (cmdLine, clLen, "iptables -D OUTPUT %s\n", outLineUDP);
	if (myCL.iptablesCmd(cmdLine))
	{
		myCL.cmdFree();
	}
	/*snprintf (cmdLine, clLen, "iptables -D INPUT %s", inLineTCP);
	if (myCL.iptablesCmd(cmdLine))
	{
		myCL.cmdFree();
	}
	snprintf (cmdLine, clLen, "iptables -D INPUT %s", inLineUDP);
	if (myCL.iptablesCmd(cmdLine))
	{
		myCL.cmdFree();
	}*/
	saveLog(true, "restored user connection - %s\n", userIPstr);
}
bool tcpdaemon::oldKillUserConection(struct in_addr userIPaddr, char *userIPstr, unsigned int killTime)
{
	/*char aLine [clLen];
	//McStr mcs;
	snprintf (aLine, clLen, "-d %s -p tcp -m tcp --sport %d -j REJECT --reject-with tcp-reset", userIPstr, serverPort);
	strncpy (mcs.lineStr, aLine, 1023);
	rejectOutputRules.push_back(mcs);
	snprintf (aLine, clLen, "-s %s -p tcp -m tcp --dport %d -j REJECT --reject-with tcp-reset", userIPstr, serverPort);
	strncpy (mcs.lineStr, aLine, 1023);
	mcs.killTime = killTime;
	mcs.beginTime = workTime;
	rejectInputRules.push_back(mcs);

	pthread_t killConnectionThread;
	int threadError = pthread_create(&killConnectionThread, NULL, KillThread, (void*)this);
	if (threadError != 0) return false;
	pthread_detach(killConnectionThread);*/
	int cpid = fork();
	switch(cpid)
	{
	case 0:
		oldKillProcess(userIPstr, killTime);
		exit(0);
	case -1:
		saveLog(true, "Error create kill user connections Process\n");
	}
	if (cpid) return true;
		else return false;

}

int tcpdaemon::registerUserIP(struct in_addr userIPaddr, char *userIPstr, char *userName, int &getLimit)
{
	char fUserIP[256];
	char logStr[1024];

	char rlBuf[1024];
	char seps [] = " ;\0\n";

	int myLDAPLimit = 0, myLDAPUnderLimit = 0, rc = 0;
	getLimit = 0;
	rc = myLdapSSLConnect(userName, myLdapServer, myLDAPLimit, myLDAPUnderLimit);
	if (rc == -1)
	{
		//saveLog("LDAP error\n", true);
		saveLog(true, "LDAP error\n");
		myLDAPLimit = 0;
		myLDAPUnderLimit = 0;
	}
	//sprintf (logStr, "LDAP Limit %d\n", myLDAPLimit);
	//saveLog (logStr, true);

	time_t realTime, registerTime;
	time (&realTime);
		
	unsigned int real_month, last_month, real_year, last_year;

	struct tm *today, *last;
	today =  localtime( &realTime );
		real_month = today->tm_mon;
		real_year = today->tm_year;

	snprintf (fUserIP , 255, "%s/_%s.mda", profileDir, userIPstr);
	FILE *fUI;

		/*fUI = fopen (fUserIP, "r");
		if (fUI != NULL)
		{
			if (fgets(rlBuf, 1023, fUI) != NULL)
			{
				char *fUserName, *registerUserTime;
				fUserName = strtok (rlBuf, seps);
				registerUserTime = strtok (NULL, seps);
				if (registerUserTime != NULL)
				{
					registerTime = atol(registerUserTime);
					last =  localtime( &registerTime );
					if (last->tm_mon != today->tm_mon)
						if (last->tm_year != today->tm_year)
							needResetTraffic = true;
				}
			}

			fclose (fUI);
		}*/

	fUI = fopen (fUserIP, "w");
	if (fUI != NULL)
	{
		fprintf (fUI, "%s;%ld;", userName, realTime);
		fclose (fUI);
	}else 
		{
			//snprintf (logStr, 1023, "error open fileUserIP (%s) for write !!!!\n", userIPstr);
			//saveLog (logStr, true);
			saveLog (true, "error open fileUserIP (%s) for write !!!!\n", userIPstr);
		}

//	snprintf (fUserIP, 255, "%s/__%s.mdu", profileDir, userName);
		snprintf (fUserIP, 255, "%s/%2.2d.%2.2d__%s.mdu", profileDir, today->tm_mon + 1, today->tm_year - 100, userName);
	unsigned long allTraffic = 0, cacheTraffic = 0, underLimit= 0;
	//char logStr[255];


	bool present;
	present = false;

//pthread_mutex_lock(&request_mutex);

	int i;
	unsigned int localUserID;
	localUserID = collected.size();
	for (i = 1; i < collected.size(); ++i)
	{
		if (strcmp(collected[i].userName, userName) == 0)
		{
			collected[i].userLimit = myLDAPLimit;
			collected[i].underLimit = myLDAPUnderLimit;

			registerTime = collected[i].lastTime;
			last =  localtime( &registerTime );
			last_month = last->tm_mon;
			last_year = last->tm_year;
	 		if ((last_month != real_month) || (last_year != real_year))
			{
				collected[i].userTraffic = 0;
				collected[i].userCacheTraffic = 0;
			}

			collected[i].lastTime = realTime;

			allTraffic = collected[i].userTraffic;
			cacheTraffic = collected[i].userCacheTraffic;
			underLimit = collected[i].underLimit;
			localUserID = collected[i].userID;
			present = true;
		}
	}
//pthread_mutex_unlock(&request_mutex);		
	if (!present)
	{
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		bool fileNotExist = true;
		fUI = fopen (fUserIP, "r");
		if (fUI != NULL)
		{
			char *sUserName, *userLimitStr, *allTrafficStr, *cacheTrafficStr, *underLimitStr, *registerTimeStr;
			if (fgets(rlBuf, 1023, fUI) != NULL)
			{
				fileNotExist = false;
				sUserName = strtok (rlBuf, seps);
				userLimitStr = strtok (NULL, seps);
				if (userLimitStr == NULL)
					userLimitStr = "0";
				allTrafficStr = strtok (NULL, seps);
				if (allTrafficStr == NULL)
					allTrafficStr = "0";
				cacheTrafficStr = strtok (NULL, seps);
				if (cacheTrafficStr == NULL)
					cacheTrafficStr = "0";
				underLimitStr = strtok (NULL, seps);
				if (underLimitStr == NULL)
					underLimitStr = "0";
				allTraffic = atoi(allTrafficStr);
				cacheTraffic = atoi(cacheTrafficStr);
				underLimit = atoi(underLimitStr);
				if ((registerTimeStr = strtok (NULL, seps)) == NULL)
					registerTime = realTime;
				else
					registerTime = atol (registerTimeStr);
			}
			fclose (fUI);
		}
		 else 
			{
				//snprintf (logStr, 1023, "can not find for open fileUserTraffik (%s) for read -> recreate\n", userIPstr);
				//saveLog (logStr, true);
				saveLog (true,  "can not find for open fileUserTraffik (%s) for read -> recreate\n", userIPstr);
			}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

		SUserData myUserData;
		strcpy (myUserData.userName, userName);
		myUserData.userLimit = myLDAPLimit;//myLimit;
		myUserData.underLimit = myLDAPUnderLimit;//myLimit;
		myUserData.userTraffic = allTraffic;

		myUserData.userCacheTraffic = cacheTraffic;
		myUserData.underLimit = underLimit;

		myUserData.oldUserTraffic = myUserData.userTraffic;
		myUserData.userID = collected.size();
		myUserData.lastTime = realTime;


//pthread_mutex_lock(&request_mutex);
		collected.push_back(myUserData);
//pthread_mutex_unlock(&request_mutex);		

		firstRegistration = true;
		//snprintf (logStr, 1023, "registrate user - %s", userName);
		//saveLog (logStr, true);
		saveLog (true, "registrate user - %s \n", userName);

//-------------------------------------------------------------------------------------------------------------
		if (fileNotExist)
		{
			fUI = fopen (fUserIP, "w");
			if (fUI != NULL)
			{
				//fprintf (fUI, "%s;%d;%d;%d;", userName, myLimit, allTraffic, sessionTraffic);
				fprintf (fUI, "%s;%d;%d;%d;%d;%d;", 
					userName, myLDAPLimit, allTraffic, cacheTraffic, myLDAPUnderLimit, realTime);
				fclose (fUI);
			}else 
				{
					//char logStr[255];
					//snprintf (logStr, 1023, "error open fileUserTraffik (%s) for write!!!\n", userIPstr);
					//saveLog (logStr, true);
					saveLog (true, "error open fileUserTraffik (%s) for write!!!\n", userIPstr);
				}
		}
//-------------------------------------------------------------------------------------------------------------
	}

//pthread_mutex_lock(&request_mutex);
	if (collected[localUserID].userID != localUserID)
	{
		//saveLog("not accociate betwen userID and member\n", true);
		saveLog(true, "not accociate betwen userID and member\n");
	}

	present = false;

	for (i = 1; i < share.size(); ++i)
	{
//		if (strcmp(share[i].userName, userName) == 0)
//			if (strcmp((*iIdent).strUserIP, userIP) == 0)
		if (share[i].userIP.s_addr == userIPaddr.s_addr)
		{
			time (&realTime);
			strcpy (share[i].userName, userName);
			if (share[i].userID != localUserID)
			{
				share[i].detachConnection = false;
				share[i].dropTime = 0;
			}
			share[i].userID = localUserID;
			share[i].rTime = realTime;
			present = true;
		}
	}
//pthread_mutex_unlock(&request_mutex);		
	if (!present)
	{
		time (&realTime);

		SIdentUser myIdentUser;
		strcpy (myIdentUser.userName, userName);
		strcpy (myIdentUser.strUserIP, userIPstr);
		myIdentUser.userIP = userIPaddr;
		myIdentUser.rTime = realTime;

		myIdentUser.userID = localUserID;
		myIdentUser.detachConnection = false;
		myIdentUser.dropTime = 0;

//pthread_mutex_lock(&request_mutex);
		share.push_back(myIdentUser);
//pthread_mutex_unlock(&request_mutex);		

		//snprintf (logStr, 1023, "registrate user - %s on IP - %s", userName, userIPstr);
		//saveLog (logStr, true);
		saveLog (true, "registrate user - %s on IP - %s \n", userName, userIPstr);
	}

	//return (myLimit - allTraffic);
	//return (myLDAPLimit - allTraffic + cacheTraffic);
	getLimit = (myLDAPLimit - allTraffic + cacheTraffic);
	return rc;
}
void tcpdaemon::deregisterUserIP(struct in_addr userIPaddr, char *userIPstr)
{
	char fUserIP[256];
	FILE *fUI;

	vector<SIdentUser>::iterator iIdent;
	char userNameStr[256];//, logStr[1024];
	if (firstRegistration)
	{
//mutex enable
//pthread_mutex_lock(&request_mutex);
		for(iIdent = share.begin(); iIdent != share.end(); ++iIdent)
		{
			//if (strcmp((*iIdent).strUserIP, userIP) == 0)
			if ((*iIdent).userIP.s_addr == userIPaddr.s_addr)
			{
				time_t realTime;
				time (&realTime);

				snprintf(userNameStr, 255, collected[(*iIdent).userID].userName);
				//share.erase(iIdent);
				strcpy ((*iIdent).userName, "Public");
				(*iIdent).detachConnection = false;
				(*iIdent).userID = 0;
				(*iIdent).rTime = 0;
				(*iIdent).dropTime = realTime + 30;
				if (!(*iIdent).detachConnection)
				{
					//saveLog ( "kill user connection in deregisterUserIP\n", true);
					/*saveLog (true, "kill user connection (%s) in deregister\n", userIPstr);
					if (!oldKillUserConection(userIPaddr, userIPstr, 5))  
						saveLog(true, "KillUserConection error in deregistrate user\n");*/
				//saveLog (true, "DROP user connection in deregister %s\n", userIPstr);
						//(*iIdent).dropTime = 130;
						(*iIdent).detachConnection = true;
						//(*iIdent).userID = 0;
				}
				break;
			}
		}
//pthread_mutex_unlock(&request_mutex);	
//mutex disable

	
	
	}
	snprintf (fUserIP , 255, "%s/_%s.mda", profileDir, userIPstr);
	fUI = fopen (fUserIP, "w");
	if (fUI != NULL)
	{
		fprintf (fUI, "[Public];0;");
		fclose (fUI);
	}

	//snprintf(logStr, 1023, "deregustrate user - %s on IP %s", userNameStr, userIPstr);
	//saveLog (logStr, true);
	saveLog (true, "deregustrate user - %s on IP %s\n", userNameStr, userIPstr);
}

bool tcpdaemon::operate(int fd, struct in_addr userIPaddr, char *userIPstr)
{
    const int szCMD = 1024;
    char cmd[szCMD] = "";
	char answer[szCMD] = "";
    char cmd2[szCMD] = "";
	//char answer2[szCMD] = "";
    bool deRegistration = false;
	
	//int myLimit;
	char seps [] = " ;\n";
	//myLimit = 0;

 	//while (recv(fd, cmd, szCMD, 0) > 0)
	if (recv(fd, cmd, szCMD, 0) > 0)
	{
		char *beginStr = "registrate->";
		char *myStr, *myUser, *myUserIPstr, *myUserHostNameStr;//, *myUserLimitStr;
		char logStr[1024];
		sprintf (logStr, "don`t have typed string");
		myCrypt(cmd);
	
		//if (!workDaemon) {return false;}

		bool registerSucces = false;
			if (strchr (cmd, '\n') == NULL) 
			{
				saveLog (true, "don`t recive first string in registration procedure!!!\n");
				return false;
			}
		if (strstr(cmd, "[Public]") == NULL)
		{
			//saveLog (cmd, true);
			myStr = strstr(cmd, beginStr);
			if (myStr != NULL)
			{
				myStr += strlen(beginStr);
				if ((myUser = strtok(myStr, seps)) != NULL)
				{
					if ((myUserIPstr = strtok(NULL, seps)) != NULL)
					{
						if ((myUserHostNameStr = strtok(NULL, seps)) != NULL)
						{
							//if ((myUserLimitStr = strtok(NULL, seps)) != NULL)
							//{
									registerSucces = true;
									//myLimit = atoi(myUserLimitStr);
								if (userIPaddr.s_addr != inet_addr(myUserIPstr))
								{
									snprintf (logStr, 1023, 
										"user - %s - IP  don`t conform to real IP %s !!!!!!!!!!!",
											myUser, myUserIPstr, userIPstr,
										true);
								}
							//}
						}
					}
				}
			}
			
			if	(registerSucces)
			{
				//sprintf (logStr, "registration User %s IP %s Host %s Limit %s\n", myUser, myUserIPstr, myUserHostNameStr, myUserLimitStr);
				//saveLog (logStr, false);

				time_t ltime;
				time (&ltime);
				sprintf (answer, "Success registration from->%s %s %d \n", myHostName, myIPstr, ltime);

				//if (!workDaemon) {return false;}
				myCrypt(answer);
				if (send(fd, answer, strlen(answer)+1, 0) > 0) 
				{
					bool attestation = false;
					if (recv(fd, cmd2, szCMD, 0) > 0)
					{
						myCrypt(cmd2);
							if (strchr (cmd2, '\n') == NULL) 
							{
								saveLog (true, "don`t recive second string  in registration procedure!!!\n");
								return false;
							}

						char *attestationStr, *servTimeStr;
						if ((attestationStr = strtok(cmd2, seps)) != NULL)
						{
							if ( (servTimeStr = strtok(NULL, seps)) != NULL)
							{
								time_t servTime = atol(servTimeStr);
								if (servTime > ltime) attestation = true;
								else 
									//saveLog("Error Server answer Time", false);
									saveLog(false, "Error Server answer Time");
							}else 
								//saveLog("Error Time string", false);
								saveLog(false, "Error Time string");
						}else 
							//saveLog("Error attestation string", false);
							saveLog(false, "Error attestation string");
					}
							//if (!workDaemon) {return false;}
					if (attestation)
					{
						int rest = 0, rc = -1;
						//tolower myUser
								char *p;
							   for( p = myUser; p < myUser + strlen( myUser ); p++ )
								{
									if ( isascii(* p) )
									{
										if( isupper( *p ) )
											*p = char( tolower( *p ) );
									}
								}


						//rest = registerUserIP(userIP, myUser, myLimit);
						//rest = registerUserIP(userIPaddr, userIPstr, myUser, myLimit);
						rc = registerUserIP(userIPaddr, userIPstr, myUser, rest);

						//if (!workDaemon) {return false;}
						sprintf (answer, "Attestation rest->%d %d \n", rest, rc);
						/*if (rest >= 0)
						{
							sprintf (answer, "Attestation rest->%d %d \n", rest, rc);
						}
						else
							{
								sprintf (answer, "Attestation rest->%d %d close\n", rest, rc);
							}*/

						myCrypt(answer);
						send(fd, answer, strlen(answer)+1, 0);
					}else 
						//saveLog ("attestation error", false);
						saveLog (false, "attestation error");
				}
			}
			else
				{
						//if (!workDaemon) {return false;}

					//saveLog ("error registration", false);
					saveLog (false, "error registration");
					sprintf (answer, "Error registration from->%s %s \n", myHostName, myIPstr);
					myCrypt(answer);
					send(fd, answer, strlen(answer)+1, 0);
				}

		}
		else 
			{
				deregisterUserIP(userIPaddr, userIPstr);
				deRegistration = true;
			}
	}
	//saveLog ("close connection\n", false);

	//close (fd);
	return deRegistration;
	//you must decide this problem!!!!!!!!!!
}

void tcpdaemon::exec() 
{
    daemonize();
}

int main(int argc, char *argv[]) 
{
    tcpdaemon tcpD;
	if (argc > 1)
	{
			//saveLog (argv[0], true);
		//saveLog (argv[1], true);
		saveLog (true, argv[1]);
		if (strstr (argv[1], "-prepare") != NULL )
		{
			if (tcpD.alreadyRun() == true)
			{
				tcpD.prepareIpTables();
				//saveLog ("����� IPTables \n", true);
				saveLog (true, "����� IPTables \n");
				exit(0);
			}
		}
	}

    tcpD.exec();
    return 0;
}

/*void saveLog(char *mylog, bool ntime)
{
	FILE *fp;
	fp = fopen(log_fname,"a+");
	if (fp != NULL)
	{
		if (ntime)
		{
			time_t workTime;
			time (&workTime);
				struct tm *today;//, *last;
				today =  localtime( &workTime );

			//fprintf (fp, "%s: %s", mylog, ctime(&workTime));
				fprintf (fp, "%d.%d.%d-%d:%d:%d > %s\n", 
					today->tm_mday, today->tm_mon+1, today->tm_year-100 , today->tm_hour, today->tm_min, today->tm_sec, mylog);
		}
		else
			fprintf (fp, "%s ", mylog);
		fclose(fp);
	}
}*/

bool myCrypt(char *strCript)
{
	unsigned int myLen;
	unsigned char cryptSymbol;

	myLen = strlen(strCript);
	cryptSymbol = myLen & 7;

	if ((myLen < 1) || (myLen >= 1024)) return false;
	for (int i = 0; i < myLen ; i ++)
	{
		strCript[i] = (strCript[i] ^ cryptSymbol);

		cryptSymbol --;
		if (cryptSymbol <= 0)
		{
			cryptSymbol = myLen & 7;
		}
	}

	return true;
}

// Local Variables:
// mode:C++
// End:
