#ifndef _MY_LDAP_H
#define _MY_LDAP_H

#include <ldap.h>
#include <ctype.h>

#include <vector>
#include <string>

using std::string;
using std::vector;
using std::iterator;

//int myLdapConnect( char *loginName);
//int myLdapSSLConnect( char *loginName, char *ldapServer);
/*union sInAddr
{
	int value;
	char b[4];
};*/
struct attrName
{
	char name[256];
};
struct allinOne
{
	 vector <attrName> userGroups;
	 int userLimit;
	 int userunderLimit;
};

class myLDAP
{

protected:
  LDAP   *ld;
	char ldapHost[256];
	struct timeval timeOut;
	bool study;

	int LSC ( char *loginName, int &ldapLimit, int &ldapUnderLimit);
	//int myLdapSearch(LDAP *ld, char *searchBase, char  **attrs, int &sLimit, int &sUnderLimit, bool userData);
	int myLdapSearch(LDAP *ld, char *searchBase, char  **attrs, int &sLimit, int &sUnderLimit, vector <attrName> &userGroups);
	//int myLdapSearch(LDAP *ld, char *searchBase, char  **attrs, allinOne &allDan);

public:
	myLDAP();
	~myLDAP();
	int myLdapInit();
	void myLdapDeInit();
	void setHost(char *ldapServer);
	//void reset();
	//int myLdapSSLConnect( char *loginName, char *ldapServer, int &ldapLimit, int &ldapUnderLimit);
	//int LSC ( char *loginName, char *ldapServer, int &ldapLimit, int &ldapUnderLimit);
	int myLdapInfo(char *loginName, int &ldapLimit, int &ldapUnderLimit);

};
//int myLdapSSLConnect( char *loginName, char *ldapServer, int &ldapLimit, int &ldapUnderLimit);

#endif /*_MY_LDAP_H*/

