WinClient.cpp : Defines the entry point for the application.
//
#include "stdafx.h"
#include "WinClient.h"
#include "shellapi.h"
#include "windows.h"
#include <iostream>
#include <stdexcept>

#include <vector>
#include <iostream>

#include <stdio.h>
#include <winsock2.h>
#include "Winuser.h"
#include <string.h>
#include <Icm.h.>
#include <stdlib.h>
#include <process.h>

#include "nwinclude/ntypes.h"
#include "nwinclude/nwnet.h"
#include "nwinclude/nwcalls.h"
#include "nwinclude/nwlocale.h"


#define MAX_LOADSTRING 100
#define WSA_ACCEPT   (WM_USER + 1)
#define WSA_NETEVENT (WM_USER + 2)
#define RMT_MESSAGE (WM_USER + 3)

//#define TEST_SERV

struct SattrInfo
{
	char str[1024];
};


using namespace std;


char redirect_serv_addr[18];
unsigned short registration_port;
unsigned short listen_port;
//const unsigned short answer_port = 711;
const unsigned int pauseTime = 10000;//millisecund
const int timeDiv = 100;
const int miniPause = pauseTime/timeDiv;


const int max_line = 100;
int line_count = 0;
char mytext[max_line][1024];
bool normal = true;
bool must_send_end = false;
bool show_limit_message = true;


UINT uID = 1;

#define  IDM_T_SHOW (WM_USER + 4)
#define  IDM_T_HIDE (WM_USER + 5)
#define  IDM_T_EXIT (WM_USER + 6)
#define  IDM_T_REGISTER (WM_USER + 7)


NOTIFYICONDATA m_nid;
bool myVisible;
char FullName[1024];

//DWORD dwThreadId, dwThrdParam = 1; 
//HANDLE hThread; 


SOCKADDR_IN s_addr_in;
SOCKET serv_sock, connect_socket;
WSADATA wsaDat;
//char myHostName[255], myIPstr[18];
//hostent* remoteHost;

HINSTANCE hInst;								// current instance  
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

bool __stdcall sock_init(HWND _hWND, char *ip_addr, unsigned short serv_port);
void __stdcall sock_destroy(HWND _hWnd);
//void __stdcall OnWSANetEvent(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
void __stdcall OnWSAAccept(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
bool __stdcall definition(char *UserLine, char *NameUser, char *trafficNet, char *sError);
void __stdcall myAddStr(char *addstr);
void __stdcall myPaint(HWND hWnd);
bool __stdcall send_name(HWND hWnd, char* myUser, char *myError, long &myLimit, long &rc);
bool __stdcall registration(HWND hWnd, char *strErr);
bool __stdcall myCrypt(char *strCript);

//bool __stdcall AnswerSend(SOCKET localSocket, int &myLimit, int &rc, char *strErr);
bool __stdcall AnswerSend(SOCKET localSocket, char *attIP, int &myLimit, int &rc, char *strErr);

void stringToLow(char *stringline);
bool mySearchAttr( NWDSContextHandle &contextHandle, pBuf_T attrName, pBuf_T outBuffer, pBuf_T inBuffer, 
				  char *loginName, const char *myAttrName, vector <SattrInfo> &myInfo, char *myError);


uintptr_t sTh;
bool threadWork;
void __cdecl sendThread(void *vhWnd);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	HANDLE hMutex; 
	// Create a mutex with no initial owner.
	hMutex = CreateMutex( 
	    NULL,                       // no security attributes
		FALSE,                      // initially not owned
		"MutexToOneStartClientStart");  // name of mutex

	if (hMutex == NULL) 
	{
	    // Check for error.
		return FALSE;
	}
	if ( GetLastError()  == ERROR_ALREADY_EXISTS) 
	{
	    // Check for error.
		HWND fhWnd = FindWindow(NULL, "WinClient");
		SendMessage(fhWnd, WM_DESTROY, 0, 0);
	}
	
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_WINCLIENT, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_WINCLIENT);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}

//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	//wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.style			= CS_SAVEBITS;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_MYICON);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+10);
	wcex.lpszMenuName	= (LPCTSTR)IDC_WINCLIENT;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_MYICON);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   //hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
   //   CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL); 
   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW | WS_EX_TOPMOST,
      CW_USEDEFAULT, 0, 400, 150, NULL, NULL, hInstance, NULL); 

   if (!hWnd)
   {
      return FALSE;
   }

   m_nid.cbSize = sizeof(NOTIFYICONDATA);
   m_nid.hWnd = hWnd;
   m_nid.uCallbackMessage = RMT_MESSAGE;
   m_nid.hIcon = LoadIcon(hInstance, (LPCTSTR)IDI_MYICON);
   m_nid.uFlags = NIF_MESSAGE | NIF_ICON;
   m_nid.uID = uID;

   //Shell_NotifyIcon (NIM_ADD, &m_nid);

   //ShowWindow(hWnd, nCmdShow);
			myVisible = false;
			ShowWindow(hWnd, SW_HIDE);
   UpdateWindow(hWnd);

   return TRUE;
}
//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//

void __cdecl sendThread(void *vhWnd)
//DWORD WINAPI sendThread( LPVOID vhWnd )
//void __cdecl sendThread( LPVOID vhWnd )
{
	HWND hWnd = (HWND)vhWnd;
	char strErr[1024];
		int startCount = 0;
		while ((FindWindow("Shell_TrayWnd", NULL) == NULL) && (startCount < 200))
		{
			startCount ++;
			Sleep (500);
		}
	int i;
		if (!registration(hWnd, strErr))
		{
			must_send_end = false;
			myAddStr(strErr);
		}
		else must_send_end = true;

	while (threadWork)
	{
		Shell_NotifyIcon (NIM_ADD, &m_nid);
		/*if (!threadWork) break;
		if (!registration(hWnd, strErr))
		{
			must_send_end = false;
			myAddStr(strErr);
		}
		else must_send_end = true;*/

		for (i = 0; i < timeDiv; ++i)
		{
			if (threadWork) Sleep(miniPause);
				else break;
		}
		//Sleep(pauseTime);

		//else myAddStr("Succes");
		//UpdateWindow(hWnd);
		//RedrawWindow(hWnd, NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE );
	}
	_endthread();
}


LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	//PAINTSTRUCT ps;
	//HDC hdc;

	int res_stup;
	HMENU hMenu;
	hostent* remoteHost;
	int my_error;


	char strErr[255];
	long myLimit, rc;
	myLimit = 0, rc = 0;
	char localHostName[255], localIPstr[18];

	switch (message) 
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(wParam); 
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_T_SHOW:
			myVisible = true;
			//ShowWindow(hWnd, SW_SHOW);
			ShowWindow(hWnd, SW_RESTORE);
			BringWindowToTop(hWnd);
			//AnimateWindow(hWnd, 100000, AW_ACTIVATE | AW_HOR_NEGATIVE);
			SetWindowPos (hWnd, HWND_TOPMOST, 0, 0, 600, 600, SWP_NOMOVE | SWP_NOSIZE | SWP_SHOWWINDOW);
			break;
		case IDM_T_HIDE:
			myVisible = false;
			ShowWindow(hWnd, SW_HIDE);
		break;
		/*case IDM_T_REGISTER:
			if (!registration (hWnd, strErr))
				myAddStr(strErr);
			UpdateWindow(hWnd);
			RedrawWindow(hWnd, NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE );
			break;*/
		case IDM_T_EXIT:
			DestroyWindow(hWnd);
		break;
	     default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_SHOWWINDOW:
		break;
	case WM_CREATE:
		//redirect_serv_addr = "192.168.2.30";
		sprintf_s (redirect_serv_addr, 18, "192.168.1.38");
		//sprintf (redirect_serv_addr, "192.168.1.38");
		registration_port = 712;
		listen_port = 711;

		res_stup = WSAStartup(MAKEWORD(2, 2), &wsaDat);
		//int res_stup = WSAStartup(MAKEWORD(1, 1), &wsaDat);
		if (res_stup)
		{
			MessageBox(NULL, "There is not enough memory for initialize socket resources",
									"Error", MB_ICONERROR + MB_OK);
			DestroyWindow(hWnd);
		}
		// 
		
		my_error = gethostname(localHostName, 18);
		if (my_error == 0)
		{
			remoteHost = gethostbyname(localHostName);
			//sprintf (localIPstr, "%s", inet_ntoa(*((struct in_addr *)remoteHost->h_addr_list[0])));
			sprintf_s (localIPstr, 18, "%s", inet_ntoa(*((struct in_addr *)remoteHost->h_addr_list[0])));

		}
		else 
			{
				//MessageBox(NULL, strerror(my_error), "gethostname Error", MB_ICONERROR + MB_OK); DestroyWindow(hWnd);
				char errStr[1024];
				strerror_s(errStr, 1024, my_error);
				MessageBox(NULL, errStr, "gethostname Error", MB_ICONERROR + MB_OK); DestroyWindow(hWnd);
			}
		//myVisible = true;
		//sock_init(HWND _hWND, char *ip_addr, unsigned short serv_port);
		if (!sock_init(hWnd, localIPstr, listen_port))
		{
			MessageBox(NULL, "Cannot create socket", "Error", MB_ICONERROR + MB_OK);
			DestroyWindow(hWnd);
		}
		//create thread to connect to demon
		threadWork = true;
		sTh = _beginthread(sendThread, 0, (void *)hWnd);
		if (sTh < 1)
		{
			//MessageBox (NULL, strerror(errno), "Thread Error", MB_OK);
			char locErr[1024];
			strerror_s(locErr, 1024, errno);
			MessageBox (NULL, locErr, "Thread Error", MB_OK);
			DestroyWindow(hWnd);
		}

		/*hThread = CreateThread( 
				NULL,                        // default security attributes 
				0,                           // use default stack size  
				sendThread,                  // thread function 
				(LPVOID)hWnd,                // argument to thread function 
				0,                           // use default creation flags 
				&dwThreadId);                // returns the thread identifier 
		 
		if (hThread == NULL) 
		{
			MessageBox (NULL, strerror(errno), "Thread Error", MB_OK);
			DestroyWindow(hWnd);
		}*/

		break;
	case WM_CLOSE:
		myVisible = false;
		ShowWindow(hWnd, SW_HIDE);
		break;
	case WM_PAINT:
		myPaint(hWnd);
		//BringWindowToTop (hWnd);
		break;
	case WM_DESTROY:
		threadWork = false;
		//Sleep(200);
		myLimit = 0; rc = 0;
		if (must_send_end)
			send_name(hWnd, "[Public]", strErr, myLimit, rc);
        Sleep((3*miniPause));
        sock_destroy(hWnd);
		//      CloseHandle( hThread );
		Shell_NotifyIcon(NIM_DELETE, &m_nid); 
		PostQuitMessage(0);
		break;
	case RMT_MESSAGE:
		switch (lParam)
		{
		case WM_RBUTTONDOWN:
 			POINT pt;
			GetCursorPos(&pt);
			hMenu = CreatePopupMenu();
			if (myVisible) AppendMenu( hMenu, MF_STRING, IDM_T_HIDE, _T("hide"));
				else AppendMenu( hMenu, MF_STRING, IDM_T_SHOW, _T("show"));		 
			//AppendMenu( hMenu, MF_STRING, IDM_T_REGISTER, _T("register"));
			AppendMenu( hMenu, MF_STRING, IDM_T_EXIT, _T("exit"));
			SetForegroundWindow(hWnd);
			TrackPopupMenuEx(hMenu,TPM_HORIZONTAL|TPM_LEFTALIGN,pt.x,pt.y,hWnd,
		 					NULL);
			DestroyMenu(hMenu); 
			break;
		case WM_LBUTTONDBLCLK:
			myVisible = true;
			//ShowWindow(hWnd, SW_SHOW);
			ShowWindow(hWnd, SW_RESTORE);
			SetForegroundWindow(hWnd);
			SetWindowPos (hWnd, HWND_TOPMOST, 0, 0, 600, 600, SWP_NOMOVE | SWP_NOSIZE | SWP_SHOWWINDOW);
			//BringWindowToTop(hWnd);
			//AnimateWindow(hWnd, 100000, AW_ACTIVATE | AW_HOR_NEGATIVE);
			break;
		}
		break;
	case WSA_ACCEPT:
		OnWSAAccept(hWnd, message, wParam, lParam);
		break;
	/*case WSA_NETEVENT:
		OnWSANetEvent(hWnd, message, wParam, lParam);
		break; */

	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}
bool __stdcall registration(HWND hWnd, char *strErr)
{
	//int  mylimit = 0;
	char UserLine[1024], NameUser[1024];
	char trafficLine[1024];
	char seps [] = " :\0\n";
	char infoStr[255];
	
	line_count = 0;

	char localHostName[255], localIPstr[18], *next_tok;

	hostent* remoteHost;
	int my_error;
	my_error = gethostname(localHostName, 18);
	if (my_error == 0)
	{
		remoteHost = gethostbyname(localHostName);
		sprintf_s (localIPstr, 18, "%s", inet_ntoa(*((struct in_addr *)remoteHost->h_addr_list[0])));
	}
	else
	{
		myAddStr("   ");
	}

	if (definition(UserLine, NameUser, trafficLine, strErr))
	{

		char *Begin;
		//Begin = strstr(UserName, "CN=");
		Begin = strstr(UserLine, "cn=");
		if (Begin != NULL)
		{
			sprintf_s (strErr, 1024, "SendingName");
			
			char *DaemonIP, *DaemonPort, *ListenPort;
			sprintf_s (FullName, 1024, "%s", UserLine);
			sprintf_s (infoStr, 255, " - %s", NameUser);
			myAddStr(infoStr);
#ifndef TEST_SERV
			if ((DaemonIP = strtok_s(trafficLine, ":", &next_tok)) != NULL)
			{
				//redirect_serv_addr = DaemonIP;
				sprintf_s (redirect_serv_addr, 18, DaemonIP);
				if ((DaemonPort = strtok_s(NULL, ":;", &next_tok)) != NULL)
				{
					registration_port = atoi(DaemonPort);
					//sprintf (infoStr, "  %s:%s", DaemonIP, DaemonPort);
					//myAddStr(infoStr);
					if ((ListenPort = strtok_s(NULL, ":;", &next_tok)) != NULL)
					{
						listen_port = atoi(ListenPort);
						//sprintf (infoStr, "  %s:%s   %s ", DaemonIP, DaemonPort, ListenPort);
						sprintf_s (infoStr, 255, "  %s:%s   %s ", DaemonIP, DaemonPort, ListenPort);
						myAddStr(infoStr);
					}
				}
			}
#else 
		sprintf (infoStr, "  %s:%d   %d ", redirect_serv_addr, registration_port, listen_port);
		myAddStr(infoStr);
#endif		

			long  mylimit, rc;
			mylimit = 0; rc = 0;
			if (send_name(hWnd, FullName, strErr, mylimit, rc)) 
			{
				if (rc > 0)
				{
					char strLimit[256];
					char header[128];
					if (mylimit >= 0)
					{
						sprintf_s (header, 128 ,"");
						normal = true;
					}
					else 
						{
							normal = false;
							sprintf_s (header, 128, " ");
							mylimit *= -1;
							/*if (show_limit_message)
							{
								myVisible = true;
								ShowWindow(hWnd, SW_SHOW);
								AnimateWindow(hWnd, 10000, AW_ACTIVATE | AW_SLIDE);
								show_limit_message = false;
							}*/
						}

					double realLimit;
					realLimit = double(mylimit)/1048576.0;

					/*sprintf (strLimit, "%s :", header);
					int limitInGb, limitInMb, limitInKb;
					limitInGb = mylimit/1073741824;
					mylimit -= limitInGb*1073741824;
					limitInMb = mylimit/1048576;
					mylimit -= limitInMb*1048576;
					limitInKb = mylimit/1024;
					mylimit -= limitInKb*1024;

					if (limitInGb > 0) sprintf (strLimit, "%s %d Gb", strLimit, limitInGb);
					if (limitInMb > 0) sprintf (strLimit, "%s %d Mb", strLimit, limitInMb);
					if (limitInKb > 0) sprintf (strLimit, "%s %d Kb", strLimit, limitInKb);
					if (mylimit > 0) sprintf (strLimit, "%s %d b", strLimit, mylimit);
					sprintf (strLimit, "%s %3.2f Mb", strLimit, realLimit);*/
					sprintf_s (strLimit, 256, "%s %3.2f Mb", header, realLimit);
					myAddStr(strLimit);
				}
				else 
					{
						if (rc < 0)
							sprintf_s (strErr, 1024, "  LDAP");
						else 
							sprintf_s (strErr, 1024, " ");
						return false;
					}
			}
			else
			{
				//sprintf (strErr, " ");
				//sprintf (strErr, "%s (%s)", strErr, UserName); 
				return false;
			}
		}
		else 
			{
				sprintf_s (strErr, 1024, "  !!!"); //myAddStr("Not registrate!!!");
				return false;
			}
	}
	else 
		{
			//sprintf (strErr, "  Novell Client"); 
			myAddStr ("  Novell Client"); 
			sprintf_s (strErr, 1024, "%s : %s", strErr, UserLine); 
			return false;
		}
	return true;
}

bool __stdcall myCrypt(char *strCript)
{
	int myLen;
	unsigned char cryptSymbol;

	myLen = int(strlen(strCript));
	cryptSymbol = myLen & 7;

	if ((myLen < 1) || (myLen >= 1024)) return false;
	for (int i = 0; i < myLen ; i ++)
	{
		strCript[i] = (strCript[i] ^ cryptSymbol);


		cryptSymbol --;
		if (cryptSymbol <= 0)
		{
			cryptSymbol = myLen & 7;
		}
	}

	return true;
}

bool __stdcall send_name(HWND hWnd, char* myUser, char *myError, long &myLimit, long &rc)
{
	char localHostName[255], localIPstr[18];	
	hostent *remoteHost;
	int my_error = gethostname(localHostName, 16);
		if (my_error == 0)
		{
			remoteHost = gethostbyname(localHostName);
			sprintf_s (localIPstr, 18, "%s", inet_ntoa(*((struct in_addr *)remoteHost->h_addr_list[0])));

		}
		else {sprintf_s(myError, 1024, "gethostname error");return false;}

	//myAddStr(myIPstr);
	sockaddr_in s_addr_out;
	SOCKET out_sock;

	out_sock = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);//
	if (out_sock == INVALID_SOCKET)
	{
		sprintf_s (myError, 1024, "registration socket create error");
		return false;
	}

	s_addr_out.sin_family = AF_INET;
	s_addr_out.sin_port = htons(registration_port);//htons(ServPort);
	s_addr_out.sin_addr.S_un.S_addr = inet_addr(redirect_serv_addr);//inet_addr(ServIP);

	if (connect(out_sock, (SOCKADDR *)&s_addr_out, sizeof(s_addr_out)) == SOCKET_ERROR)
	{
		sprintf_s (myError, 1024, "     ");
		//myAddStr(myError);
		return false;
	}
	int bytesSent;//, recCount;
	int bytesRecv;
	const int szBuff = 1024;
	char send_buff[szBuff] = "";
	char recv_buff[szBuff] = "";
	char recv_buff2[szBuff] = "";
	//char randStr[256] = "";//, iBuffer[65];
	sprintf_s (send_buff, 1024, "<-registrate->%s %s %s %d;<EOF> \n", myUser, localIPstr, localHostName, myLimit);

	char seps[] = " ;\n";

	bool registerSuccess = false;
	bool attestation = false;
	/*srand( (unsigned)time( NULL ) );
	for (int i = 0; i < 10; ++i)
	{
		sprintf(randStr, "%s%d", randStr, rand());
	}
	sprintf (send_buff, "%s<-registrate->%s %s %s %d;<EOF>", randStr, myUser, myIPstr, myHostName, myLimit);*/

	myCrypt(send_buff);

	bytesSent = send(out_sock, send_buff, int(strlen(send_buff)) + 1, 0);

		if (bytesSent != strlen(send_buff) + 1)
		{
			sprintf_s (myError, 1024, "dont sending user name");
			closesocket(out_sock);
			return false;
		}

if (strstr (myUser, "[Public]") == NULL)
{
	//sprintf (myError, "connect to host");
	//while ((bytesRecv = recv(out_sock, recv_buff, szBuff, 0)) > 0)
	bytesRecv = recv(out_sock, recv_buff, szBuff, 0);//MSG_OOB
	if ((bytesRecv > 0) && (bytesRecv != WSAECONNRESET))
	{
		char *myStr, *myServName = "unknown", *myServIPstr="0.0.0.0", *myLimitStr, *myRegistrationTimeStr, *beginStr = "from->";
		char *limitStr, *rcStr, *next_tok;
		//char hostAnswer[1024];
		//strcpy (hostAnswer, "");
		myCrypt(recv_buff);
			if (strchr (recv_buff, '\n') == NULL) 
			{
				sprintf_s (myError, 1024, "don`t recive first string in registration procedure");
				closesocket(out_sock);
				return false;
			}
		if (strstr(recv_buff, "Success") )
		{
			myStr = strstr(recv_buff, beginStr);
			if (myStr != NULL)
			{
				myStr += strlen(beginStr);
				//if ((myServName = strtok(myStr, seps)) != NULL)
				if ((myServName = strtok_s(myStr, seps, &next_tok)) != NULL)
				{
					//if ((myServIPstr = strtok(NULL, seps)) != NULL) 
					if ((myServIPstr = strtok_s(NULL, seps, &next_tok)) != NULL) 
					{
						//if ( (myRegistrationTimeStr = strtok(NULL, seps)) != NULL)
						if ( (myRegistrationTimeStr = strtok_s(NULL, seps, &next_tok)) != NULL)
						{
							registerSuccess = true;
						}
						/*else
								{
									registerSuccess = false;
									myRegistrationTimeStr = "0";
								}*/

					}
					/*else
						{
							registerSuccess = false;
							myUIPstr = "<empty>";
						}*/
				}
				/*else
					{
						registerSuccess = false;
						myHostName = "<empty>";
					}*/
			}
			if (registerSuccess)
			{
		
				time_t myRegistrationTime = atol(myRegistrationTimeStr) + 5;
				sprintf_s (send_buff, 1024, "attestation %d server_time \n", myRegistrationTime);
				myCrypt(send_buff);
				bytesSent = send(out_sock, send_buff, int(strlen(send_buff)) + 1, 0);
					
					if (bytesSent != strlen(send_buff) + 1)
					{
						sprintf_s (myError, 1024, "dont sending verify string");
						closesocket(out_sock);
						return false;
					}


				//sprintf (myError, "registration host=%s(%s)", myHostName, myUIPstr);

				bytesRecv = recv(out_sock, recv_buff2, szBuff, 0);
				if ((bytesRecv > 0) && (bytesRecv != WSAECONNRESET))
				{
					myCrypt(recv_buff2);
						if (strchr (recv_buff2, '\n') == NULL) 
						{
							sprintf_s (myError, 1024, "don`t recive first string in registration procedure");
							closesocket(out_sock);
							return false;
						}
					//char *aBeginStr = "rest->";
					char *aBeginStr = "Attestation rest->";
					myLimitStr = strstr(recv_buff2, "Attestation");
					if (myLimitStr != NULL)
					{
						//char *aBeginStr = "rest->";
						//if ((myLimitStr = strstr(recv_buff2, aBeginStr)) != NULL)
						//{
							myLimitStr += strlen(aBeginStr);
							//myLimit = atoi(myLimitStr);
							if ((limitStr = strtok_s(myLimitStr, seps, &next_tok)) != NULL)
							//if ((limitStr = strtok(myLimitStr, seps)) != NULL)
							{
								myLimit = atol(limitStr);
								if ((rcStr = strtok_s(NULL, seps, &next_tok)) != NULL)
								//if ((rcStr = strtok(NULL, seps)) != NULL)
								{
									rc = atol(rcStr);
									attestation = true;
								}
								else rc = 0;
							}
							else myLimit = 0;
						//}
					}else
						{
							sprintf_s (myError, 1024, "Error atestation string");
						}

				}else 
					{
						sprintf_s (myError, 1024, "dont recive traffic info");
					}

			}
		}
		else
			{
				sprintf_s (myError, 1024, "   %s(%s)", myServName, myServIPstr);
			}
//		sprintf (myError, "");
	}
	else
		{
			sprintf_s (myError, 1024, "Host not answer");
		}
}
else {	sprintf_s (myError, 1024, "not registred name");}
	closesocket(out_sock);
	if (attestation) return true;
	else return false;
}

/*bool __stdcall create_listener(HWND hWnd, unsigned short clnt_port)
{
	if (!sock_init(hWnd, myIPstr, clnt_port))
		{
		MessageBox(NULL, "Cannot create socket", "Error", MB_ICONERROR + MB_OK);
		return false;
		}
   return true;
}*/

void __stdcall myPaint(HWND hWnd)
{
	char emptytext[255] = "                                                                                   ";
	PAINTSTRUCT ps;
	HDC hdc;

	hdc = BeginPaint(hWnd, &ps);
	RECT r;
	GetClientRect(hWnd, &r); 
	FillRect(hdc, &r, (HBRUSH)GetStockObject(BLACK_BRUSH)); 

	//SetBkColor(hdc, RGB(255,255,255));
	SetBkMode(hdc, TRANSPARENT);

	if (RectVisible(hdc, &r))
	{
		if (normal) SetTextColor(hdc, RGB(0,240,0));
		else SetTextColor(hdc, RGB(240,0,0));
		//SetTextColor(hdc, RGB(0,240,0));
		for (int i = 0; i < line_count; ++i)
		{
			//if (i == (line_count-1)) SetTextColor(hdc, RGB(255,0,0));
			//TextOut(hdc,r.left,r.top + i*15,emptytext, strlen(emptytext));
			TextOut( hdc,r.left,r.top + i*20, mytext[i], int(strlen(mytext[i])) );
		}
	}
	EndPaint(hWnd, &ps);

}
// 
//---------------------------------------------------------------------------
bool  __stdcall sock_init(HWND _hWnd, char *ip_addr, unsigned short serv_port)
{
 serv_sock = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
 if (serv_sock == INVALID_SOCKET)
 {
  MessageBox(NULL, "Error socket creating", "Error", MB_ICONERROR + MB_OK);
  WSACleanup();
  return false;
 }

 s_addr_in.sin_family = AF_INET;
 s_addr_in.sin_port = htons(serv_port);
 //s_addr_in.sin_addr.S_un.S_addr = inet_addr(ip_addr);
 s_addr_in.sin_addr.S_un.S_addr = inet_addr("0.0.0.0");

 if (bind(serv_sock, (LPSOCKADDR)&s_addr_in, sizeof(SOCKADDR_IN)) == SOCKET_ERROR)
 {
  //MessageBox(NULL, strerror(WSAGetLastError()), "Bind Error", MB_ICONERROR + MB_OK);
	char locErr[1024];
	strerror_s(locErr, 1024, WSAGetLastError());
  MessageBox(NULL, locErr, "Bind Error", MB_ICONERROR + MB_OK);
  sock_destroy(_hWnd);
  return false;
 }

 if (listen(serv_sock, 5) == SOCKET_ERROR)
 {
  //MessageBox(NULL, strerror(WSAGetLastError()), "Listen Error", MB_ICONERROR + MB_OK);
	char locErr[1024];
	strerror_s(locErr, 1024, WSAGetLastError());
  MessageBox(NULL, locErr, "Listen Error", MB_ICONERROR + MB_OK);
  sock_destroy(_hWnd);
  return false;
 }

 //WSAAccept

 int res_asin_sel = WSAAsyncSelect(serv_sock, _hWnd, WSA_ACCEPT, FD_ACCEPT);
 if (res_asin_sel > 0)
  {
   MessageBox(NULL, "The attempt of creating real-time mode failed",
                            "Warning", MB_OK + MB_ICONWARNING);
   sock_destroy(_hWnd);
   return false;
  }
 return true;
}
//---------------------------------------------------------------------------
void __stdcall sock_destroy(HWND _hWnd)
{
 WSAAsyncSelect(serv_sock, _hWnd, 0, 0);
 closesocket(serv_sock);
 WSACleanup();
}
/*void __stdcall OnWSANetEvent(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
		SOCKET localSocket = (SOCKET)wParam;
		if(WSAGETSELECTEVENT(lParam) == FD_READ )
    {

		char strErr[1024];
		int mylimit = 0, rc = -1;

		if (AnswerSend(localSocket, mylimit, rc, strErr))
		{
			if (rc >=	0)
			{
				char strLimit[256];
				char header[128];
				if (mylimit	>= 0)
				{
					sprintf	(header	,"");
					normal = true;
				}
				else 
					{
						normal = false;
						sprintf	(header, "");
						mylimit	*= -1;
					}

				double realLimit;
				realLimit	=	double(mylimit)/1048576.0;

				sprintf	(strLimit, "%s %3.2f Mb",	header,	realLimit);
				myAddStr(strLimit);
			}//if	(rc	>= 0)
				else 
					{
						myAddStr(" LDAP");
					}
		}
			else 
			{
				myAddStr(" ");
				must_send_end = true;
			}
		closesocket(localSocket);
		//closesocket(connect_socket);
		return;
    }
	else if(WSAGETSELECTEVENT(lParam) == FD_CLOSE )
    {
			WSAAsyncSelect (localSocket , hWnd, 0, 0 );
			myAddStr("connection close");
			//closesocket(connect_socket);
			closesocket(localSocket);
    }

}*/
//---------------------------------------------------------------------------
void __stdcall OnWSAAccept(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  //int rc;
  //     
  //    
  if(WSAGETSELECTERROR(lParam) != 0)
  {
    MessageBox(NULL, "accept  Error", "Error", MB_OK);
    //WSAAsyncSelect (serv_sock , hWnd, 0, 0);
    return;
  }
  //    
	sockaddr_in acc_sin;
	int acc_sin_len;
  acc_sin_len = sizeof(sockaddr_in);

  SOCKET localSocket;
	//   
  localSocket = accept (serv_sock, (LPSOCKADDR)&acc_sin, (int FAR *)&acc_sin_len);
  //localSocket = WSAAccept (serv_sock, (LPSOCKADDR)&acc_sin, (int FAR *)&acc_sin_len, NULL, NULL);
  if(localSocket == INVALID_SOCKET)
  {
   //MessageBox(NULL, strerror(WSAGetLastError()), "Connect Error", MB_ICONERROR + MB_OK);
		char locErr[1024];
		strerror_s(locErr, 1024, WSAGetLastError());
		MessageBox(NULL, locErr, "Connect Error", MB_ICONERROR + MB_OK);

   return;
  }

				if (WSAAsyncSelect (localSocket , hWnd, 0, 0 ) > 0)
					{
						myAddStr("WSAAsyncSelect failed in OnWSAAccept");
						//sock_destroy(_hWnd);
					}
				// Set the socket I/O mode: In this case FIONBIO
				// enables or disables the blocking mode for the 
				// socket based on the numerical value of iMode.
				//If iMode = 0, blocking is enabled; 
				//If iMode != 0, non-blocking mode is enabled.
				int iMode = 0;
				ioctlsocket(localSocket, FIONBIO, (u_long FAR*) &iMode);

//myAddStr("Accept");
		char strErr[1024];
		int mylimit = 0, rc = -1;

		char atestationIP[18];
		//strncpy (atestationIP, inet_ntoa(acc_sin.sin_addr), 18);
		strncpy_s (atestationIP, 18, inet_ntoa(acc_sin.sin_addr), 18);
		if (AnswerSend(localSocket, atestationIP, mylimit, rc, strErr))
		{
			if (rc >=	0)
			{
				char strLimit[256];
				char header[128];
				if (mylimit	>= 0)
				{
					//sprintf	(header	,"");
					sprintf_s	(header, 128	,"");
					normal = true;
				}
				else 
					{
						normal = false;
						//sprintf	(header, "");
						sprintf_s	(header, 128, "");
						mylimit	*= -1;
					}

				double realLimit;
				realLimit	=	double(mylimit)/1048576.0;

				//sprintf	(strLimit, "%s %3.2f Mb",	header,	realLimit);
				sprintf_s	(strLimit, 256, "%s %3.2f Mb",	header,	realLimit);
				myAddStr(strLimit);
			}//if	(rc	>= 0)
				else 
					{
						myAddStr(" LDAP ");
					}
		}
			else 
			{
				myAddStr(" ");
				myAddStr(strErr);
				must_send_end = true;
			}
		UpdateWindow(hWnd);
		RedrawWindow(hWnd, NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE );

		closesocket(localSocket);
	/*
  //   
  connect_socket = accept (serv_sock, (LPSOCKADDR)&acc_sin, (int FAR *)&acc_sin_len);
  if(connect_socket == INVALID_SOCKET)
  {
   MessageBox(NULL, strerror(WSAGetLastError()), "Connect Error", MB_ICONERROR + MB_OK);
   return;
  }

	//        
  // ,     
  //  WSA_NETEVENT.
  //            WSAEVENT
  rc = WSAAsyncSelect (connect_socket , hWnd, WSA_NETEVENT, FD_READ  | FD_CLOSE );
  if(rc > 0)
  {
    closesocket (connect_socket);
    MessageBox(NULL, strerror(rc), "WSAAsyncSelect  Error", MB_ICONERROR + MB_OK);
  }*/
}
bool __stdcall AnswerSend(SOCKET localSocket, char *attIP, int &myLimit, int &rc, char *strErr)
{
	const int szBuff = 1024;
	char *specString = "<EOF>";
	char UserLine[szBuff], NameUser[szBuff];
	char trafficLine[szBuff];
	char seps [] = " :;\0\n";
	char infoStr[szBuff];
	
	int bytesSent, bytesRecv;
	char send_buff[szBuff] = "";
	char recv_buff[szBuff] = "";
	char recv_buff2[szBuff] = "";

//MessageBox(NULL, "get Squid answer", "Info", MB_OK);
	char *myStr, *myServName, *myServIPstr, *myRegistrationTimeStr, *beginStr = "from->";
					char *aBeginStr = "Attestation rest->", *myLimitStr, *rcStr, *limitStr, *next_tok;


	line_count = 0;

	hostent* remoteHost;
	char localHostName[255], localIPstr[18];
	int my_error;
	my_error = gethostname(localHostName, 18);
	if (my_error == 0)
	{
		remoteHost = gethostbyname(localHostName);
		//sprintf (localIPstr, "%s", inet_ntoa(*((struct in_addr *)remoteHost->h_addr_list[0])));
		sprintf_s (localIPstr, 18, "%s", inet_ntoa(*((struct in_addr *)remoteHost->h_addr_list[0])));
	}
	else
	{
		myAddStr("    ");
	}

	if (definition(UserLine, NameUser, trafficLine, strErr))
	{
		char *Begin;
		//Begin = strstr(UserName, "CN=");
		Begin = strstr(UserLine, "cn=");
		if (Begin != NULL)
		{
			//sprintf (strErr, "SendingName");
			sprintf_s (strErr, 1024, "SendingName");
			
			char *DaemonIP, *DaemonPort, *ListenPort;
			//sprintf (FullName, "%s", UserLine);
			sprintf_s (FullName, 1024, "%s", UserLine);
			//sprintf (infoStr, " - %s", NameUser);
			sprintf_s (infoStr, 1024, " - %s", NameUser);
			myAddStr(infoStr);
			//if ((DaemonIP = strtok(trafficLine, ":")) != NULL)
			if ((DaemonIP = strtok_s(trafficLine, ":", &next_tok)) != NULL)
			{
				//redirect_serv_addr = DaemonIP;
				//if ((DaemonPort = strtok(NULL, ":;")) != NULL)
				if ((DaemonPort = strtok_s(NULL, ":;", &next_tok)) != NULL)
				{
					//sprintf (infoStr, "  %s:%s", DaemonIP, DaemonPort);
					//myAddStr(infoStr);
					//if ((ListenPort = strtok(NULL, ":;")) != NULL)
					if ((ListenPort = strtok_s(NULL, ":;", &next_tok)) != NULL)
					{
#ifndef TEST_SERV
				//sprintf (redirect_serv_addr, DaemonIP);
				sprintf_s (redirect_serv_addr, 18, DaemonIP);
					registration_port = atoi(DaemonPort);
						listen_port = atoi(ListenPort);
						//sprintf (infoStr, "  %s:%s   %s ", DaemonIP, DaemonPort, ListenPort);
						//sprintf (infoStr, "  %s  %d ", attIP, listen_port);
						sprintf_s (infoStr, 1024, "  %s  %d ", attIP, listen_port);
						myAddStr(infoStr);
#else 
		//sprintf (infoStr, " %s:%d   %d ", redirect_serv_addr, registration_port, listen_port);
		sprintf (infoStr, "  %s  %d ", attIP, listen_port);
		myAddStr(infoStr);
#endif		
						
						//  
						bytesRecv = recv(localSocket, recv_buff, szBuff, 0);
						if ((bytesRecv > 0) && (bytesRecv != WSAECONNRESET))
						{
							myCrypt(recv_buff);
							
							myStr = strstr(recv_buff, beginStr);
							if (myStr != NULL)
							{
								myStr += strlen(beginStr);
								//if ((myServName = strtok(myStr, seps)) != NULL)
								if ((myServName = strtok_s(myStr, seps, &next_tok)) != NULL)
								{
									//if ((myServIPstr = strtok(NULL, seps)) != NULL) 
									if ((myServIPstr = strtok_s(NULL, seps, &next_tok)) != NULL) 
									{
										//if ( (myRegistrationTimeStr = strtok(NULL, seps)) != NULL)
										if ( (myRegistrationTimeStr = strtok_s(NULL, seps, &next_tok)) != NULL)
										{
											time_t myRegistrationTime = atol(myRegistrationTimeStr) + 5;
											char timeStr[50];
											//sprintf(timeStr, "%d", myRegistrationTime);
											sprintf_s(timeStr, 1024, "%d", myRegistrationTime);
											//sprintf (send_buff, "Attestation->%s %s %s \n",		timeStr, UserLine, localIPstr);
											sprintf_s (send_buff, 1024, "Attestation->%s %s %s \n",		timeStr, UserLine, localIPstr);
											myCrypt(send_buff);
											//   
											//bytesSent = send(localSocket, send_buff, int(strlen(send_buff)) + 1, 0);
											bytesSent = send(localSocket, send_buff, int(strlen(send_buff)) + 1, 0);
											if (bytesSent != strlen(send_buff) + 1)
											//if (bytesSent != strlen(send_buff))
											{
												myAddStr ("dont sending verify string");
												//closesocket(out_sock);
												return false;
											}
											bytesRecv = recv(localSocket, recv_buff2, szBuff, 0);
											//bytesRecv = recv(localSocket, recv_buff2, szBuff, 0);
											if ((bytesRecv > 0) && (bytesRecv != WSAECONNRESET))
											{
													myCrypt(recv_buff2);
													//myAddStr(recv_buff2);
												
												if (strchr (recv_buff2, '\n') == NULL) 
												{
													myAddStr ("dont resive end off limit string");
													//sprintf (strErr, "don`t recive first string in registration procedure");
													//closesocket(out_sock);
													return false;
												}
												myLimitStr = strstr(recv_buff2, aBeginStr);
												if (myLimitStr != NULL)
												{
													myLimitStr += strlen(aBeginStr);
													//myAddStr(myLimitStr);
													//if ((limitStr = strtok(myLimitStr, seps)) != NULL)
													if ((limitStr = strtok_s(myLimitStr, seps, &next_tok)) != NULL)
													{
														myLimit = atol(limitStr);
														//if ((rcStr = strtok(NULL, seps)) != NULL)
														if ((rcStr = strtok_s(NULL, seps, &next_tok)) != NULL)
														{
															rc = atol(rcStr);
														}
														else rc = 0;
													}
													else myLimit = 0;

												}//if (myLimitStr != NULL)
												else
													{
														//sprintf (strErr, "Error limit string");
														sprintf_s (strErr, 1024, "Error limit string");
														//myAddStr("  ");
														return false;
													}

											}// 2 if ((bytesRecv > 0) && (bytesRecv != WSAECONNRESET))	
											else 
											{
												myAddStr("  ");
												//sprintf (infoStr, "bytesRecv = %d", bytesRecv);
												//myAddStr(infoStr);
												myAddStr("WSAECONNRESET incoming");
												if (bytesRecv == 0)
													myAddStr("0 size string incoming");
												if (bytesRecv == WSAECONNRESET)
													myAddStr("WSAECONNRESET incoming");


											}

										}
									}
								}
							}
							else 
							{
								myAddStr("  ");
								myAddStr(recv_buff);
							}
							//}

						}
					}//if ((ListenPort = strtok(NULL, ":;")) != NULL)
				}//if ((DaemonPort = strtok(NULL, ":;")) != NULL)
			}


		}//if ((bytesRecv > 0) && (bytesRecv != WSAECONNRESET))
	}
	return true;

}
//---------------------------------------------------------------------------
/*int filter(unsigned int code, struct _EXCEPTION_POINTERS *ep) {

   puts("in filter.");

   if (code == EXCEPTION_ACCESS_VIOLATION) {

      puts("caught AV as expected.");

      return EXCEPTION_EXECUTE_HANDLER;

   }

   else {

      puts("didn't catch AV, unexpected.");

      return EXCEPTION_CONTINUE_SEARCH;

   };

}*/

//bool __stdcall definition(char *myAttrName, char *UserLine, char *sError, bool needName)
bool __stdcall definition(char *UserLine, char *NameUser, char *trafficNet, char *sError)
{
 bool retCode = true;

 NWDSContextHandle contextHandle;
 LCONV               lConvInfo;

 int rCode;
 char loginName[MAX_DN_BYTES];//257
 pBuf_T attrName;
 pBuf_T outBuffer, inBuffer;
 long iterationHandle;
 unsigned long attrIndex, attrValIndex;
 unsigned long attrCount, attrValCount, syntaxID, attrValSize;
 char *attrVal;

 //sprintf (UserLine, "");
 sprintf_s (UserLine, 1024, "");
 outBuffer = NULL;
 rCode = NWCallsInit( NULL, NULL);
 if( rCode != 0 )
  {

   sprintf_s(sError, 1024, "NWCallsInit returned ");
   //sprintf(sError, "NWCallsInit returned ");
   return false;
  }

  NWLlocaleconv(&lConvInfo);
  rCode = NWInitUnicodeTables(lConvInfo.country_id,
                               lConvInfo.code_page);
  if(rCode)
  {
	//sprintf(sError, "NWInitUnicodeTables returned %X", rCode);
	sprintf_s(sError, 1024, "NWInitUnicodeTables returned %X", rCode);
	NWFreeUnicodeTables();
	NWCallsTerm( NULL );
	return false;
  }

	//sprintf (sError, ">");
	sprintf_s (sError, 1024, ">");
try
 {
	rCode = NWDSCreateContextHandle( &contextHandle );
	if( rCode != 0 )
	{
		//sprintf(sError, "NWDSCreateContextHandle returned ");
		throw "NWDSCreateContextHandle error";//return false;
	}
	// Get the user name
	/*rCode = NWDSSetContext(contextHandle, DCK_TREE_NAME, "NIRCTU_TREE");
	if( rCode != 0 )
	{
		sprintf(sError, "NWDSSetContext (DCK_TREE_NAME) returned ");
		throw "NWDSSetContext (DCK_TREE_NAME) error";//return false;
	}*/
	   if (rCode = NWDSSetContext( contextHandle, DCK_NAME_CONTEXT, ""))
		{
			//sprintf(sError, "NWDSSetContext (DCK_NAME_CONTEXT) returned ");
			throw "NWDSSetContext (DCK_NAME_CONTEXT) error";//return false;
		}


	rCode = NWDSWhoAmI( contextHandle, loginName);
	if( rCode != 0 )
	{
		//sprintf(sError, "NWDSWhoAmI returned ");
		throw "NWDSWhoAmI error";//return false;
	}
		sprintf_s (UserLine, 1024, "%s", loginName);
		//sprintf (UserLine, "%s", loginName);

		if (strstr (UserLine, ".") == NULL)
		{
				char context_and_tree[1024];
				rCode = NWDSGetContext (contextHandle, DCK_NAME_CONTEXT, context_and_tree);
				if( rCode != 0 )
				{
					//sprintf(sError, "NWDSGetContext returned ");
					throw "NWDSGetContext error";//return false;
				}
			char *firstWorld, *secondWorld, *next_tok; 
			//firstWorld = strtok (context_and_tree, ".");
			firstWorld = strtok_s (context_and_tree, ".", &next_tok);
			//while ( (secondWorld = strtok (NULL, ".")) != NULL)
			while ( (secondWorld = strtok_s (NULL, ".", &next_tok)) != NULL)
			{
				sprintf_s (UserLine, 1024, "%s,ou=%s", UserLine, firstWorld);
				//sprintf (UserLine, "%s,ou=%s", UserLine, firstWorld);
				firstWorld = secondWorld;
			}
			sprintf_s (UserLine, 1024, "%s,o=%s", UserLine, firstWorld);
//			sprintf (UserLine, "%s,o=%s", UserLine, firstWorld);
		}
		else 
		{
			char *pdest;
			while ( (pdest = strstr (UserLine, ".")) != NULL)
			{
				*pdest = ',';
			}
			/*char *p;
		    for( p = UserLine; p < UserLine + strlen( UserLine ); p++ )
			{
				if ( isascii(* p) )
				{
					if( isupper( *p ) )
						*p = _tolower( *p );
				}
			}*/
			stringToLow (UserLine);
		//destroy?????
			/*if (strstr (UserLine, "nirctu") == NULL)
			{
				if (UserLine[strlen(UserLine)-1] == ',')
					sprintf (UserLine, "%sO=%s", UserLine, "NIRCTU");
				else 
					sprintf (UserLine, "%s,O=%s", UserLine, "NIRCTU");
			}*/
		}

	if (strstr(loginName, "[Public]") != NULL)
	{
		throw " ";
	}
	///+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	// Allocate & Initialize the results buffer
		rCode = NWDSAllocBuf( DEFAULT_MESSAGE_LEN, &attrName);
		if( rCode != 0 ) 
		{
			//sprintf(sError, "NWDSAllocBuf() for attrName returned ");
			throw "NWDSAllocBuf (attrName) error";//return false;
		}
		rCode = NWDSInitBuf( contextHandle, DSV_READ, attrName );
		if( rCode != 0 ) 
		{
			//sprintf(sError, "NWDSInitBuf() for attrName returned ");
			throw "NWDSInitBuf (attrName) error";//return false;
		}

		  
	rCode = NWDSAllocBuf( DEFAULT_MESSAGE_LEN, &outBuffer );
	if( rCode != 0 ) 
	{
		//sprintf(sError, "NWDSAllocBuf() for outBuffer returned ");
		throw "NWDSAllocBuf (outBuffer) error";//return false;
	}
	// Allocate & Initialize the input buffer
	rCode = NWDSAllocBuf( DEFAULT_MESSAGE_LEN, &inBuffer );
	if( rCode != 0 )
	{
		//sprintf(sError, "NWDSAllocBuf() for inBuffer returned ");
		throw "NWDSAllocBuf (inBuffer) error";//return false;
	}
	rCode = NWDSInitBuf( contextHandle, DSV_READ, inBuffer );
	if( rCode != 0 )
	{
		//sprintf(sError, "NWDSInitBuf returned ");
		throw "NWDSInitBuf (inBuffer) error";//return false;
	}

//????????????????????????????????????????????????????????????????????????????????????????????????????????
	vector <SattrInfo> myInfo;
	myInfo.clear();
	if (mySearchAttr( contextHandle, attrName, outBuffer, inBuffer, loginName, "Full Name", myInfo, sError))
	{
		if (!myInfo.empty())
		{
			//char nameStr[256];
			unsigned int c;
			for (c = 0; c < myInfo.size(); ++c)
			{
				//sprintf (nameStr, "[%d] - %s", c, myInfo[c].str);
				//myAddStr(nameStr);
				strncpy_s (NameUser, 1024, myInfo[c].str, 1024);
				//strncpy (NameUser, myInfo[c].str, 1024);
			}
		}
	}
	else 
	{
		//myAddStr (sError);
		//throw "not find name";
		myInfo.clear();
		if (mySearchAttr( contextHandle, attrName, outBuffer, inBuffer, loginName, "Given Name", myInfo, sError))
		{
			if (!myInfo.empty())
			{
				//char nameStr[256];
				unsigned int c;
				for (c = 0; c < myInfo.size(); ++c)
				{
					//sprintf (nameStr, "[%d] - %s", c, myInfo[c].str);
					//myAddStr(nameStr);
					strncpy_s (NameUser, 1024, myInfo[c].str, 1024);
					//strncpy (NameUser, myInfo[c].str, 1024);				
				}
			}
		}
		else
		{
			myInfo.clear();
			if (mySearchAttr( contextHandle, attrName, outBuffer, inBuffer, loginName, "sn", myInfo, sError))
			{
				if (!myInfo.empty())
				{
					//char nameStr[256];
					unsigned int c;
					for (c = 0; c < myInfo.size(); ++c)
					{
						//sprintf (nameStr, "[%d] - %s", c, myInfo[c].str);
						//myAddStr(nameStr);
						strncpy_s (NameUser, 1024, myInfo[c].str, 1024);
						//strncpy (NameUser, myInfo[c].str, 1024);
					}
				}
			}
		}
	}
	myInfo.clear();

//========================================================================================================
	bool member_of_Inet = false;
	//char groupStr[256][1024];
	//int groupCount = 0;
	vector <SattrInfo> groupStr;
	groupStr.clear();

	rCode = NWDSPutAttrName( contextHandle, inBuffer, pnstr8("Group Membership") );//get my attribut
	if( rCode != 0 )
	{
		//sprintf(sError, "NWDSPutAttrName returned ");
		//sprintf_s(sError, 1024, "NWDSPutAttrName returned ");
		throw "NWDSPutAttrName error";//return false;
	}
	// Read the data
	iterationHandle = NO_MORE_ITERATIONS;
	do
	{
		rCode = NWDSRead( contextHandle, loginName, DS_ATTRIBUTE_VALUES, N_FALSE, inBuffer, &iterationHandle, outBuffer );
		if( rCode != 0 ) 
		{
			//sprintf(sError, "NWDSRead returned error");
			throw "NWDSRead error";//return false;
		}
		rCode = NWDSGetAttrCount( contextHandle, outBuffer, &attrCount );
		if( rCode != 0 )
		{
			//sprintf(sError, "NWDSGetAttrCount()  returned ");
			throw "NWDSGetAttrCount error";//return false;
		}
		for (attrIndex = 1; attrIndex <= attrCount; attrIndex ++ )
		{
			// Find the attribute in the buffer
			rCode = NWDSGetAttrName( contextHandle, outBuffer, (pnstr8)attrName, &attrValCount, &syntaxID );
			if( rCode != 0 )
			{
	 			//sprintf(sError, "NWDSGetAttrName()  returned ");
				throw "NWDSGetAttrName error";//return false;
			}
			// Read the values
			for (attrValIndex = 1; attrValIndex <= attrValCount; attrValIndex++)
			{
				// Compute the size of the value
				rCode = NWDSComputeAttrValSize( contextHandle, outBuffer, syntaxID, &attrValSize );
				if( rCode != 0 )
				{
	 				//sprintf(sError, "NWDSComputeAttrValSize()  returned ");
					throw "NWDSComputeAttrValSize error";//return false;
				}

				// Allocate memory
				attrVal = (char *) malloc(attrValSize);
				if( attrVal == NULL )
				{
	 				//sprintf(sError, "Insufficient memory AttrVal buffer  returned ");
					throw "malloc error";//return false;
				}
				// Get the value
				rCode = NWDSGetAttrVal( contextHandle, outBuffer, syntaxID, nptr(attrVal) );
				if( rCode != 0 )
				{
	 				//sprintf(sError, "NWDSGetAttrVal()  returned ");
					throw "NWDSGetAttrVal error";//return false;
				}
				//if (strstr(attrVal, "OU=Inet.O=NIRCTU") != NULL)
				char attrStr[1024];
				sprintf_s (attrStr, 1024, "%s", attrVal);
				stringToLow(attrStr);
				//if (strstr(attrVal, "OU=Inet") != NULL)
				if (strstr(attrStr, "ou=inet") != NULL)
				{
					member_of_Inet = true;
					//strncpy (groupStr[groupCount], attrVal, 255);
					SattrInfo groupName;
					strncpy_s (groupName.str, 1024, attrVal, 255);
					groupStr.push_back(groupName);
					//groupCount ++;
				}

				// Release memory
				if( attrVal != NULL )
					free( attrVal );
			}  // for - Each value
		}  // for
	} while( iterationHandle != NO_MORE_ITERATIONS );

	if (!member_of_Inet) 
		throw "   ";
	unsigned int i;
	member_of_Inet = false;
	//========================================================================================================
	rCode = NWDSPutAttrName( contextHandle, inBuffer, pnstr8("auxNetArray") );//get my attribut
	if( rCode != 0 )
	{
		//sprintf(sError, "NWDSPutAttrName returned ");
		throw "NWDSPutAttrName error 2";//return false;
	}
	// Read the data
	//strncpy(trafficNet, "", 255);
	strncpy_s(trafficNet, 1024, "", 255);// _TRUNCATE
	iterationHandle = NO_MORE_ITERATIONS;
	for (i = 0; i < groupStr.size(); ++i)
	//for (i = 0; i < groupCount; ++i)
	{
		do
		{
			rCode = NWDSRead( contextHandle, groupStr[i].str, DS_ATTRIBUTE_VALUES, N_FALSE, inBuffer, &iterationHandle, outBuffer );
			if( rCode != 0 ) 
			{
				//sprintf(sError, "NWDSRead returned error");
				sprintf_s(sError, 1024, "NWDSRead returned error");
				//throw "NWDSRead error 2";
				break;
			}
			else 
			{
				member_of_Inet = true;
				myAddStr (groupStr[i].str);
			}
			rCode = NWDSGetAttrCount( contextHandle, outBuffer, &attrCount );
			if( rCode != 0 )
			{
				//sprintf(sError, "NWDSGetAttrCount()  returned ");
				throw "NWDSGetAttrCount error 2";//return false;
			}
			for (attrIndex = 1; attrIndex <= attrCount; attrIndex ++ )
			{
				// Find the attribute in the buffer
				rCode = NWDSGetAttrName( contextHandle, outBuffer, (pnstr8)attrName, &attrValCount, &syntaxID );
				if( rCode != 0 )
				{
//	 				sprintf(sError, "NWDSGetAttrName()  returned ");
	 				sprintf_s(sError, 1024, "NWDSGetAttrName()  returned ");
					throw "NWDSGetAttrName error 2";//return false;
				}
				// Read the values
				for (attrValIndex = 1; attrValIndex <= attrValCount; attrValIndex++)
				{
					// Compute the size of the value
					rCode = NWDSComputeAttrValSize( contextHandle, outBuffer, syntaxID, &attrValSize );
					if( rCode != 0 )
					{
	 					//sprintf(sError, "NWDSComputeAttrValSize()  returned ");
						throw "NWDSComputeAttrValSize error 2";//return false;
					}

					// Allocate memory
					attrVal = (char *) malloc(attrValSize);
					if( attrVal == NULL )
					{
	 					//sprintf(sError, "Insufficient memory AttrVal buffer  returned ");
						throw "malloc error 2";//return false;
					}
					// Get the value
					rCode = NWDSGetAttrVal( contextHandle, outBuffer, syntaxID, nptr(attrVal) );
					if( rCode != 0 )
					{
	 					//sprintf(sError, "NWDSGetAttrVal()  returned ");
						throw "NWDSGetAttrVal error 2";//return false;
					}
					//strcat (trafficNet, attrVal);
					//strcat (trafficNet, ";");
					strcat_s (trafficNet, 1024, attrVal);
					strcat_s (trafficNet, 1024, ";");

					// Release memory
					if( attrVal != NULL )
						free( attrVal );
				}  // for - Each value
			}  // for
				//member_of_Inet = true;
		} while( iterationHandle != NO_MORE_ITERATIONS );
	}
	if (!member_of_Inet) throw "   ";


 }
catch(char * str)
{
	retCode = false;
	//sprintf (sError, ": %s ", str);
	sprintf_s (sError, 1024, ": %s ", str);
}

	if(attrName)
	{
			NWDSFreeBuf(attrName);
	}
	if (inBuffer)
	{
		NWDSFreeBuf( inBuffer );
	}
	if (outBuffer)
	{
		NWDSFreeBuf( outBuffer );
	}
	// Release context handle
	NWDSFreeContext( contextHandle );
    // Release memory
	NWFreeUnicodeTables();

  NWCallsTerm( NULL );

	return retCode;
}

void stringToLow(char *stringline)
{
	char *p;
	for( p = stringline; p < stringline + strlen( stringline ); p++ )
	{
		if ( isascii(* p) )
		{
			if( isupper( *p ) )
				*p = _tolower( *p );
		}
	}
}

//bool mySearchAttr( NWDSContextHandle &contextHandle, pBuf_T &attrName, pBuf_T &outBuffer, pBuf_T &inBuffer, 
bool mySearchAttr( NWDSContextHandle &contextHandle, pBuf_T attrName, pBuf_T outBuffer, pBuf_T inBuffer, 
				  char *loginName, const char *myAttrName, vector <SattrInfo> &myInfo, char *myError)
{
 unsigned long attrIndex, attrValIndex, attrCount, attrValCount, syntaxID, attrValSize;
 char *attrVal;
 int rCode;//, i;
 long iterationHandle;
 SattrInfo myAttrInfo;

	try
	{
		rCode = NWDSPutAttrName( contextHandle, inBuffer, pnstr8(myAttrName) );//get my attribut
		if( rCode != 0 )
		{
			//sprintf(sError, "NWDSPutAttrName returned ");
			throw "NWDSPutAttrName error mySearchAttr";//return false;
		}
		// Read the data
		iterationHandle = NO_MORE_ITERATIONS;
		do
		{
			rCode = NWDSRead( contextHandle, loginName, DS_ATTRIBUTE_VALUES, N_FALSE, inBuffer, &iterationHandle, outBuffer );
			if( rCode != 0 ) 
			{
				//sprintf(sError, "NWDSRead returned error");
				throw "NWDSRead error mySearchAttr";
				//break;
			}

			rCode = NWDSGetAttrCount( contextHandle, outBuffer, &attrCount );
			if( rCode != 0 )
			{
				//sprintf(sError, "NWDSGetAttrCount()  returned ");
				throw "NWDSGetAttrCount error mySearchAttr";
			}
			for (attrIndex = 1; attrIndex <= attrCount; attrIndex ++ )
			{
				// Find the attribute in the buffer
				rCode = NWDSGetAttrName( contextHandle, outBuffer, (pnstr8)attrName, &attrValCount, &syntaxID );
				if( rCode != 0 )
				{
 					//sprintf(sError, "NWDSGetAttrName()  returned ");
					throw "NWDSGetAttrName error mySearchAttr";
				}

				// Read the values
				for (attrValIndex = 1; attrValIndex <= attrValCount; attrValIndex++)
				{
					// Compute the size of the value

					rCode = NWDSComputeAttrValSize( contextHandle, outBuffer, syntaxID, &attrValSize );
					if( rCode != 0 )
					{
 						//sprintf(sError, "NWDSComputeAttrValSize()  returned ");
						throw "NWDSComputeAttrValSize error mySearchAttr";
					}

					// Allocate memory
					attrVal = (char *) malloc(attrValSize);
					if( attrVal == NULL )
					{
 						//sprintf(sError, "Insufficient memory AttrVal buffer  returned ");
						throw "malloc error mySearchAttr";
					}
					// Get the value
					rCode = NWDSGetAttrVal( contextHandle, outBuffer, syntaxID, nptr(attrVal) );
					if( rCode != 0 )
					{
 						//sprintf(sError, "NWDSGetAttrVal()  returned ");
						throw "NWDSGetAttrVal error mySearchAttr";
					}
					//sprintf (myAttrInfo.str, "%s", attrVal);
					sprintf_s (myAttrInfo.str, 1024, "%s", attrVal);
					//sprintf (myAttrInfo.str, "%s[%d][%d]=%s", attrName, attrIndex, attrValIndex, attrVal);
					myInfo.push_back(myAttrInfo);

					if( attrVal != NULL )
						free( attrVal );
				}  // for - Each value
			}  // for
		} while( iterationHandle != NO_MORE_ITERATIONS );
	}
	catch(char * str)
	{
		//sprintf (myError, "exeption: %s ", str);
		sprintf_s (myError, 1024, "exeption: %s ", str);
		return false;
	}
	return true;
}

void __stdcall myAddStr(char *addstr)
{
	if (line_count >= max_line) line_count = 0;
	//sprintf(mytext[line_count], addstr);
	sprintf_s(mytext[line_count], 1024, addstr);
	line_count++;
}
