
#include <time.h>
#include <mysql.h>
#include "squid2sql.h"
//#include "ldap2sql.h"

#define BUFFER_SIZE             (8*1024)
extern char *localName [];

bool mustWork;
char localDir[1024], logDir[1024], pidFile[1024], logFileName[1024], backUpLog[1024], unKnownLog[1024];
char effective_user[256], effective_group[256], squidPid[256], squidLog[256];

/*char *host = "192.168.1.3";
unsigned int port = 6612;
char *username = "root";
//char *password = "raptor";
char *password = "";
char *database = "trafficdb";*/
//const char *unix_socket = "/usr/local/mysql/mysql5.sock";

const int udateTime = 60;

ServerInfo servInfo;
MYSQL mysql;

ServerInfo& ServerInfo::operator = (ServerInfo &si)
{
	uint i;
	for (i = 0; i < si.myVectorAttrs.size(); ++i)
		myVectorAttrs.push_back(si.myVectorAttrs[i]);
	needSSL = si.needSSL;
	port = si.port;

	strncpy (ldapServer, si.ldapServer, 255);
	strncpy (host, si.host, 255);
	strncpy (username, si.username, 255);
	strncpy (password, si.password, 255);
	strncpy (database, si.database, 255);
	strncpy (LDAPlogin, si.LDAPlogin, 255);
	strncpy (LDAPpassword, si.LDAPpassword, 255);

	return *this;
};

void stopLogPipre(int signum)
{
	mustWork = false;
	saveLog(true, "recive TERM signal\n");
	sleep(3);
	saveLog (true, "exit in stopLogPipre function\n");
		//mysql_close(&mysql);
		//mysql_library_end();

	exit(0);
}

int main (int argc, char *argv[])
{
	
	/*sprintf (logDir, "/usr/novell/sys/mySQUID/sqlbase");
	sprintf (logFileName, "%s/squid2sql.log", logDir);
	sprintf (pidFile, "%s/squid2sql.pid", logDir);
	sprintf (backUpLog, "%s/backUp.Log", logDir);
	sprintf (unKnownLog, "%s/unKnown.Log", logDir);

	sprintf (squidPid, "/usr/local/squid/var/logs/squid.pid");
	sprintf (squidLog, "/usr/local/squid/var/logs/access.log");

	snprintf (effective_user, 256, "tsquid");
	snprintf (effective_group, 256, "tsquidgroup");*/

	char *infStr;
	char seps [] = " ;\0\n";

	char infFileName[1024], ldapStr[1024];;
	//snprintf (infFileName, 1024, "squid_daemon.inf");
	//snprintf (infFileName, 1024, "/usr/novell/sys/mySQUID/sqlbase/squid2sql.inf");
	snprintf (infFileName, 1024, "/usr/novell/sys/mySQUID/full.inf");


	char *iFN;
	if (argc > 1)
	{
		if ((infStr = strstr(argv[1], "--inf=")) != NULL )
		{
			infStr += strlen("--inf=");
			if ((iFN = strtok(infStr, seps)) != NULL)
			{
				snprintf (infFileName, 1024, "%s", iFN);
			}
			
		}
	}

	FILE *infoFile;
	infoFile = fopen (infFileName, "r");
	char rBuf [4096];
	if (infoFile != NULL)
	{
		int countii = 0;
		int numberVariable = 16;
		printf ("open inf file\n");
		while (fgets(rBuf, 4096, infoFile) != NULL)
		{
			int ii;
			//char *configMass [] = {"workDir",
			char *configMass [] = {"squid2sqlDir",
									"logDir",
									"effective_user",
									"effective_group",
									"ldapAttr",
									"useSSL",
									"MySQLuser",
									"MySQLpassword",
									"MySQLserver",
									"MySQLport",
									"MySQLbase",
									"ldapServer",
									"ldapLogin",
									"ldapPassword",
									"squidPid",
									"squidLog"
									};

			char *confString, *configMean;

			for (ii = 0; ii < numberVariable; ++ii)
			{
				if ((confString = strstr(rBuf, configMass[ii])) != NULL)
				{
					countii ++;
					confString += strlen (configMass[ii]);
					if ((configMean = strtok(confString, seps)) != NULL)
					{
						switch (ii)
						{
							case 0: snprintf (localDir, 256, "%s", configMean);
								printf ("localDir - %s +\n", localDir);
								break;
							case 1: snprintf (logDir, 1024, "%s", configMean);
								printf ("logDir - %s +\n", logDir);
								break;
							case 2: snprintf (effective_user, 256, "%s", configMean);
								printf ("effective_user - %s +\n", effective_user);
								break;
							case 3: snprintf (effective_group, 256, "%s", configMean);
								printf ("effective_group - %s +\n", effective_group);
								break;
							case 4: snprintf (ldapStr, 1024, "%s", configMean);
								printf ("ldapStr - %s +\n", ldapStr);
								break;
							case 5: if (strstr (configMean, "true"))
									 {
										servInfo.needSSL = true;
										 printf ("needSSL - true +\n");
									 }
									 else
									 {
										 servInfo.needSSL = false;
										printf ("neddSSL - false +\n");
									 }
								break;
							case 6: snprintf (servInfo.username, 255, "%s", configMean);
								printf ("MySQL username - %s +\n", servInfo.username);
								break;
							case 7: snprintf (servInfo.password, 255, "%s", configMean);
								printf ("MySQL password - %s +\n", servInfo.password);
								break;
							case 8: snprintf (servInfo.host, 255, "%s", configMean);
								printf ("MySQL host - %s +\n", servInfo.host);
								break;
							case 9: servInfo.port = atoi(configMean);
								printf ("MySQL port - %d +\n", servInfo.port);
								break;
							case 10: snprintf (servInfo.database, 255, "%s", configMean);
								printf ("MySQL base - %s +\n", servInfo.database);
								break;
							case 11: snprintf (servInfo.ldapServer, 256, "%s", configMean);
								snprintf (servInfo.ldapServer, 256, "%s", configMean);
								printf ("ldapServer - %s +\n", servInfo.ldapServer);
								break;
							case 12: snprintf (servInfo.LDAPlogin, 255, "%s", configMean);
								printf ("LDAPlogin - %s +\n", servInfo.LDAPlogin);
								break;
							case 13: snprintf (servInfo.LDAPpassword, 255, "%s", configMean);
								printf ("LDAPpassword - %s +\n", servInfo.LDAPpassword);
								break;
							case 14: snprintf (squidPid, 255, "%s", configMean);
								printf ("squidPid - %s +\n", squidPid);
								break;
							case 15: snprintf (squidLog, 255, "%s", configMean);
								printf ("squidLog - %s +\n", squidLog);
								break;
						}
					}
				}
			}

		}
		fclose (infoFile);
		if (countii < numberVariable)
		{
			printf ("Not full inf file\n");
			exit (0);
		}
	}
	else
		{
			printf ("Cannot open Squid2SQL inf file !!!\n");
			exit (0);
		}
	char *getAttr;
	char sep2 [] = ",\0\n"; 
	getAttr = strtok (ldapStr, sep2);
		myString ms;
	while (getAttr != NULL)
	{
		printf ("Attr - %s\n", getAttr);
		strncpy (ms.str, getAttr, 255);
		servInfo.myVectorAttrs.push_back (ms);
		getAttr = strtok (NULL, sep2);
	}

	sprintf (logFileName, "%s/squid2sql.log", logDir);
	sprintf (pidFile, "%s/squid2sql.pid", localDir);
	sprintf (backUpLog, "%s/backUp.Log", logDir);
	sprintf (unKnownLog, "%s/unKnown.Log", logDir);


	FILE *dF;
	//char rBuf[1024];
	int myPid = -1;
	dF = fopen(pidFile, "r");
	if (dF != NULL)
	{
		if (fgets(rBuf, 255, dF) != NULL)
		{
			myPid = atoi(rBuf);
			//saveLog (true, " read pid=%d\n", pid);
				if (myPid > 0)
				{
						if (kill(myPid, 0) >= 0)
					{

						//saveLog (true, "squid2sql already run!!!\n");
						printf ("squid2sql already run!!!\n");
						exit (0);
					}
				}
		}
			//else saveLog (true, "cannot read pid file\n");
		fclose (dF);
	}
		else saveLog (true, "cannot open pid file\n");
	
	struct passwd *eUserPasswd;
	eUserPasswd = getpwnam (effective_user);
	struct group *eGroup;
	eGroup = getgrnam (effective_group);
	if (eUserPasswd != NULL)
		if (eGroup != NULL)
	{
		FILE *fp;
		fp = fopen(logFileName,"a+");
		if (fp != NULL)
		{
			fclose(fp);
			if (chown(logFileName, eUserPasswd->pw_uid, eGroup->gr_gid) != 0)
				saveLog(true, "change logFileName owner error\n");
		}

		fp = fopen(backUpLog,"a+");
		if (fp != NULL)
		{
			fclose(fp);
			if (chown(backUpLog, eUserPasswd->pw_uid, eGroup->gr_gid) != 0)
				saveLog(true, "change backUpLog owner error\n");
		}

		fp = fopen(unKnownLog,"a+");
		if (fp != NULL)
		{
			fclose(fp);
			if (chown(unKnownLog, eUserPasswd->pw_uid, eGroup->gr_gid) != 0)
				saveLog(true, "change unKnownLog owner error\n");
		}	
	}

	
	//saveLog(true, "run fork\n");
	struct sigaction act;
  mustWork = true;
	myPid = fork();
  
	switch(myPid) 
  {
	case 0:
	    setsid();
	    chdir("/");

	    close(0);
	    close(1);
	    close(2);

	    memset(&act, 0, sizeof(act));
	    act.sa_handler = stopLogPipre;
	    sigaction(SIGTERM, &act, NULL);

	    logPipe();
			//startParent();
	    saveLog (true, "exit logPipe daemon\n");
	    exit(0);

	case -1:
	    saveLog (true, "fork() error\n");
	    break;

	default:
		dF = fopen(pidFile, "w");
		if (dF != NULL)
		{
			fprintf (dF, "%d\n", myPid);
			fclose (dF);
		}
		 else 
			saveLog (true, "Cannot save pid file !!!\n");

	    saveLog (true, "pid = %d\n", myPid);
	    break;
    }
}

void stopLogPipreChild(int signum)
{
	mustWork = false;
	saveLog(true, "recive TERM signal in Child\n");
	sleep(3);
	saveLog (true, "exit in stopLogPipreChild function\n");
		mysql_close(&mysql);
		mysql_library_end();
	exit(0);
}

/*void startParent()
{
	mustWork = true;
	do
	{
		logPipe();
		if (childPid > 0)
			waitpid(0, 0, 0);
	}while (mustWork);
}*/
void logPipe()
{
	struct sigaction act;
  
	int childPid;
	while (mustWork)
	{
		saveLog (true, "+++++++++++++++++++++++++++++++START PARENT+++++++++++++++++++++++++++++++++\n");
		mustWork = true;
		childPid = fork();
		switch(childPid) 
		{
		case 0:
				memset(&act, 0, sizeof(act));
				act.sa_handler = stopLogPipreChild;
				sigaction(SIGTERM, &act, NULL);

				logPipeChild();
				//startParent();
				saveLog (true, "exit logPipeChild daemon\n");
				exit(0);

		case -1:
				saveLog (true, "child fork() error\n");
				break;

		default:
			/*dF = fopen(pidFile, "w");
			if (dF != NULL)
			{
				fprintf (dF, "%d\n", myPid);
				fclose (dF);
			}
			else 
				saveLog (true, "Cannot save pid file !!!\n");
			*/
				saveLog (true, "childpid = %d\n", childPid);
				if (childPid > 0)
					waitpid(0, 0, 0);
				break;
		}	
	}
}

bool readUserInfo(MYSQL &loc_mysql, userInfo &myUserInfo)
{
	char sqlStr[BUFFER_SIZE];
	MYSQL_RES *res;
	MYSQL_ROW row;
	//userInfo getInfo;
		/*snprintf (sqlStr, BUFFER_SIZE , "SELECT limitName,groupName,userLimit,userTraffic,userCacheTraffic,fromUserTraffic,lastUpdate,month,year FROM userGroups WHERE userName=\"%s\"", 
									myUserInfo.userName);
		if (mysql_query(&loc_mysql, sqlStr))
		{
			saveLog(true, "select from userGroups error - %s\n", mysql_error(&loc_mysql));
			return false;
		}
		if ((res = mysql_store_result(&loc_mysql)) == NULL)
		{
			saveLog(true, "store result from userGroups error - %s\n", mysql_error(&loc_mysql));
		 return false;
		}
		while((row = mysql_fetch_row(res))) 
		{
			if (mysql_num_fields(res) >= 9)
			{
				//for (n = 0 ; n < 3; ++n)
				//n = 0;
				//while (allLimitNames[n] != NULL)
				//{
				//	if (strstr(row[0], allLimitNames[n]) != NULL)
				//	{
						//uint count;
						//for (count = 0; count < localInfo.allLimits[n].size(); count ++)
						//{
							attrName locAttr(row[1]);
							//strncpy (locAttr.groupName, row[1]);
							locAttr.Limit = atoi(row[2]);
							locAttr.Traffic = atoi(row[3]);
							locAttr.CacheTraffic = atoi(row[4]);
							locAttr.fromUser = atoi(row[5]);
							
							myUserInfo.lastUpdate = atoi(row[6]);

							myUserInfo.month = atoi(row[7])-1;
							myUserInfo.year = atoi(row[8])-1900;

							uint lc;
							bool findlimitName = false;
							for (lc = 0; lc < myUserInfo.userLimits.size(); ++lc)
							{
								if (strstr(myUserInfo.userLimits[lc].limitName, row[0])!= NULL)
								{
									myUserInfo.userLimits[lc].limitInfo.push_back(locAttr);
									if ((strstr(myUserInfo.userLimits[lc].limitName, "ADSunderArray")!= NULL) && 
										((myUserInfo.userLimits[lc].value == -1) || (locAttr.Limit == -1)))
													myUserInfo.userLimits[lc].value = -1;
									else
										myUserInfo.userLimits[lc].value += locAttr.Limit;
										myUserInfo.userLimits[lc].inet += locAttr.Traffic;
										myUserInfo.userLimits[lc].cache += locAttr.CacheTraffic;
										myUserInfo.userLimits[lc].toinet += locAttr.fromUser;
									findlimitName = true;
									break;
								}
							}
							if (!findlimitName)
							{
								limitArray firstLimit(row[0]);
								int coint = myUserInfo.userLimits.size();
								myUserInfo.userLimits.push_back(firstLimit);
								myUserInfo.userLimits[coint].limitInfo.push_back(locAttr);
									myUserInfo.userLimits[coint].value += locAttr.Limit;
									myUserInfo.userLimits[coint].inet += locAttr.Traffic;
									myUserInfo.userLimits[coint].cache += locAttr.CacheTraffic;
									myUserInfo.userLimits[coint].toinet += locAttr.fromUser;
							}
						//}
						//strncpy (locAttr, row[0], 256);
					//}
					//n++;
				//}
			}
			else
				{
					saveLog(true, "don`t get need number of elements from mySQL\n");
					return false;
				}
				
		}
	      
		if (!mysql_eof(res))
		{
			saveLog(true, "not end of row - %s\n", mysql_error(&loc_mysql));
			return false;
		}
		mysql_free_result(res);*/
	int n = 0;
	while (localName[n] != NULL)
	{
		snprintf (sqlStr, BUFFER_SIZE , "SELECT limitName,groupName,userLimit,userTraffic,userCacheTraffic,fromUserTraffic,lastUpdate FROM squid2sqlData WHERE userName=\"%s\" AND limitName=\"%s\"", 
									myUserInfo.userName,
									localName[n]);
//		snprintf (sqlStr, BUFFER_SIZE , "SELECT limitName,groupName,userLimit,userTraffic,userCacheTraffic,fromUserTraffic,lastUpdate FROM squid2sqlData WHERE userName=\"%s\"", 
//									myUserInfo.userName);
		if (mysql_query(&loc_mysql, sqlStr))
		{
			saveLog(true, "select from squid2sqlData error - %s\n", mysql_error(&loc_mysql));
			return false;
		}
		if ((res = mysql_store_result(&loc_mysql)) == NULL)
		{
			saveLog(true, "store result from squid2sqlData error - %s\n", mysql_error(&loc_mysql));
		 return false;
		}
		while((row = mysql_fetch_row(res))) 
		{
			if (mysql_num_fields(res) >= 7)
			{
					attrName locAttr(row[1]);
					locAttr.Limit = atoi(row[2]);
					locAttr.Traffic = atoi(row[3]);
					locAttr.CacheTraffic = atoi(row[4]);
					locAttr.fromUser = atoi(row[5]);
					
					myUserInfo.lastUpdate = atoi(row[6]);

					//myUserInfo.month = atoi(row[7])-1;
					//myUserInfo.year = atoi(row[8])-1900;
					time_t rtime;
					time (&rtime);
					struct tm *today;
					today =  localtime( &rtime );

					myUserInfo.month = today->tm_mon;
					myUserInfo.year = today->tm_year;


					uint lc;
					bool findlimitName = false;
					for (lc = 0; lc < myUserInfo.userLimits.size(); ++lc)
					{
						if (strstr(myUserInfo.userLimits[lc].limitName, row[0])!= NULL)
						{
							myUserInfo.userLimits[lc].limitInfo.push_back(locAttr);
							//if ((strstr(myUserInfo.userLimits[lc].limitName, "ADSunderArray")!= NULL) && 
							if (	((myUserInfo.userLimits[lc].value == -1) || (locAttr.Limit == -1)))
											myUserInfo.userLimits[lc].value = -1;
							else
								myUserInfo.userLimits[lc].value += locAttr.Limit;
								myUserInfo.userLimits[lc].inet += locAttr.Traffic;
								myUserInfo.userLimits[lc].cache += locAttr.CacheTraffic;
								myUserInfo.userLimits[lc].toinet += locAttr.fromUser;
							findlimitName = true;
							break;
						}
					}
					if (!findlimitName)
					{
						limitArray firstLimit(row[0]);
						int coint = myUserInfo.userLimits.size();
						myUserInfo.userLimits.push_back(firstLimit);
						myUserInfo.userLimits[coint].limitInfo.push_back(locAttr);
							myUserInfo.userLimits[coint].value += locAttr.Limit;
							myUserInfo.userLimits[coint].inet += locAttr.Traffic;
							myUserInfo.userLimits[coint].cache += locAttr.CacheTraffic;
							myUserInfo.userLimits[coint].toinet += locAttr.fromUser;
					}

			}
			else
				{
					saveLog(true, "don`t get need number of elements from mySQL\n");
					return false;
				}
		}
	      
		if (!mysql_eof(res))
		{
			saveLog(true, "not end of row - %s\n", mysql_error(&loc_mysql));
			return false;
		}
		mysql_free_result(res);
		n ++;
	}
		return true;
}

bool saveUserInfo(MYSQL &loc_mysql, userInfo &myUserInfo)
{
	char sqlStr[BUFFER_SIZE];
	MYSQL_RES *res;
	MYSQL_ROW row;

	uint i, j;
	for (i=0; i < myUserInfo.userLimits.size(); ++i)
	{
		for (j = 0; j <myUserInfo.userLimits[i].limitInfo.size(); ++j)
		{

			bool lineExixt = false;
			snprintf (sqlStr, BUFFER_SIZE , "SELECT limitName,userLimit,groupName,userTraffic,userCacheTraffic,fromUserTraffic FROM userGroups WHERE userName=\"%s\" AND limitName=\"%s\" AND groupName=\"%s\"", 
											myUserInfo.userName, myUserInfo.userLimits[i].limitName, myUserInfo.userLimits[i].limitInfo[j].groupName);
			if (mysql_query(&loc_mysql,sqlStr))
			{
				saveLog(true, "select count from userGroups error (saveUserInfo) - %s\n", mysql_error(&loc_mysql));
				return false;
			}
			if ((res = mysql_store_result(&loc_mysql)) != NULL)
			{
				if ((row = mysql_fetch_row(res)))
					if (mysql_num_fields(res) > 0)
					{
						lineExixt = true;
					}
			}
 			mysql_free_result(res); 
		 	
			if (!lineExixt)
			{
				snprintf (sqlStr, BUFFER_SIZE , "INSERT INTO userGroups(userName,limitName,groupName,userLimit,userTraffic,userCacheTraffic,fromUserTraffic,lastUpdate,month,year) VALUES(\"%s\",\"%s\",\"%s\",%d,%d,%d,%d,%u,%u,%u)", 
											myUserInfo.userName, myUserInfo.userLimits[i].limitName, myUserInfo.userLimits[i].limitInfo[j].groupName, myUserInfo.userLimits[i].limitInfo[j].Limit, myUserInfo.userLimits[i].limitInfo[j].Traffic, myUserInfo.userLimits[i].limitInfo[j].CacheTraffic, myUserInfo.userLimits[i].limitInfo[j].fromUser, uint(myUserInfo.lastUpdate), uint(myUserInfo.month+1), uint(myUserInfo.year+1900));
			}
				else
				{
						snprintf (sqlStr, BUFFER_SIZE , "UPDATE userGroups SET userLimit=%d,userTraffic=%d,userCacheTraffic=%d,fromUserTraffic=%d,lastUpdate=%u,month=%u,year=%u WHERE userName=\"%s\" AND limitName=\"%s\" AND groupName=\"%s\"", 
													myUserInfo.userLimits[i].limitInfo[j].Limit, myUserInfo.userLimits[i].limitInfo[j].Traffic, myUserInfo.userLimits[i].limitInfo[j].CacheTraffic, myUserInfo.userLimits[i].limitInfo[j].fromUser, uint(myUserInfo.lastUpdate), uint(myUserInfo.month+1), uint(myUserInfo.year+1900),
													myUserInfo.userName, myUserInfo.userLimits[i].limitName, myUserInfo.userLimits[i].limitInfo[j].groupName);
				}
				
				
			if (mysql_query(&loc_mysql, sqlStr) != 0)
			{
				saveLog(true, "insert or update into userGroups error - %s\n", mysql_error(&loc_mysql));
				saveLog(true, ">%s\n", sqlStr);
				return false;
			}
			if (mysql_affected_rows(&loc_mysql) < 0)
			{
				saveLog(true, "mysql_affected_rows error - %s\n", mysql_error(&loc_mysql));
				return false;
			}
		
		}
	}
	for (i=0; i < myUserInfo.userLimits.size(); ++i)
	{
		for (j = 0; j <myUserInfo.userLimits[i].limitInfo.size(); ++j)
		{

			bool lineExixt = false;
			snprintf (sqlStr, BUFFER_SIZE , "SELECT limitName,userLimit,groupName,userTraffic,userCacheTraffic,fromUserTraffic FROM squid2sqlData WHERE userName=\"%s\" AND limitName=\"%s\" AND groupName=\"%s\"", 
											myUserInfo.userName, myUserInfo.userLimits[i].limitName, myUserInfo.userLimits[i].limitInfo[j].groupName);
			if (mysql_query(&loc_mysql,sqlStr))
			{
				saveLog(true, "select count from squid2sqlData error (saveUserInfo) - %s\n", mysql_error(&loc_mysql));
				return false;
			}
			if ((res = mysql_store_result(&loc_mysql)) != NULL)
			{
				if ((row = mysql_fetch_row(res)))
					if (mysql_num_fields(res) > 0)
					{
						lineExixt = true;
					}
			}
 			mysql_free_result(res); 
		 	
			if (!lineExixt)
			{
				snprintf (sqlStr, BUFFER_SIZE , "INSERT INTO squid2sqlData(userName,limitName,groupName,userLimit,userTraffic,userCacheTraffic,fromUserTraffic,lastUpdate) VALUES(\"%s\",\"%s\",\"%s\",%d,%d,%d,%d,%u)", 
											myUserInfo.userName, myUserInfo.userLimits[i].limitName, myUserInfo.userLimits[i].limitInfo[j].groupName, myUserInfo.userLimits[i].limitInfo[j].Limit, myUserInfo.userLimits[i].limitInfo[j].Traffic, myUserInfo.userLimits[i].limitInfo[j].CacheTraffic, myUserInfo.userLimits[i].limitInfo[j].fromUser, uint(myUserInfo.lastUpdate));
			}
				else
				{
						snprintf (sqlStr, BUFFER_SIZE , "UPDATE squid2sqlData SET userLimit=%d,userTraffic=%d,userCacheTraffic=%d,fromUserTraffic=%d,lastUpdate=%u WHERE userName=\"%s\" AND limitName=\"%s\" AND groupName=\"%s\"", 
													myUserInfo.userLimits[i].limitInfo[j].Limit, myUserInfo.userLimits[i].limitInfo[j].Traffic, myUserInfo.userLimits[i].limitInfo[j].CacheTraffic, myUserInfo.userLimits[i].limitInfo[j].fromUser, uint(myUserInfo.lastUpdate),
													myUserInfo.userName, myUserInfo.userLimits[i].limitName, myUserInfo.userLimits[i].limitInfo[j].groupName);
				}
				
				
			if (mysql_query(&loc_mysql, sqlStr) != 0)
			{
				saveLog(true, "insert or update into squid2sqlData error - %s\n", mysql_error(&loc_mysql));
				saveLog(true, ">%s\n", sqlStr);
				return false;
			}
			if (mysql_affected_rows(&loc_mysql) < 0)
			{
				saveLog(true, "mysql_affected_rows error - %s\n", mysql_error(&loc_mysql));
				return false;
			}
		
		}
	}

	return true;	
}


void subGroups(limitArray &routUser, int &groupTraffic, int &groupCacheTraffic, int &fromUser, vector <attrName> &groupInfo)
{
	int groupRest;//, groupTraffic, groupCacheTraffic;
	uint j;
	//groupTraffic = traffic;
	//groupCacheTraffic = cacheTraffic;
	for (j = 0; j < routUser.limitInfo.size(); ++j)
	{
		groupRest = routUser.limitInfo[j].Limit - 
							routUser.limitInfo[j].Traffic +
							routUser.limitInfo[j].CacheTraffic;
//saveLog (true, "%d - limit=%d groupRest=%d limitName-%s\n", j, routUser.limitInfo[j].Limit, groupRest, routUser.limitName);
//saveLog (true, "Group - %s rest - %d\n", routUser.limitInfo[j].groupName, groupRest);
		//if ( (groupRest > 10) || ((routUser.limitInfo[j].Limit == -1) && (strstr(routUser.limitName, "ADSunderArray")!=NULL)) )
		//if (groupRest > 10)
		{
//saveLog (true, "-traffic to Group - %s rest - %d\n", routUser.limitInfo[j].groupName, groupRest);
					attrName myGroup(routUser.limitInfo[j].groupName);
				if (
					(groupRest > groupTraffic) || 
					//((routUser.limitInfo[j].Limit == -1) && (strstr(routUser.limitName, "ADSunderArray")!=NULL))
					(routUser.limitInfo[j].Limit == -1)
					)
				{
//saveLog (true, "put all traffic (%d) to Group - %s rest - %d\n", groupTraffic, routUser.limitInfo[j].groupName, groupRest);
					routUser.limitInfo[j].Traffic += groupTraffic;
					routUser.limitInfo[j].CacheTraffic += groupCacheTraffic;
					routUser.limitInfo[j].fromUser += fromUser;

					
						myGroup.Traffic = groupTraffic;
						myGroup.CacheTraffic = groupCacheTraffic;
						myGroup.fromUser = fromUser;
						groupInfo.push_back(myGroup);

					groupTraffic = 0;
					groupCacheTraffic = 0;
					fromUser = 0;
					break;
				}
				else
				{
					if (groupRest > 10)
					{
//saveLog (true, "put part traffic (%d) to Group - %s rest - %d\n", groupTraffic, routUser.limitInfo[j].groupName, groupRest);
						routUser.limitInfo[j].Traffic += groupRest;
						groupTraffic -= groupRest;
								myGroup.Traffic = groupRest;
								myGroup.fromUser += groupRest;
						if (groupCacheTraffic > 0)
						{
							routUser.limitInfo[j].CacheTraffic += groupRest;
								myGroup.CacheTraffic = groupRest;
								myGroup.CacheTraffic = groupCacheTraffic;
								myGroup.fromUser = fromUser;

							groupCacheTraffic -= groupRest;
						}
								groupInfo.push_back(myGroup);
					}
				}
		}
	}
}


void logPipeChild()
{
	//MYSQL_RES *res;
	//MYSQL_ROW row;
	saveLog (true, "_________________________________________START CHILD___________________________________\n");

	saveLog (true, "set effective user and group\n");
	saveLog (true, "Set effective group\n");
	struct group *eGroup;
	int result;
	eGroup = getgrnam (effective_group);
	if (eGroup != NULL)
	{
		result = setgid (eGroup->gr_gid);
		if (result < 0)
		{
			saveLog (true, "error set effectiv group - %s with gid - %d\n", effective_group, eGroup->gr_gid);
		}
	}
	else saveLog (true, "Error getgrnam effective_group\n");
	struct passwd *eUserPasswd;
	eUserPasswd = getpwnam (effective_user);
	if (eUserPasswd != NULL)
	{
		saveLog (true, "Set effective user\n");
		result = setuid (eUserPasswd->pw_uid);
		if (result < 0)
		{
			saveLog (true, "error set effectiv user - %s with uid - %d\n", effective_user, eUserPasswd->pw_uid);
		}
	}
	else saveLog (true, "Error getpwnam effective_user\n");

// 0 time
// 1 duration
// 2 computer
// 3 status/code
// 4 size
// 5 method
// 6 URL
// 7 user
// 8 peerstatus/peerhost
// 9 objecttype
	saveLog(true, "--begin--\n");
	bool squidwork = false, queryComplete = false, unknownUser = false;
	
			vector <userInfo> allUsers;
			
			myLDAP ldapCon;
			//ldapCon.setHost("192.168.1.3", false);
			ldapCon.setHost(servInfo);
			saveLog(true, "init LDAP\n");
			allUsers.clear();
	 
			//squidwork = false;
			squidwork = true;

		saveLog(true, "open pipe chanel\n");
		FILE *pipeChanal;
		if ((pipeChanal = fopen (squidLog, "r")) != NULL)
		{	
	do
	{
	
		if (!mysql_init(&mysql))
			saveLog(true, "Error mysql_init error - %s\n", mysql_error(&mysql));
		char buf[BUFFER_SIZE], sqlStr[BUFFER_SIZE], *splitM[10];
		char backLogStr[BUFFER_SIZE];



		//mysql_connect(&mysql, host, username, password);
		saveLog(true, "connect to DB\n");
		if (!mysql_real_connect(&mysql, servInfo.host, servInfo.username, servInfo.password, servInfo.database, servInfo.port, NULL, 0))
		//if (!mysql_real_connect(&mysql, host, username, password, database, port, NULL, CLIENT_SSL))
		//if (!mysql_real_connect(&mysql, host, username, password, database, port, unix_socket, 0))
		{
			saveLog(true, "Error connect to mysql error -> %s\n", mysql_error(&mysql));
		}
		/*if (mysql_select_db(&mysql, database))
		{
			saveLog(true, "Error select DB error - %s", mysql_error(&mysql));
		}*/

//		saveLog(true, "open pipe chanel\n");
//		FILE *pipeChanal;
		vector <attrName> groupInfo;
//		if ((pipeChanal = fopen (squidLog, "r")) != NULL)
//		{

			while ((fgets(buf, BUFFER_SIZE, pipeChanal) != NULL) && mustWork)
				{
					//saveLog(true, "back string\n");
					strncpy (backLogStr, buf, BUFFER_SIZE);
					queryComplete = false;
					//slit insert line
					uint i, j;
					for (i = 0; i < 10; ++i) splitM[i] = "";
					if ((splitM[0] = strtok(buf," ")) != NULL)
					{
						for (i = 1; i < 10; ++i)
						{
							if ((splitM[i] = strtok(NULL," ")) == NULL)
							{
								saveLog (true, "get null split[%d] string\n", i);
								break;
							}
						}
					}
					char *timeStr, *codeStatus, *codeStr, *peerStatus, *peerHost;
					int status=17;
					timeStr = "0";
					codeStatus = "-";
					codeStr = "17";
					peerStatus = "-";
					peerHost = "-";

					if ((timeStr=strtok(splitM[0], ".")) == NULL)
					{
						saveLog(true, "Error split timeStr\n");
					}

					if ((codeStatus=strtok(splitM[3],"/")) != NULL)
					{
						if ((codeStr=strtok(NULL,"/")) == NULL)
							saveLog(true, "Error split codeStr\n");
					}
					else
						saveLog(true, "Error split codeStatus\n");

					if (strstr(codeStatus, "TCP_HIT")) { status=0; }
					if (strstr(codeStatus, "TCP_REFRESH_HIT")) { status=1; }
					if (strstr(codeStatus, "TCP_REF_FAIL_HIT")) { status=2; }
					if (strstr(codeStatus, "TCP_IMS_HIT")) { status=3; }
					if (strstr(codeStatus, "TCP_NEGATIVE_HIT")) { status=4; }
					if (strstr(codeStatus, "TCP_MEM_HIT")) { status=5; }
					if (strstr(codeStatus, "TCP_OFFLINE_HIT")) { status=6; }
					if (strstr(codeStatus, "UDP_HIT")) { status=7; }
					if (strstr(codeStatus, "TCP_DENIED")) { status=8; }
					if (strstr(codeStatus, "UDP_DENIED")) { status=9; }
					if (strstr(codeStatus, "TCP_REFRESH_MISS")) { status=10; }
					if (strstr(codeStatus, "TCP_CLIENT_REFRESH_MISS")) { status=11; }
					if (strstr(codeStatus, "TCP_MISS")) { status=12; }
					if (strstr(codeStatus, "TCP_SWAPFILE_MISS")) { status=13; }
					if (strstr(codeStatus, "UDP_MISS")) { status=14; }
					if (strstr(codeStatus, "UDP_INVALID")) { status=15; }
					if (strstr(codeStatus, "UDP_MISS_NOFETCH")) { status=16; }
					if (strstr(codeStatus, "NONE")) { status=17; }
						
					if ((peerStatus=strtok(splitM[8],"/")) != NULL)
					{
						//if ((peerHost=strtok(NULL,"/")) == NULL) saveLog(true, "Error split codeStr\n");
						peerHost=strtok(NULL,"/");
					}
					//else	saveLog(true, "Error split codeStatus\n");

					char *p;
					if ((p=strchr(splitM[9], '\n')) != NULL)
					{
						*p = ' ';
					}
		
					
					if (strstr(splitM[7],"-") == NULL)
					{

						unknownUser = false;

//						snprintf (sqlStr, BUFFER_SIZE , "INSERT INTO full_proxy_stat(Time,TimeRequest,Computer,Status,Code,Size,Method,URL,DNUser,HierarhyInfo,HierarhyHost,ObjectType)	VALUES(%s,%s,\"%s\",%d,%s,%s,\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",\"%s\")", 
//										timeStr, splitM[1], splitM[2],	status, codeStr, splitM[4] , splitM[5] , splitM[6] , splitM[7], peerStatus, peerHost, splitM[9]);
						snprintf (sqlStr, BUFFER_SIZE , "INSERT INTO full_proxy_stat(Time,TimeRequest,Computer,Status,Code,Size,Method,URL,DNUser,HierarhyInfo,HierarhyHost,ObjectType,StatusStr)	VALUES(%s,%s,\"%s\",%d,%s,%s,\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",\"%s\")", 
										timeStr, splitM[1], splitM[2],	status, codeStr, splitM[4] , splitM[5] , splitM[6] , splitM[7], peerStatus, peerHost, splitM[9], codeStatus);

						if (mysql_query(&mysql, sqlStr) != 0)
						{
							saveLog(true, "inser into full_proxy_stat error - %s\n", mysql_error(&mysql));
							saveLog(true, ">%s\n", sqlStr);
							break;
						}
//saveLog (true, "%s\n", sqlStr);
						
						char *inet,	*toinet, *cache, *size;
						inet = "0";
						toinet = "0";
						cache = "0";
						size = "0";
						size = splitM[4];
						if (status < 10)
						{
							cache=size;
						}
						else
							{
								if (strstr(splitM[5], "PUT") != NULL)
								{
									toinet=size;
								}
								else
									{
										inet=size;
									}
							}

						char dURL[4096], *site, *dGroup, *webhost, *dOrg;
						strncpy (dURL, splitM[6], 4096);
						site = "-";
						webhost = "-";
						dGroup = "-";
						dOrg = "-";
						webhost = "-";
						if (strtok(dURL, "/")!=NULL)
						{
							site = strtok(NULL, "/");
						}

								int rest;
								int traffic, cacheTraffic, fromUser;
								traffic = atol (size);
								cacheTraffic = atol (cache);
								fromUser = atol(toinet);
//saveLog(true, "traffic=%d cacheTraffic=%d fromUser=%d \n", traffic, cacheTraffic, fromUser);
								//search user info in local date
																	//saveLog(true, "search user info (split - %s) in local date\n", splitM[7]);
								int userID = -1;
								if (!allUsers.empty())
								{
									for (i=0; i < allUsers.size(); ++i)
									{
																	//saveLog(true, "user[%d] - %s\n", i, allUsers[i].userName);
										if (strstr(splitM[7], allUsers[i].userName) != NULL)
										{
											userID = i;
																	//saveLog(true, "finf user (%s) ID - %d\n", splitM[7], i);
											break;
										}
									}
								}
								else
									saveLog (true, "Empty user VECTOR!!!\n");
								
										time_t rtime, registerTime;
										time (&rtime);

								if (userID < 0)
								{
																	saveLog(true, "not find user (%s) in memory ID - get in MySQL\n", splitM[7]);
									userID = allUsers.size();
									//userID = 0;
									userInfo newUser(splitM[7]);
									//user not found in local data - search in MySQL
									readUserInfo(mysql, newUser);
									
									allUsers.push_back(newUser);
									/*if (ldapCon.myLdapInfo(allUsers[userID]) > 0)
									{
																	saveLog(true, "success get LDAP user info - %s\n", splitM[7]);
										allUsers[userID].lastUpdate = rtime;
																	saveLog(true, "updte user info - %s\n", splitM[7]);
									}
									else 
										{
											saveLog(true, "error update user %s ldap info\n", splitM[7]);
											squidwork = false;
											break;
										}*/
								}																	
						
																	//saveLog(true, "update user info - %s if necessary\n", splitM[7]);
										uint real_month, last_month, real_year, last_year;

										struct tm *today, *last;
										registerTime = allUsers[userID].lastUpdate;
										today =  localtime( &rtime );

										real_month = today->tm_mon;
										real_year = today->tm_year;

										last =  localtime( &registerTime );
										last_month = last->tm_mon;
										last_year = last->tm_year;
 										if ((last_month != real_month) || (last_year != real_year))
										{
											for (i=0; i < allUsers[userID].userLimits.size(); ++i)
											{
												saveLog (true, "reset user (%s) Traffic from %s\n", allUsers[userID].userName, allUsers[userID].userLimits[i].limitName);
												//if (strstr(allUsers[userID].userLimits[i].limitName, "ADScommercialArray") == NULL)
												if (strstr(allUsers[userID].userLimits[i].limitName, localName[1]) == NULL)
												{
													for (j = 0; j <allUsers[userID].userLimits[i].limitInfo.size(); ++j)
													{
														allUsers[userID].userLimits[i].limitInfo[j].Traffic = 0;
														allUsers[userID].userLimits[i].limitInfo[j].CacheTraffic = 0;
														saveLog (true, "<------ reset user (%s) Traffic in %s\n", allUsers[userID].userName, allUsers[userID].userLimits[i].limitInfo[j].groupName);
													}
													allUsers[userID].userLimits[i].inet = 0;
													allUsers[userID].userLimits[i].cache = 0;
												}
											}
										}

								if ((rtime - allUsers[userID].lastUpdate) > udateTime)
								{
									if (ldapCon.myLdapInfo(allUsers[userID]) > 0)
									{
										//registerTime = allUsers[userID].lastUpdate;
										saveLog (true, "update user (%s) info in LDAP\n", allUsers[userID].userName);
						 
										allUsers[userID].lastUpdate = rtime;
										allUsers[userID].month = real_month;
										allUsers[userID].year = real_year;
									}
									else 
									{
										saveLog(true, "error update user %s ldap info\n", splitM[7]);
										squidwork = false;
										break;
									}
								}
								
								//code for sort user traffic to groups...
																	//saveLog(true, "code for sort user(%s) traffic to groups...\n", splitM[7]);
								
								groupInfo.clear();
								int n = 0;
								while (localName[n] != NULL)
								{
								for (i = 0; i < allUsers[userID].userLimits.size(); ++i)
								{
									if (strstr(localName[n], allUsers[userID].userLimits[i].limitName))
									{
									rest = allUsers[userID].userLimits[i].value - allUsers[userID].userLimits[i].inet
												+ allUsers[userID].userLimits[i].cache;
//saveLog(true, "limitName - %s (rest - %d)\n", allUsers[userID].userLimits[i].limitName, rest);
																	//saveLog(true, "user - %s userLimits - %s value = %d rest = %d\n", 
																	//	allUsers[userID].userName, allUsers[userID].userLimits[i].limitName, allUsers[userID].userLimits[i].value, rest);
									//if (rest > traffic)
									if ((rest > traffic) || 
										//((allUsers[userID].userLimits[i].value == -1) && (strstr(allUsers[userID].userLimits[i].limitName,"ADSunderArray")!=NULL)))
										(allUsers[userID].userLimits[i].value == -1) )
										//((allUsers[userID].userLimits[i].value == -1) && (strstr(allUsers[userID].userLimits[i].limitName,"excess")!=NULL)))
									{
																	//saveLog(true, "put user - %s traffic to userLimits - %s\n", 
																	//	allUsers[userID].userName, allUsers[userID].userLimits[i].limitName);
										allUsers[userID].userLimits[i].inet += traffic;
										allUsers[userID].userLimits[i].cache += cacheTraffic;
										//for subgroups....
										//int groupRest, 
											//int groupTraffic, groupCacheTraffic;
											//groupTraffic = traffic;
											//groupCacheTraffic = cacheTraffic;
																	//saveLog(true, "put user - %s traffic (inet=%s toinet=%s cache=%s) to Groups from userLimits - %s\n", 
																	//	allUsers[userID].userName, inet, toinet, cache, allUsers[userID].userLimits[i].limitName);
										subGroups(allUsers[userID].userLimits[i], traffic, cacheTraffic, fromUser, groupInfo);
																	//saveLog (true, "Finish\n");
										//traffic = 0;
										//cacheTraffic = 0;
										break;
									}
										else
										{
																	//saveLog(true, "put PART user - %s traffic to userLimits - %s\n", 
																	//	allUsers[userID].userName, inet, toinet, cache, allUsers[userID].userLimits[i].limitName);
											if (rest > 10)
											{
												allUsers[userID].userLimits[i].inet += rest;
												traffic -= rest;
												if (cacheTraffic > 0)
												{
													allUsers[userID].userLimits[i].cache += rest;
													cacheTraffic -= rest;
												}
												//for subgroups....
												//int groupRest, 
												//int groupTraffic, groupCacheTraffic;
												//groupTraffic = traffic;
												//groupCacheTraffic = cacheTraffic;
																		//saveLog(true, "put PART user - %s traffic (inet=%s toinet=%s cache=%s) to Groups userLimits - %s\n", 
																		//	allUsers[userID].userName, inet, toinet, cache, allUsers[userID].userLimits[i].limitName);
												subGroups(allUsers[userID].userLimits[i], traffic, cacheTraffic, fromUser, groupInfo);
											}
										}
									}
								}

								n ++;
								}

															/*
															if (strstr(splitM[7], "cn=")!=NULL)
															{
																if ((dGroup=strstr(splitM[7], ","))!=NULL)
																	dGroup++;
																else
																	saveLog (true, "Error split dGroup\n");
															}
															else
																saveLog (true, "Error find (cn=) in user name\n");
															*/
						if (groupInfo.empty() || traffic > 0)
						{
																	saveLog (true, "not set some Groups to limit\n");
								
								//if (!allUsers[userID].userLimits.empty())
								//if (allUsers[userID].userLimits.size() > 0)
								//	for (i = allUsers[userID].userLimits.size() - 1; i >= 0; i--)
								for (i = 0; i < allUsers[userID].userLimits.size(); ++i)
								{
									//if (!allUsers[userID].userLimits[i].limitInfo.empty())
									//if (allUsers[userID].userLimits[i].limitInfo.size() > 0)
									//	for (j = allUsers[userID].userLimits[i].limitInfo.size() - 1; j >= 0; j--)
									for (j = 0; j < allUsers[userID].userLimits[i].limitInfo.size(); ++j)
									{
										if (allUsers[userID].userLimits[i].limitInfo[j].Traffic > 1024)
										{
																	//saveLog (true, "set some Limit (%s)\n", allUsers[userID].userLimits[i].limitName);
																	//saveLog (true, "user traffic %d\n", allUsers[userID].userLimits[i].limitInfo[j].Traffic);
//saveLog (true, "set some Groups (%s) [i = %d j = %d] traffic=%d cacheTraffic=%d fromUser=%d \n", 
//								allUsers[userID].userLimits[i].limitInfo[j].groupName, i, j, traffic, cacheTraffic, fromUser);
											attrName myGroup(allUsers[userID].userLimits[i].limitInfo[j].groupName);
											myGroup.Traffic = traffic;
											myGroup.CacheTraffic = cacheTraffic;
											myGroup.fromUser = fromUser;
											groupInfo.push_back(myGroup);

											allUsers[userID].userLimits[i].limitInfo[j].Traffic += traffic;
											allUsers[userID].userLimits[i].limitInfo[j].CacheTraffic += cacheTraffic;
											traffic = 0;
											cacheTraffic = 0;
											break;
										}
									}
								}
						}

																	//saveLog (true, "save user (%s) limit to MySQL\n", allUsers[userID].userName);
								saveUserInfo(mysql, allUsers[userID]);

						for (i = 0; i < groupInfo.size(); ++i)
						{
							dGroup = groupInfo[i].groupName;
							dOrg = strstr(groupInfo[i].groupName, "ou=");
							if (dOrg == NULL)
								dOrg = strstr(groupInfo[i].groupName, "OU=");
							if (dOrg == NULL)
								dOrg = "-";
							snprintf (sqlStr, BUFFER_SIZE , "INSERT INTO proxy_stat(Time,Computer,Inet,toInet,Cache,URL,Code,ObjectType,DNUser,Site,DNGroup, DNOrg) VALUES (\"%s\",\"%s\",%d,%d,%d,\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",\"%s\")", 
															timeStr, splitM[2], (groupInfo[i].Traffic - groupInfo[i].CacheTraffic),	groupInfo[i].fromUser, groupInfo[i].CacheTraffic, splitM[6], codeStr, splitM[9], splitM[7], site, dGroup, dOrg);

							if (mysql_query(&mysql, sqlStr) != 0)
							{
								saveLog(true, "inser into full_proxy_stat error - %s\n", mysql_error(&mysql));
								saveLog(true, ">%s\n", sqlStr);
								break;
							}
//saveLog (true, "%s\n", sqlStr);
						}
						queryComplete = true;
					}
					else
						{
							unknownUser = true;
							saveUnKnownLog(backLogStr);
						}
				}
//			fclose(pipeChanal);
//		}
//		else 		saveLog(true, "Can not open squid log\n");
		//mysql_free_result(res);
		mysql_close(&mysql);
		mysql_library_end();
		if (!queryComplete)
			saveBackUpLog(backLogStr);
 		/*FILE *dF;
		int sPid;
		dF = fopen(squidPid, "r");
		if (dF != NULL)
		{
			if (fgets(buf, 255, dF) != NULL)
			{
				sPid = atoi(buf);
				if (kill(sPid, 0) >= 0)
					squidwork = true;
				else
					squidwork = false;
			}else 
				saveLog (true, "cannot read squidPid file\n");
			fclose (dF);
		}*/
	}while (squidwork && mustWork);
			fclose(pipeChanal);
		}
		else 		saveLog(true, "Can not open squid log\n");
	saveLog(true, "end of logPipe\n");

}


void print_to_file (FILE *fp, const char *format, va_list args)
{
	vfprintf(fp, format, args);
}

void saveLog(bool ntime, const char *format,...)
{
	va_list marker;
    va_start(marker, format);
	FILE *fp;
	fp = fopen(logFileName,"a+");
	if (fp != NULL)
	{
		if (ntime)
		{
			time_t workTime;
			time (&workTime);
			struct tm *today;
			today =  localtime( &workTime );
			fprintf (fp, "%d.%d.%d-%d:%d:%d >", 
					today->tm_mday, today->tm_mon+1, today->tm_year-100 , today->tm_hour, today->tm_min, today->tm_sec);
		}
			
		static char f[4096];   
		snprintf (f, 4095, "%s", format);

		if (strlen(f) > 0)
			print_to_file (fp, f, marker);
		fclose(fp);
	}
	va_end( marker );
}

void saveBackUpLog(char *Str)
{

	FILE *fp;
	fp = fopen(backUpLog,"a+");
	if (fp != NULL)
	{
		fprintf (fp, "%s", Str);
		fclose(fp);
	}
}

void saveUnKnownLog(char *Str)
{

	FILE *fp;
	fp = fopen(unKnownLog,"a+");
	if (fp != NULL)
	{
		fprintf (fp, "%s", Str);
		fclose(fp);
	}
}

// Local Variables:
// mode:C++
// End:
