#ifndef _MY_LDAP_H
#define _MY_LDAP_H

#include <ldap_ssl.h>
#include <ldap.h>
#include <ldapx.h>
#include <ctype.h>
#include <pthread.h>

#include <vector>
#include <string>

#include "mydata.h"


using std::string;
using std::vector;
using std::iterator;

struct attrName
{
	char name[256];
};
struct allinOne
{
	 vector <attrName> userGroups;
	 int userLimit;
	 int userunderLimit;
	 int ldapComLimit;
};

class myLDAP
{

protected:
	//LDAP   *ldGlobal;
	char ldapHost[256];
	struct timeval timeOut;
	bool needSSL;
	LDAP *GlobalLd;
	int  ldapPort;
	char *loginDN, *password;
	char LDAPlogin[255], LDAPpassword[255];
	char **getAttr;


	//int LSC (LDAP *ld, char *loginName, int &ldapLimit, int &ldapUnderLimit);
	int myLDAP::LSC (LDAP   *ld, char *loginName,int &ldapLimit, int &ldapUnderLimit, int &ldapComLimit);
	//int myLdapSearch(LDAP *ld, char *searchBase, char  **attrs, char *filter, int &sLimit, int &sUnderLimit, vector <attrName> &userGroups);
	int myLdapSearch(LDAP *localLD, char *searchBase, char  **attrs, char *filter,
														int &sLimit, int &sUnderLimit, int &sComLimit, vector <attrName> &userGroups);

public:
	//myLDAP(bool LinitSSL);
	myLDAP();
	~myLDAP();
	//myLDAPInit();
	void myLDAPdeInit();
	void setHost(ServerInfo si);
	//int myLdapInfo(char *loginName, int &ldapLimit, int &ldapUnderLimit);
	int myLdapInfo(char *loginName, int &ldapLimit, int &ldapUnderLimit, int &ldapComLimit);
};

#endif /*_MY_LDAP_H*/

