#include "mysqlsave.h"

#define BUFFER_SIZE             (8*1024)

//char *host = "192.168.1.3";
//unsigned int port = 6612;
//char *username = "root";
//char *password = "";
//char *database = "trafficdb";

extern void saveLog(bool ntime, const char *format,...);
extern void stringToLow(char *inStr);

const uint numTry = 3;
//MYSQL mysql;

mySqlSave::mySqlSave()
{
	/*if (pthread_mutex_init(&sql_mutex, NULL))
	{
		saveLog(true, "Error SQL mutex init!!!\n");
	}*/
strncpy (host, "192.168.1.3", 255);
port = 6612;
strncpy (username, "root", 255);
strncpy (password, "", 255);
strncpy (database, "trafficdb", 255);

/*host = "192.168.1.3";
port = 6612;
username = "root";
password = "";
database = "trafficdb";*/

	//myConnect();
}

mySqlSave::~mySqlSave()
{
	/*if (pthread_mutex_destroy(&sql_mutex))
	{
		saveLog(true, "Error SQL mutex destroy!!!\n");
	}*/
	myDisConnect();
}

bool mySqlSave::myConnect(ServerInfo si)
{
	//needSSL = si.needSSL;
	port = si.port;

	strncpy (host, si.host, 255);
	strncpy (username, si.username, 255);
	strncpy (password, si.password, 255);
	strncpy (database, si.database, 255);

	if (!mysql_init(&mysql))
	{
		saveLog(true, "Error mysql_init error - %s\n", mysql_error(&mysql));
		return false;
	}
	//mysql_options(&mysql,MYSQL_READ_DEFAULT_GROUP,"squid_daemon");

	if (!mysql_real_connect(&mysql, host, username, password, database, port, NULL, 0))
	{
		saveLog(true, "Error connect to mysql error -> %s\n", mysql_error(&mysql));
		return false;
	}
	//if (mysql_select_db(&mysql,"payroll"))
	saveLog (true, "Connect to MySQL %s:%d\n", host, port);
	return true;
}

bool mySqlSave::myDisConnect()
{
	mysql_close(&mysql);
	mysql_library_end();

	return true;	
}

bool mySqlSave::myTest()
{
						//pthread_mutex_lock(&sql_mutex);

	bool normal;
	uint count = 0;
	do
	{
		if (mysql_ping(&mysql) == 0)
		{
		 saveLog(true, "ping MySQL normal\n");
			normal = true;
		}
			else 
			{
				normal = false;
				// saveLog(true, "ping MySQL error\n");
				saveLog(true, "ping MySQL error - %s\n", mysql_error(&mysql));
			}
	 count ++;
	} while ((!normal) && (count < numTry));
	return normal;
	/*char sqlStr[BUFFER_SIZE];
	snprintf (sqlStr, BUFFER_SIZE , "SELECT * FROM userIP");
  if (mysql_query(&mysql, sqlStr))
  {
		saveLog(true, "select from userDate error - %s\n", mysql_error(&mysql));
						//pthread_mutex_unlock(&sql_mutex);
    return false;
  }
  if ((res = mysql_store_result(&mysql)) == NULL)
  {
		saveLog(true, "store result from userDate error - %s\n", mysql_error(&mysql));
						//pthread_mutex_unlock(&sql_mutex);
   return false;
  }
 
  if (!mysql_eof(res))
  {
		saveLog(true, "not end of row - %s\n", mysql_error(&mysql));
						//pthread_mutex_unlock(&sql_mutex);
		return false;
  }
	mysql_free_result(res);
	return true;*/
}
bool mySqlSave::myReconnect()
{
	//bool normal = myTest();
	if (!myTest())
	{
		myDisConnect();
		if (!mysql_init(&mysql))
		{
			saveLog(true, "Error re mysql_init error - %s\n", mysql_error(&mysql));
			return false;
		}
		//mysql_options(&mysql,MYSQL_READ_DEFAULT_GROUP,"squid_daemon");

		if (!mysql_real_connect(&mysql, host, username, password, database, port, NULL, 0))
		{
			saveLog(true, "Error reconnect to mysql error -> %s\n", mysql_error(&mysql));
			return false;
		}
		//saveLog (true, "ReConnect to MySQL\n");
		saveLog (true, "ReConnect to MySQL %s:%d\n", host, port);
	}
	return true;
}

bool mySqlSave::locSaveToMySQL(SUserData &sud, uint month, uint year)
{
				//pthread_mutex_lock(&sql_mutex);
		month += 1;
		year += 1900;

	char sqlStr[BUFFER_SIZE];
	//if (mysql_select_db(&mysql,"userData"))
	//{
	//	saveLog (true, "ysql_select_db error - %s\n", mysql_error(&mysql));
	//	return false;
	//}
		
		//snprintf (sqlStr, BUFFER_SIZE , "INSERT INTO full_proxy_stat(Time,TimeRequest,Computer,Status,Code,Size,Method,URL,DNUser,HierarhyInfo,HierarhyHost,ObjectType)	VALUES(%s,%s,\"%s\",%d,%s,%s,\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",\"%s\")", 
		//							time, splitM[1], splitM[2],	status, codeStr, splitM[4] , splitM[5] , splitM[6] , splitM[7], peerStatus, peerHost, splitM[9]);
	bool lineExixt = false;
	snprintf (sqlStr, BUFFER_SIZE , "SELECT userTraffic,userCacheTraffic FROM userData	WHERE userName=\"%s\" AND month=%d AND year=%d", 
									sud.userName, month, year);
  if (mysql_query(&mysql,sqlStr))
  {
		saveLog(true, "select count from userDate error - %s\n", mysql_error(&mysql));
						//pthread_mutex_unlock(&sql_mutex);
    return false;
  }
  //if ( (!(res = mysql_store_result(&mysql))) && mysql_num_fields(&mysql))
  /*if (!(res = mysql_store_result(&mysql)))
  {
		saveLog(true, "mysql_store_result from userDate error - %s\n", mysql_error(&mysql));
		
						//pthread_mutex_unlock(&sql_mutex);
						
    return false;
  }*/
  if ((res = mysql_store_result(&mysql)) != NULL)
  {
		if ((row = mysql_fetch_row(res)))
			if (mysql_num_fields(res) > 0)
			{
				lineExixt = true;
			}
  }
 	mysql_free_result(res); 
 	
  if (!lineExixt)
  {
		snprintf (sqlStr, BUFFER_SIZE , "INSERT INTO userData(month,year,userName,userLimit,userTraffic,userCacheTraffic,underLimit,oldUserTraffic,userID,LdapUpdate,lastTime,commercialLimit,commercialTraffic,commercialCacheTraffic)	VALUES(%d,%d,\"%s\",%d,%d,%d,%d,%d,%d,%u,%u,%d,%d,%d)", 
									month, year,
									sud.userName, sud.userLimit, sud.userTraffic, sud.userCacheTraffic, sud.underLimit, sud.oldUserTraffic, sud.userID, uint(sud.LdapUpdate), uint(sud.lastTime), 
									sud.commercialLimit,sud.commercialTraffic, sud.commercialCacheTraffic);
	}
		else
		{
			//uint count;
				//uint i;
				//while((row = mysql_fetch_row(res))) {
				//	for (i=0 ; i < mysql_num_fields(res); ++i)
				//	{
				//		count = atoi( row[i] );
				//	}
				//}
			//if ((row = mysql_fetch_row(res)) != NULL)
			//	if (mysql_num_fields(res) > 0)
			//{
			//			count = atoi( row[0] );
				snprintf (sqlStr, BUFFER_SIZE , "UPDATE userData SET userName=\"%s\",userLimit=%d,userTraffic=%d,userCacheTraffic=%d,underLimit=%d,oldUserTraffic=%d,userID=%d,LdapUpdate=%u,lastTime=%u,commercialLimit=%d,commercialTraffic=%d,commercialCacheTraffic=%d WHERE userName=\"%s\" AND month=%d AND year=%d", 
											sud.userName, sud.userLimit, sud.userTraffic, sud.userCacheTraffic, sud.underLimit, sud.oldUserTraffic, sud.userID, uint(sud.LdapUpdate), uint(sud.lastTime),
											sud.commercialLimit,sud.commercialTraffic, sud.commercialCacheTraffic,
											sud.userName, month, year);
			//}
		}
		
		
		if (mysql_query(&mysql, sqlStr) != 0)
		{
			saveLog(true, "insert or update into userData error - %s\n", mysql_error(&mysql));
			saveLog(true, ">%s\n", sqlStr);
						//pthread_mutex_unlock(&sql_mutex);
			return false;
		}
		if (mysql_affected_rows(&mysql) < 0)
		{
			saveLog(true, "mysql_affected_rows error - %s\n", mysql_error(&mysql));
						//pthread_mutex_unlock(&sql_mutex);
			return false;
		}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	lineExixt = false;
	snprintf (sqlStr, BUFFER_SIZE , "SELECT userTraffic,userCacheTraffic FROM daemonData	WHERE userName=\"%s\"", 
									sud.userName);
  if (mysql_query(&mysql,sqlStr))
  {
		saveLog(true, "select count from daemonData error - %s\n", mysql_error(&mysql));
						//pthread_mutex_unlock(&sql_mutex);
    return false;
  }
  if ((res = mysql_store_result(&mysql)) != NULL)
  {
		if ((row = mysql_fetch_row(res)))
			if (mysql_num_fields(res) > 0)
			{
				lineExixt = true;
			}
  }
 	mysql_free_result(res); 
 	
  if (!lineExixt)
  {
		snprintf (sqlStr, BUFFER_SIZE , "INSERT INTO daemonData(userName,userLimit,userTraffic,userCacheTraffic,underLimit,oldUserTraffic,userID,LdapUpdate,lastTime,commercialLimit,commercialTraffic,commercialCacheTraffic)	VALUES(\"%s\",%d,%d,%d,%d,%d,%d,%u,%u,%d,%d,%d)", 
									sud.userName, sud.userLimit, sud.userTraffic, sud.userCacheTraffic, sud.underLimit, sud.oldUserTraffic, sud.userID, uint(sud.LdapUpdate), uint(sud.lastTime), 
									sud.commercialLimit,sud.commercialTraffic, sud.commercialCacheTraffic);
	}
		else
		{
				snprintf (sqlStr, BUFFER_SIZE , "UPDATE daemonData SET userName=\"%s\",userLimit=%d,userTraffic=%d,userCacheTraffic=%d,underLimit=%d,oldUserTraffic=%d,userID=%d,LdapUpdate=%u,lastTime=%u,commercialLimit=%d,commercialTraffic=%d,commercialCacheTraffic=%d WHERE userName=\"%s\"", 
											sud.userName, sud.userLimit, sud.userTraffic, sud.userCacheTraffic, sud.underLimit, sud.oldUserTraffic, sud.userID, uint(sud.LdapUpdate), uint(sud.lastTime),
											sud.commercialLimit,sud.commercialTraffic, sud.commercialCacheTraffic,
											sud.userName);
		}
		
		
		if (mysql_query(&mysql, sqlStr) != 0)
		{
			saveLog(true, "insert or update into daemonData error - %s\n", mysql_error(&mysql));
			saveLog(true, ">%s\n", sqlStr);
						//pthread_mutex_unlock(&sql_mutex);
			return false;
		}
		if (mysql_affected_rows(&mysql) < 0)
		{
			saveLog(true, "mysql_affected_rows error - %s\n", mysql_error(&mysql));
						//pthread_mutex_unlock(&sql_mutex);
			return false;
		}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
						//pthread_mutex_unlock(&sql_mutex);
	return true;	
}

/*bool mySqlSave::updateIntoMySQL(SUserData &sud, uint month, uint year)
{
						//pthread_mutex_lock(&sql_mutex);
		month += 1;
		year += 1900;

	char sqlStr[BUFFER_SIZE];
//	snprintf (sqlStr, BUFFER_SIZE , "UPDATE INTO userData(userName,userLimit,userTraffic,userCacheTraffic,underLimit,oldUserTraffic,userID,LdapUpdate,lastTime)	VALUES(\"%s\",%d,%d,%d,%d,%d,%d,%u,%u) WHERE userName=\"%s\" AND month=%d AND year=%d",
//								sud.userName, sud.userLimit, sud.userTraffic, sud.userCacheTraffic, sud.underLimit, sud.oldUserTraffic, sud.userID, uint(sud.LdapUpdate), uint(sud.lastTime),
//								sud.userName, month, year);
			snprintf (sqlStr, BUFFER_SIZE , "UPDATE userData SET userName=\"%s\",userLimit=%d,userTraffic=%d,userCacheTraffic=%d,underLimit=%d,oldUserTraffic=%d,userID=%d,LdapUpdate=%u,lastTime=%u,commercialLimit=%d,commercialTraffic=%d,commercialCacheTraffic=%d WHERE userName=\"%s\" AND month=%d AND year=%d", 
										sud.userName, sud.userLimit, sud.userTraffic, sud.userCacheTraffic, sud.underLimit, sud.oldUserTraffic, sud.userID, uint(sud.LdapUpdate), uint(sud.lastTime),
										sud.commercialLimit,sud.commercialTraffic, sud.commercialCacheTraffic,
										sud.userName, month, year);

	if (mysql_query(&mysql, sqlStr) != 0)
	{
		saveLog(true, "update into userData error - %s\n", mysql_error(&mysql));
		saveLog(true, ">%s\n", sqlStr);
						//pthread_mutex_unlock(&sql_mutex);
		return false;
	}
	if (mysql_affected_rows(&mysql) < 0)
	{
		saveLog(true, "mysql_affected_rows error - %s\n", mysql_error(&mysql));
						//pthread_mutex_unlock(&sql_mutex);
		return false;
	}

						//pthread_mutex_unlock(&sql_mutex);
	return true;	
}

bool mySqlSave::insertIntoMySQL(SUserData &sud, uint month, uint year) 
{
						//pthread_mutex_lock(&sql_mutex);
		month += 1;
		year += 1900;

	char sqlStr[BUFFER_SIZE];
	snprintf (sqlStr, BUFFER_SIZE , "INSERT INTO userData(month,year,userName,userLimit,userTraffic,userCacheTraffic,underLimit,oldUserTraffic,userID,LdapUpdate,lastTime,commercialLimit,commercialTraffic,commercialCacheTraffic)	VALUES(%d,%d,\"%s\",%d,%d,%d,%d,%d,%d,%u,%u,%d,%d,%d)", 
									month, year,
									sud.userName, sud.userLimit, sud.userTraffic, sud.userCacheTraffic, sud.underLimit, sud.oldUserTraffic, sud.userID, uint(sud.LdapUpdate), uint(sud.lastTime), 
									sud.commercialLimit,sud.commercialTraffic, sud.commercialCacheTraffic);
	if (mysql_query(&mysql, sqlStr) != 0)
	{
		saveLog(true, "insert into userData error - %s\n", mysql_error(&mysql));
		saveLog(true, ">%s\n", sqlStr);
						//pthread_mutex_unlock(&sql_mutex);
		return false;
	}
	if (mysql_affected_rows(&mysql) < 0)
	{
		saveLog(true, "mysql_affected_rows error - %s\n", mysql_error(&mysql));
						//pthread_mutex_unlock(&sql_mutex);
		return false;
	}

						//pthread_mutex_unlock(&sql_mutex);
	return true;	
}*/

bool mySqlSave::locReadLustTimeFromMySQL(time_t &MySQLupdateTime, char *userName, uint month, uint year)
{
/*						//pthread_mutex_lock(&sql_mutex);
		month += 1;
		year += 1900;

	char sqlStr[BUFFER_SIZE];
	snprintf (sqlStr, BUFFER_SIZE , "SELECT lastTime,LdapUpdate FROM userData WHERE userName=\"%s\" AND month=%d AND year=%d", 
								userName, month, year);
  if (mysql_query(&mysql, sqlStr))
  {
		saveLog(true, "select from userDate error - %s\n", mysql_error(&mysql));
						//pthread_mutex_unlock(&sql_mutex);
    return false;
  }
  if ((res = mysql_store_result(&mysql)) == NULL)
  {
		saveLog(true, "store result from userDate error - %s\n", mysql_error(&mysql));
						//pthread_mutex_unlock(&sql_mutex);
   return false;
  }
  while((row = mysql_fetch_row(res))) 
  {
		if ( mysql_num_fields(res) > 0)
		{
			MySQLupdateTime = atoi(row[0]);		
		}
		else
			{
				//pthread_mutex_unlock(&sql_mutex);
				saveLog(true, "error get all row from MySQL\n");
				return false;
			}
  }
      
  if (!mysql_eof(res))
  {
		saveLog(true, "not end of row - %s\n", mysql_error(&mysql));
						//pthread_mutex_unlock(&sql_mutex);
		return false;
  }
	mysql_free_result(res);
 
						//pthread_mutex_unlock(&sql_mutex);*/
	//pthread_mutex_lock(&sql_mutex);
	char sqlStr[BUFFER_SIZE];
	snprintf (sqlStr, BUFFER_SIZE , "SELECT lastTime,LdapUpdate FROM daemonData WHERE userName=\"%s\"", 
								userName);
  if (mysql_query(&mysql, sqlStr))
  {
		saveLog(true, "select from daemonData error - %s\n", mysql_error(&mysql));
						//pthread_mutex_unlock(&sql_mutex);
    return false;
  }
  if ((res = mysql_store_result(&mysql)) == NULL)
  {
		saveLog(true, "store result from daemonData error - %s\n", mysql_error(&mysql));
						//pthread_mutex_unlock(&sql_mutex);
   return false;
  }
  while((row = mysql_fetch_row(res))) 
  {
		if ( mysql_num_fields(res) > 0)
		{
			MySQLupdateTime = atoi(row[0]);		
		}
		else
			{
				//pthread_mutex_unlock(&sql_mutex);
				saveLog(true, "error get all row from MySQL\n");
				return false;
			}
  }
      
  if (!mysql_eof(res))
  {
		saveLog(true, "not end of row - %s\n", mysql_error(&mysql));
						//pthread_mutex_unlock(&sql_mutex);
		return false;
  }
	mysql_free_result(res);
 
						//pthread_mutex_unlock(&sql_mutex);
  return true;

}
bool mySqlSave::locReadFromMySQL(SUserData &sud, char *userName, uint month, uint year)
{
/*						//pthread_mutex_lock(&sql_mutex);
		month += 1;
		year += 1900;
	
	
	char sqlStr[BUFFER_SIZE];
	snprintf (sqlStr, BUFFER_SIZE , "SELECT userName,userLimit,userTraffic,userCacheTraffic,underLimit,oldUserTraffic,userID,LdapUpdate,lastTime,commercialLimit,commercialTraffic,commercialCacheTraffic FROM userData WHERE userName=\"%s\" AND month=%d AND year=%d", 
								userName, month, year);
  //if (mysql_query(&mysql,"SELECT userName,userLimit,userTraffic,userCacheTraffic,underLimit,oldUserTraffic,userID,LdapUpdate,lastTime FROM userData"))
  if (mysql_query(&mysql, sqlStr))
  {
		saveLog(true, "select from userDate error - %s\n", mysql_error(&mysql));
						//pthread_mutex_unlock(&sql_mutex);
    return false;
  }
  if ((res = mysql_store_result(&mysql)) == NULL)
  {
		saveLog(true, "store result from userDate error - %s\n", mysql_error(&mysql));
						//pthread_mutex_unlock(&sql_mutex);
   return false;
  }
  while((row = mysql_fetch_row(res))) 
  {
		if ( mysql_num_fields(res) >= 12)
		{
				strncpy (sud.userName, row[0], 256);
				sud.userLimit = atoi(row[1]);
				sud.userTraffic = atoi(row[2]);
				sud.userCacheTraffic = atoi(row[3]);
				sud.underLimit = atoi(row[4]);
				sud.oldUserTraffic = atoi(row[5]);
				sud.userID = atoi(row[6]);
				sud.LdapUpdate = atoi(row[7]);
				sud.lastTime = atoi(row[8]);
				sud.commercialLimit = atoi(row[9]);
				sud.commercialTraffic = atoi(row[10]);
				sud.commercialCacheTraffic = atoi(row[11]);
		}
		else
			{
				saveLog(true, "error get all row from MySQL\n");
				return false;
			}
  }
      
  if (!mysql_eof(res))
  {
		saveLog(true, "not end of row - %s\n", mysql_error(&mysql));
						//pthread_mutex_unlock(&sql_mutex);
		return false;
  }
	mysql_free_result(res);
 
						//pthread_mutex_unlock(&sql_mutex);*/

						//pthread_mutex_lock(&sql_mutex);
	
	char sqlStr[BUFFER_SIZE];
	snprintf (sqlStr, BUFFER_SIZE , "SELECT userName,userLimit,userTraffic,userCacheTraffic,underLimit,oldUserTraffic,userID,LdapUpdate,lastTime,commercialLimit,commercialTraffic,commercialCacheTraffic FROM daemonData WHERE userName=\"%s\"", 
								userName);
  if (mysql_query(&mysql, sqlStr))
  {
		saveLog(true, "select from daemonData error - %s\n", mysql_error(&mysql));
						//pthread_mutex_unlock(&sql_mutex);
    return false;
  }
  if ((res = mysql_store_result(&mysql)) == NULL)
  {
		saveLog(true, "store result from daemonData error - %s\n", mysql_error(&mysql));
						//pthread_mutex_unlock(&sql_mutex);
   return false;
  }
  //uint i;//, structCount = 0;
  while((row = mysql_fetch_row(res))) 
  {
		/*if (mysql_num_fields(res) == 0)
		{
						//pthread_mutex_unlock(&sql_mutex);
			return false;
		}*/
		if ( mysql_num_fields(res) >= 12)
		{
				strncpy (sud.userName, row[0], 256);
				sud.userLimit = atoi(row[1]);
				sud.userTraffic = atoi(row[2]);
				sud.userCacheTraffic = atoi(row[3]);
				sud.underLimit = atoi(row[4]);
				sud.oldUserTraffic = atoi(row[5]);
				sud.userID = atoi(row[6]);
				sud.LdapUpdate = atoi(row[7]);
				sud.lastTime = atoi(row[8]);
				sud.commercialLimit = atoi(row[9]);
				sud.commercialTraffic = atoi(row[10]);
				sud.commercialCacheTraffic = atoi(row[11]);
		}
		else
			{
				saveLog(true, "error get all row from MySQL\n");
				return false;
			}
  }
      
  if (!mysql_eof(res))
  {
		saveLog(true, "not end of row - %s\n", mysql_error(&mysql));
						//pthread_mutex_unlock(&sql_mutex);
		return false;
  }
	mysql_free_result(res);
  return true;
}
//--------------------------------------------------------------------------------------------------------------
bool mySqlSave::locSaveIPinMySQL(SIdentUser &siu)
{
				//pthread_mutex_lock(&sql_mutex);

	char sqlStr[BUFFER_SIZE];
	bool lineExist = false;
	snprintf (sqlStr, BUFFER_SIZE , "SELECT IPstr,userName FROM userIP	WHERE IPaddr=%u", 
									uint(siu.userIP.s_addr));
  if (mysql_query(&mysql,sqlStr))
  {
		saveLog(true, "select IP (%s) from userIP error - %s\n", siu.strUserIP, mysql_error(&mysql));
						//pthread_mutex_unlock(&sql_mutex);
    return false;
  }
  if ((res = mysql_store_result(&mysql)) != NULL)
  {
		if ((row = mysql_fetch_row(res))!= NULL)
			if (mysql_num_fields(res) > 0)
			{
				lineExist = true;
			}
  }
 	mysql_free_result(res); 
 	
  if (!lineExist)
  {
		snprintf (sqlStr, BUFFER_SIZE , "INSERT INTO userIP(IPstr,IPaddr,UserName,registrationTime,userID,detachConnection,dropTime)	VALUES(\"%s\",%u,\"%s\",%u,%u,%u,%u)", 
									siu.strUserIP, uint(siu.userIP.s_addr), siu.userName, uint(siu.rTime), uint(siu.userID), siu.detachConnection, uint(siu.dropTime));
	}								
		else
		{
			snprintf (sqlStr, BUFFER_SIZE , "UPDATE userIP SET IPstr=\"%s\",IPaddr=%u,UserName=\"%s\",registrationTime=%u,userID=%u,detachConnection=%u,dropTime=%u WHERE IPaddr=%d", 
								siu.strUserIP, siu.userIP.s_addr, siu.userName, uint(siu.rTime), uint(siu.userID), siu.detachConnection, uint(siu.dropTime),
								siu.userIP.s_addr);
		}
		
		
		if (mysql_query(&mysql, sqlStr) != 0)
		{
			saveLog(true, "insert or update into userIP error - %s\n", mysql_error(&mysql));
			saveLog(true, ">%s\n", sqlStr);
						//pthread_mutex_unlock(&sql_mutex);
			return false;
		}
		if (mysql_affected_rows(&mysql) < 0)
		{
			saveLog(true, "mysql_affected_rows error - %s\n", mysql_error(&mysql));
						//pthread_mutex_unlock(&sql_mutex);
			return false;
		}

						//pthread_mutex_unlock(&sql_mutex);
	return true;	
}

bool mySqlSave::locReadIPinMySQL(SIdentUser &siu, struct in_addr getIPaddr)
{
				//pthread_mutex_lock(&sql_mutex);

	char sqlStr[BUFFER_SIZE];
	//bool lineExixt = false;
	snprintf (sqlStr, BUFFER_SIZE , "SELECT IPstr,IPaddr,userName,registrationTime,userID,detachConnection,dropTime FROM userIP	WHERE IPaddr=%d", 
									getIPaddr.s_addr);
  if (mysql_query(&mysql,sqlStr))
  {
		saveLog(true, "select IP from userIP error - %s\n", mysql_error(&mysql));
						//pthread_mutex_unlock(&sql_mutex);
    return false;
  }
  if (!(res = mysql_store_result(&mysql)))
  {
		saveLog(true, "store result from userIP error - %s\n", mysql_error(&mysql));
						//pthread_mutex_unlock(&sql_mutex);
   return false;
  }
  uint i;//, structCount = 0;
  while((row = mysql_fetch_row(res))) 
  {
    for (i=0 ; i < mysql_num_fields(res); i++)
    {
      //printf("%s\n",row[i]);
      switch (i)
      {
				case 0: strncpy (siu.strUserIP, row[i], 18);
					break;
				case 1: siu.userIP.s_addr = atoi(row[i]);
					break;
				case 2: strncpy (siu.userName, row[i], 256);
					break;
				case 3: siu.rTime = atoi(row[i]);
					break;
				case 4: siu.userID = atoi(row[i]);
					break;
				case 5: siu.detachConnection = atoi(row[i]);
					break;
				case 6: siu.dropTime = atoi(row[i]);
					break;
      }
    }
  }
      
  if (!mysql_eof(res))
  {
		saveLog(true, "not end of row - %s\n", mysql_error(&mysql));
						//pthread_mutex_unlock(&sql_mutex);
		return false;
  }

 	mysql_free_result(res); 
 	
						//pthread_mutex_unlock(&sql_mutex);
	return true;	
}

	bool mySqlSave::saveToMySQL(SUserData &sud, uint month, uint year)
	{
		bool finish;
		uint count = 0;
		do
		{
			finish = locSaveToMySQL(sud, month, year);
			if (!finish) myReconnect();
			count ++;
		} while ((!finish) && (count < numTry));
		return finish;
	}
	bool mySqlSave::readFromMySQL(SUserData &sud, char *userName, uint month, uint year)
	{
		bool finish;
		uint count = 0;
		do
		{
			finish = locReadFromMySQL(sud, userName, month, year);
			if (!finish) myReconnect();
			count ++;
		} while ((!finish) && (count < numTry));
		return finish;
	}
	bool mySqlSave::readLustTimeFromMySQL(time_t &MySQLupdateTime, char *userName, uint month, uint year)
	{
		bool finish;
		uint count = 0;
		do
		{
			finish = locReadLustTimeFromMySQL(MySQLupdateTime, userName, month, year);
			if (!finish) myReconnect();
			count ++;
		} while ((!finish) && (count < numTry));
		return finish;
	}
	bool mySqlSave::saveIPinMySQL(SIdentUser &siu)
	{
		bool finish;
		uint count = 0;
		do
		{
			finish = locSaveIPinMySQL(siu);
			if (!finish) myReconnect();
			count ++;
		} while ((!finish) && (count < numTry));
		return finish;
	}
	bool mySqlSave::readIPinMySQL(SIdentUser &siu, struct in_addr getIPaddr)
	{
		bool finish;
		uint count = 0;
		do
		{
			finish = locReadIPinMySQL(siu, getIPaddr);
			if (!finish) 
				myReconnect();
			count ++;
		} while ((!finish) && (count < numTry));
		return finish;
	}
// Local Variables:
// mode:C++
// End:
