#ifndef _SQUID_SAVETOMUSQL_H
#define _SQUID_SAVETOMUSQL_H

#include <vector>
#include <string>

#include <mysql.h>

#include "mydata.h"

using std::string;
using std::vector;
using std::iterator;

class mySqlSave
{
private:
	MYSQL mysql;
	MYSQL_RES *res;
	MYSQL_ROW row;

	char host [255];
	unsigned int port;
	char username [255];
	char password [255];
	char database [255];
	//pthread_mutex_t sql_mutex;
	bool locSaveToMySQL(SUserData &sud, uint month, uint year);
	//bool updateIntoMySQL(SUserData &sud, uint month, uint year);
	//bool insertIntoMySQL(SUserData &sud, uint month, uint year);
	bool locReadFromMySQL(SUserData &sud, char *userName, uint month, uint year);
	bool locReadLustTimeFromMySQL(time_t &MySQLupdateTime, char *userName, uint month, uint year);
	
	bool locSaveIPinMySQL(SIdentUser &siu);
	bool locReadIPinMySQL(SIdentUser &siu, struct in_addr getIPaddr);

public:
	mySqlSave();
	~mySqlSave();
	bool myReconnect();
	
	bool myConnect(ServerInfo si);
	bool myDisConnect();
	bool saveToMySQL(SUserData &sud, uint month, uint year);
	//bool updateIntoMySQL(SUserData &sud, uint month, uint year);
	//bool insertIntoMySQL(SUserData &sud, uint month, uint year);
	bool readFromMySQL(SUserData &sud, char *userName, uint month, uint year);
	bool readLustTimeFromMySQL(time_t &MySQLupdateTime, char *userName, uint month, uint year);
	
	bool saveIPinMySQL(SIdentUser &siu);
	bool readIPinMySQL(SIdentUser &siu, struct in_addr getIPaddr);

	bool myTest();
};

#endif /*_SQUID_SAVETOMUSQL_H*/ 
